/**
 * Save bookmark dialog
 * 
 * arguments[0] context
 * arguments[1] Bookmark
 * arguments[2] moreOptions {listId: , tags: [], unread: true} 
 */
var mainWindow = window.opener;
var D = mainWindow.diigo;

//gContext is provided when bookmarking current page
//gContext is null when bookmarking a link (right-click menu)
var gContext = window.arguments[0];
var bm = window.arguments[1] || gContext.bookmark;
var moreOptions = window.arguments[2] || {};
var image=null;//bm.image;
var editing = null;//bm.saved;
var tempBm=bm;

var lastUsedTag=[];

var autoCompleteTags = [];

function onload() {

	if (editing) document.title = $('#dlg_diigotb-addBookmark').attr('editTitle');
	
	if(!D.ff3up||D.ff3up==null){
		$('#check-upload').hide();
	}else{
		$('#check-upload').show();
	}	
	
	updateBmInfo(bm);
//	if(image){
//		$('#select-bm-type')[0].selectedIndex=1;
//		setTimeout(function(){
//			openBmImageType();
//		},50);
//	}
	
	//hide Save & Forward if gContext is not available because the share window relies on gContext
	if (!gContext||gContext==null)
		$('#btn-saveAndForward').attr('hidden', true);
	
	//tag suggestion
	autoCompleteTags = [].slice.call(D.env.myTags, 0); 
	
	showLastUsedTags();
	
	populateGroupSelection();
	
	//group option event
	$('#check-shareToGroup, #select-shareToGroup').bind('command', showGroupTags);
	
	//should call initOptionTabs before populateListSelection so that populateListSelection may expand the options panel
	initOptionTabs();
	
	populateListSelection();
	
	adjustSize();
	
	catchTheLinks();
	
	setTimeout(function() { $('#txt-tags')[0].focus(); }, 100);
	
	new SelfEvidentTextBox('#txt-groupComment',"Add a Group Comment");
	new SelfEvidentTextBox('#txt-list-title',"Input Outliner Title");
	//show fanfou for me
	if (D.prefs.val('bookmark.fanfou')) {
		//$('#check-fanfou').removeAttr('hidden');
	}
	
	if(!D.env.bShrinkShare||D.env.bShrinkShare==null){
		clickMoreOptions($('.moreOptions')[0]);
	}
	
	if(!D.env.permissions.snapshot||D.env.permissions.snapshot==null){
		$('#check-upload').attr({
			'tooltiptext':'Premium feature ~ please upgrade.  Enable the page to be uploaded & saved ',
			'disabled':true});
	}
}

function updateBmInfo(bookmark){
	
	dataToUI(bookmark);
	
	// if bookmarkInfo not loaded
	if (gContext && bookmark.saved && !gContext.bookmarkInfoLoaded) {
		$('#box-loadingBookmarkInfo')[0].hidden = false;
		D.WebAPI.loadBookmark({url: bookmark.url, what: 'bookmarkInfo'}, gContext, function() {
			$('#box-loadingBookmarkInfo')[0].hidden = true;
			dataToUI(bookmark);
			syncTags(); //at this time, recommended tags may not be loaded, but never mind
		});
	} else {
		$('#box-loadingBookmarkInfo')[0].hidden = true;
	}
	
	//selected text as description
	var s = mainWindow.content.getSelection().toString();
	if (!bookmark.description && s){
		if(diigoUtil.string.trim(s).length>0){
			s="\""+s+"\"";
		}
		$('#txt-desc').val(s);
	}
	
	if (gContext && gContext.recommendedTagsLoaded) {
		showRecommendedTags(gContext.recommendedTags);
	} else {
		D.WebAPI.loadRecommendedTags(bookmark.url, bookmark.getTitle(), gContext, function(data) {
			showRecommendedTags(data.tags);
		});
	}

}

function openBmUrlType(){
	$('#bm-url').show();
	$('#bm-image').hide();
	$('#check-unread').show();
	$('#check-upload').show();
	$('#btn-saveAndForward').attr('hidden', false);
	bm=tempBm;
	updateBmInfo(bm);
	adjustSize();
}

function openBmImageType(){
	$('#bm-url').hide();
	$('#bm-image').show();
	$('#check-unread').hide();
	$('#check-upload').hide();
	$('#btn-saveAndForward').attr('hidden', true);
	adjustSize();
	
	function i(img){ 
		//var w=img.width/200;
		var h,zoom;
		if(img.height>150){
			h=150;
			zoom=img.height/150;
		}else{
			h=img.height;
			zoom=1;
		}
		var w=img.width/zoom;
//		var zoomLevel=w;
//		h=img.height;
//		w=img.width;
//		if(zoomLevel>1){
//			h=img.height/zoomLevel;
//			w=img.width/zoomLevel;
//		}
		$('#bm-image-preview').height(h);
		$('#bm-image-preview').width(w);
		
		var url=img.src;
		$('#bm-image-preview').attr('src',url);
		
		var title=img.alt;
		if(title.length>28){
			title=title.substr(0,28)+"...";
		}

		if(title.length>0){
			$('#diigotb-image-alt').text(title).show();
			$('#txt-title').val(title);
			bm.title=title;
		}else{
			$('#diigotb-image-alt').text('').hide();
			$('#txt-title').val(title);
			bm.title='';
		}
		
		$('#bm-image-preview').attr('dtype','');
		$('#bm-image-preview').attr('dname','');
		if(img._type=="capture"){
			$('#diigotb-image-type').val("Type: PNG");
			$('#bm-image-preview').attr('dtype',"png");
		}else{
			url=url.replace(/\?.*/ig,"");
				var ft=url.replace(/(.*\/){0,}([^.]+)\.+/ig,"");
				if(ft&&ft.length==3){
					$('#diigotb-image-type').val("Type: "+ft);
					$('#bm-image-preview').attr('dtype',ft);
				}
				var fn=url.replace(/(.*\/){0,}([^.]+).*/ig,"$2");//([^.]+).*
				if(fn.length>0){
					$('#bm-image-preview').attr('dname',fn);
				}
		}
		
		var obj=D.upload.ReadfileByURL(url,true);
		var bytes=obj.n.toString(10);
		var strBytes="";
		if(bytes.length<=3)
			strBytes=bytes;
		else{
			var n1=bytes.length%3;
			if(n1==0)n1=3;
			strBytes+=bytes.substr(0,n1);
			for(var j=n1;j<bytes.length;j+=3){
				strBytes+=","+bytes.substr(j,3);
			}
		}
		$('#diigotb-image-size').val("size: "+strBytes+" Bytes");

		var offset={left:0,top:0};
		if(image===img){
			if(image.left&&image.left!=null){
				offset.left=image.left;
				offset.top=image.top;				
			}else{
				offset=bm.context.$(image).offset();
			}
		}else{
			offset=bm.context.$(img).offset();
			img.left=offset.left;
			img.top=offset.top;
		}
		
		$('#bm-image-preview').attr('durl',url);
		$('#bm-image-preview').attr('dleft',offset.left);
		$('#bm-image-preview').attr('dtop',offset.top);
		
		$('#diigotb-image-dimension').val("Dimension: "+img.width+"x"+img.height);
		image=img;
		updateBmInfo(bm);
	}
	
	if(bm.context&&bm.context!=null){
		doc=D.getCurrentContext().doc;
		
		lists=$.grep(doc.images,function(item){
			if(item.width>160&&item.height>120)
				return true;
			return false;
		});

		lists.sort(function(a,b){
			sqA=a.width*a.height;
			sqB=b.width*b.height;
			return sqA>sqB?-1:1;
		});
		bm = D.handle('getImageBookmark', tempBm.url);

		if(image&&image!=null){
			lists.splice(0,1,image);
			//i(image);
		}

		var index=0;
		if(lists.length>0){
			i(lists[index]);
			
			$('.prebtn').click(function(){
				index--;
				if(index>=lists.length||index<0)
					index=lists.length-1;
				i(lists[index]);
			});
			$('.nextbtn').click(function(){
				index++;
				if(index>=lists.length||index<0)
					index=0;
					
				i(lists[index]);
			});
		}else{
			$('#diigotb-image-alt').val("no image").show();
			$('#diigotb-image-type').hide();
			$('#diigotb-image-dimension').hide();
		}
	} 
	//if(!image){
		
	//}
		
}
/**
 * Update the group tag dictionary
 * 
 */
function showGroupTags() {
	var jLoading = $('#box-loadingGroupTags');
	var jTags = $("#box-groupTags");
	
	var groupName = null;

	if ($('#check-shareToGroup').is(':checked')) {
		var value = $('#select-shareToGroup')[0].value;
		if (value != -1)
			groupName = value;
	}
	
	if (groupName) {
		//always reload to ensure we get the lastest 2007-12-22 15:27:11 UTC
		if (false && D.env.groupTagsDict[groupName]) {
			f(D.env.groupTagsDict[groupName]);
		} else {
			//do not show the annoying loading 2008-01-20 18:31:49 UTC
			//jLoading.attr('hidden', false);
			D.WebAPI.loadGroupTagsDictionary(
				[groupName],
				function() {f(D.env.groupTagsDict[groupName]);}
			);
		}
	} else {
		jLoading.attr('hidden', true);
		jTags.removeClass('recommended');
		jTags.attr('hidden', true);
		adjustSize();
	}
	
	function f (tags) {
		jLoading.attr('hidden', true);
		tags = tags || [];
		
		if (tags.length > 0) {
			var j = jTags.addClass('recommended')
			.removeAttr('hidden')[0];//.childNodes[1]
			$(j).children(".tagButton").remove();
			j = jTags;
			
			//build tag button elements
			tags.forEach(function(tag, i) {
				$(diigoUtil.dom.buildOne('label', {
					'class': 'tagButton ' + (D.env.myTags.indexOf(tag) > -1 ? 'my' : ''),
					id: 'groupTag_' + escapeTagForElementId(tag),
					value: tag,
					crop: 'end'
				})).appendTo(j);
			});
			
			//hook tag button click event
			j.unbind('click').click(function(event) {
				var t = $(event.target);
				if (t.is('.tagButton')) {
					toggleTag(t.val(), !t.is('.selected'));
				}
			});
			
			syncTags();
		} else {
			jTags.removeClass('recommended');
			jTags.attr('hidden', true);
		}
		
		adjustSize();
	};
}

/**
 * called by the autocomplete XBL
 */
function getSuggestedTags(input) {
	var tags = D.parseTags(input);
	var lastTag = tags[tags.length - 1];
	if (!lastTag) return [];
	
	lastTag = lastTag.toLowerCase();
	return diigoUtil.array.unique(
			   autoCompleteTags
			   .filter(function(t) {return t.toLowerCase().indexOf(lastTag) == 0;})
		   ).map(function(t) {return {tag: t}});
}

function EditTag(h) {
	D.utils.firefox.openTab(D.urls.getEditTagsURL()+"&q="+h); 
	mainWindow.focus();
}

/**
 * Add to groups
 * Add to lists
 * Share with friends
 */
function initOptionTabs() {
	var j = $('#box-options');
	//hide initially
	j.find('.optionPanel').attr({hidden: true});
	
	var checkboxes = j.find('checkbox.optionTab');
	checkboxes.click(function() {
		var t = $(this);
		panel=$(t.attr('relatedTarget'));//.next('.optionPanel');
		panel.attr({hidden: !t.is(':checked')});
		
		//desc=$('#txt-desc').val();
		//if(desc.length>0)
		//	panel.find('#txt-groupComment').val(desc).removeClass('tip');

		adjustSize();
	});
}

//share to a group dropdown select
function populateGroupSelection() {
	var j = $('#select-shareToGroup menupopup').empty();
	j=j.append(diigoUtil.dom.buildOne('menuitem', {
		'label': new Array(20).join('-'),
		value: -1 
	}));
	j=j.append(D.env.myGroups.map(function(g) {
		return diigoUtil.dom.buildOne('menuitem', {
			'label': g.displayName + (bm.inGroup(g.name, D.env.user) ? '(shared)' : ''),
			value: g.name 
		});
	}));
	//--------------------
	j[0].appendChild(document.createElement('menuseparator'));
	//Create a Group
	j[0].appendChild(diigoUtil.dom.buildOne('menuitem', {
		'label': 'Create a Group...',
		value: "",
		'onclick': 'D.utils.firefox.openTab(D.urls.getCreateGroupURL()); var p = this.parentNode.parentNode; setTimeout(function() {p.selectedIndex = 0;}, 200);'
	}));
	
	var j = j.parent();
	j[0].selectedIndex = 0;
	
	var lastSelectedGroup = D.prefs.val('bookmark.selectedGroup');
	
	if (lastSelectedGroup) {
		j[0].value = lastSelectedGroup;
	}
	
	j.parent()[0].selectedIndex = 0;
	
	//hide "share existing annotations" when there is none
	if (!gContext || (gContext.annotations.length == 0 && !bm.fileUploaded))
		$('#check-shareExistingAnnotations').hide();
	
}

function checkUploadable(){
	if(!D.isURIUploadable(bm.url)&&!$('#check-upload').is(":checked")){
//		if(!D.prefs.val(D.env.user+'.dontShowNoticeHttps')){
//			var res={doit:false};
//			openDialog('chrome://diigotb/content/NoticeHttps.xul', '', 'centerscreen,modal',res).focus();
//			if(!res.doit){
//				$('#check-upload').attr({checked:true});
//			}
//		}
	}else if(D.isPDFPage(bm)){

	}
}

//add to a list dropdown select
function populateListSelection() {
	var j = $('#select-addToList menupopup');
	j.empty()
	//--------------------
	.append(diigoUtil.dom.buildOne('menuitem', {
		'label': new Array(20).join('-'),
		value: -1 
	}))
	.append(D.env.outliners.map(function(li) {
		return diigoUtil.dom.buildOne('menuitem', {
			'label': li.title + (bm.inList(li) ? '(added)' : ''),
			value: li.id 
		});
	}))
	//--------------------
	.append(document.createElement('menuseparator'))
	.append(D.env.myList.map(function(li) {
		return diigoUtil.dom.buildOne('menuitem', {
			'label': li.title + (bm.inList(li) ? '(added)' : ''),
			value: li.id 
		});
	}))
	//--------------------
	.append(document.createElement('menuseparator'))
	//Create a List
	.append(diigoUtil.dom.buildOne('menuitem', {
		'label': 'Create an Outliner...',
		value: -1,
		'onclick': 'ShowCreateList(); var p = this.parentNode.parentNode; setTimeout(function() {p.selectedIndex = 0;}, 200);'
		//'onclick': 'D.handle("OnCreateList", event, populateListSelection); var p = this.parentNode.parentNode; setTimeout(function() {p.selectedIndex = 0;}, 200);'
	}));
	
	var j = j.parent();
	j[0].selectedIndex = 0;
	
	var lastSelectedList = D.prefs.val('bookmark.selectedList');
	if (lastSelectedList) {
		j[0].value = lastSelectedList;
	}
	
	//more options
	if (moreOptions.listId) {
		//var jj = $('#check-addToList');
		
		//trigger('click') also changes .checked, but it's not right. so I set checked by force
		//jj[0].checked = true;
		//jj.trigger('click');
		//jj[0].checked = true;
		
		j[0].value = moreOptions.listId;
	}
	
	//hide "add to list" when there is nothing in there
//	if (D.env.myBookmarkLists.length == 0)
//		$('#box-addToList').hide();
	
}

function clickMoreOptions(This){
	$(This).toggleClass('opened');
	if($(This).is('.opened')){
		$('#box-options').show();
		D.env.bShrinkShare=false;
	}else{
		$('#box-options').hide();
		D.env.bShrinkShare=true;
	}
	adjustSize();
}

function networkCreateAList(){
	var title=$('#txt-list-title')[0].getValue();
	if(diigoUtil.string.trim(title).length<=0){
		alert('Title can\'t be empty.');
		return;
	}
	var res={
		title:title,
		mode:2
	};
	$('.CreateListPanel').hide();
	$('.CreatingListPanel').show();
	D.WebAPI.CreateOneList(res,function(data){
		if(data&&data!=null&&data.list&&data.list.id)
			moreOptions.listId=data.list.id;
		populateListSelection();
		$('.CreateListPanel').hide();
		$('.CreatingListPanel').hide();
		$('#select-addToList').show();
		$('.NeedUpgrade').hide();
	});
}

function ShowCreateList(){
	$('#select-addToList').hide();
	if(D.env.permissions.createOutliner){
		$('.CreateListPanel').show();
	}else{
		$('.NeedUpgrade').show();
	}
	
//	$('#txt-list-title').val('');
}

function upgradeAccount(){
	D.handle('upgrade');
	window.close();
}

function cancelList(){
	$('.CreateListPanel').hide();
	$('.NeedUpgrade').hide();
	$('#select-addToList').show();
}

/**
 * Ajust window size to fit content
 */
function adjustSize() {
	var box = $('vbox:first')[0].boxObject;
	var preferedHeight = box.y + box.height, 
		preferedWidth = box.x + box.width;
	
	window.innerHeight = preferedHeight;
	//window.innerWidth = preferedWidth;
}

function SelectAllTags(id){
	var tTag = $('#txt-tags');
	var inputTags = D.parseTags(tTag.val());
	var newTag=[];
	
	var j = $("#"+id);
	$(j).children(".tagButton").each(function(i,item) {
		tag=item.value;
		
		var i = inputTags.indexOf(tag);
		if (i > -1) {
			inputTags.splice(i, 1);
		}
		newTag.push(tag);
		
		//D.utils.dump('[bookmark] select:', tag);
		
		$('#lastTag_' + escapeTagForElementId(tag)).addClass('selected');
		$('#tag_' + escapeTagForElementId(tag)).addClass('selected');
		$('#groupTag_' + escapeTagForElementId(tag)).addClass('selected');
	});
	
	//D.utils.dump('[bookmark] select all', D.unparseTags($.merge(inputTags,newTag)));
	
	tTag.val(D.unparseTags($.merge(inputTags,newTag))).focus();
}

function showLastUsedTags() {
	
	lastUsedTag=[];
	try{
		lastUsedTag=D.utils.json.parseJSON(decodeURIComponent(D.prefs.val('bookmark.tags')));
	}catch(e){throw e;}
	
	if(lastUsedTag.length>0){
		j = $("#box-lastTags").addClass('recommended')
		.removeAttr('hidden')[0];//.childNodes[1];
		//in firefox 3 $().find('div') cannot find html element in xul elements
		$(j).children(".tagButton").remove();
		j = $("#box-lastTags");
		
		lastUsedTag.forEach(function(tag, i) {
			$(diigoUtil.dom.buildOne('label', {
				'class': 'tagButton ' + (D.env.myTags.indexOf(tag) > -1 ? 'my' : ''),
				id: 'lastTag_' + escapeTagForElementId(tag),
				value: tag,
				crop: 'end'
			})).appendTo(j);
		});
		
		j.unbind('click').click(function(event) {
			var t = $(event.target);
			if (t.is('.tagButton')) {
				toggleTag(t.val(), !t.is('.selected'));
			}
		});
	}else{
		j = $("#box-lastTags").removeClass('recommended')
	}
}

function showRecommendedTags(tags) {
	//hide loading...
	$('#box-loadingRecommendedTags').hide();
	
	//NOTICE modify argument?
	//if (tags.length == 0) tags = bm.tags;
	
	if (tags.length > 0){
		j = $("#box-recommendedTags").addClass('recommended')
		.removeAttr('hidden')[0];//.childNodes[0];
		//in firefox 3 $().find('div') cannot find html element in xul elements
		$(j).children(".tagButton").remove();
		j = $("#box-recommendedTags");//[0].childNodes[0];
		
		tags.forEach(function(tag, i) {
			$(diigoUtil.dom.buildOne('label', {
				'class': 'tagButton ' + (D.env.myTags.indexOf(tag) > -1 ? 'my' : ''),
				id: 'tag_' + escapeTagForElementId(tag),
				value: tag,
				crop: 'end'
			})).appendTo(j);
		});
		
		j.unbind('click').click(function(event) {
			var t = $(event.target);
			if (t.is('.tagButton')) {
				toggleTag(t.val(), !t.is('.selected'));
			}
		});
	}else{
		j = $("#box-recommendedTags").removeClass('recommended')
	}
	
	
	adjustSize();
	syncTags();
}

/**
 * FIXME
 * Update recommended tags buttons according to tag textbox input
 */
function syncTags() {
	var inputTags = D.parseTags($('#txt-tags').val());
	
	//on
	inputTags.forEach(function(t) {
		toggleTag(t, true);
	});
	
	//off
	$('.tagButton.selected').each(function() {
		var t = $(this).val();
		if (inputTags.indexOf(t) == -1) toggleTag(t, false);
	});
}

//update tag textbox
function toggleTag(tag, on) {
//	D.utils.dump('toggleTag', tag, on);
	$('#tag_' + escapeTagForElementId(tag)).toggleClass('selected', !!on);
	$('#groupTag_' + escapeTagForElementId(tag)).toggleClass('selected', !!on);
	$('#lastTag_' + escapeTagForElementId(tag)).toggleClass('selected', !!on);
	
	var inputChanged = false; //whether this call to toggleTag need to change tag input
	var j = $('#txt-tags');
	var inputTags = D.parseTags(j.val());
	
	var i = inputTags.indexOf(tag);
	if (on) {
		if (i == -1) {
			inputTags.push(tag);
			inputChanged = true;
		}
	} else if (i > -1) {
		inputTags.splice(i, 1);
		inputChanged = true;	
	}
	
	// add a space and focus, the caret will be at the end
	// so that the user can continue typing
	// do not update the text input if toggleTag doesn't change tag input. this also avoids adding space to the end of input when recommended tags finish loading
	if (inputChanged) {
  	j.val(D.unparseTags(inputTags) + ' ').focus();
  }
}

//function toggleTag(tag, on) {
//	$('#tag_' + escapeTagForElementId(tag)).toggleClass('selected', !!on);
//	
//	var j = $('#txt-tags');
//	var inputTags = j.val();
//	
//	var quoted = quoteTag(tag);
//	if (on) {
//		if (inputTags.indexOf(quoted) == -1) {
//			inputTags = inputTags.replace(/\s*$/, ' ').replace(/^\s+/, '')
//			 + quoted;	
//		}
//	} else {
//		inputTags = inputTags.replace(new RegExp('\\s*' + diigoUtil.string.escapeRegexp(quoted) + '\\s*'), ' ').replace(/^\s+|\s+$/g, '');	
//	}
//	j.val(inputTags);
//}

function onEditUrl(){
	$('#bm-url-label').hide();
	$('#txt-url').show();
}


function dataToUI(bm) {
	//private by default?
	if (!bm.saved && !bm.privacyModeSetByUser)
		bm.mode = D.prefs.val('bookmark.privateByDefault') ? D.PRIVACY_MODE_PRIVATE : D.PRIVACY_MODE_PUBLIC;
	
	$('#txt-url').val(bm.url);
	var url=bm.url;
	if(url.length>40){
		url=url.substr(0,40);
		url+='...';
	}
	$('#bm-url-label').val(url);
	
//	if($('#select-bm-type')[0].selectedIndex==0){
	$('#txt-title').val(bm.getTitle());
//	}
	
	$('#txt-tags').val(D.unparseTags(diigoUtil.array.unique(bm.tags.concat(moreOptions.tags || []))));
	$('#txt-desc').val(bm.description);
	
	$('#check-private').attr({checked: bm.isPrivate()});
	$('#check-unread').attr({checked: ('unread' in moreOptions) ? moreOptions.unread : bm.unread});
	$('#check-alert').attr({checked: bm.alert});
	//$('#check-bookmarkElsewhere').attr({checked: D.prefs.val('bookmark.bookmarkElsewhere') || false});
	
	//already shared to groups
	var j = $('#box-sharedGroups').hide();
	if (bm.groups && bm.groups.length > 0) {
		j.find('.alreadyIn')
		 .empty()
		 .append(
		 	bm.groups.map(
		 		function(g) {
			 		return diigoUtil.dom.buildOne('label', {
			 			value: g.displayName, 
			 			'class': "link",
			 			href: D.urls.getGroupURL(g.name)
			 		});
			 	}
		 	)
		 );
		 
		j.show();
	}
	
	//already added to lists
	$('#box-list-space').hide();
	var j = $('#box-lists').hide();
	if (bm.lists && bm.lists.length > 0) {
		j.find('.alreadyIn')
		 .empty()
		 .append(bm.lists.map(function(li) {
		 	if(li.uri.indexOf('https://')>=0){
		 		return diigoUtil.dom.buildOne('label', {value: li.title, 'class': "link", href: li.uri})
		 	}
		 	return diigoUtil.dom.buildOne('label', {value: li.title, 'class': "link", href: D.urls.getListURL(li.uri)});
		 }));
		
		j.show();
		$('#box-list-space').show();
	}
}

function UIToData(bm) {
	var tags = D.parseTags($('#txt-tags').val(), true);
	if (tags.length > 20) {
		alert('You can input at most 20 tags.');
		return false;
	}
	
	var url = diigoUtil.string.strip($('#txt-url').val());
	if (!url) {
		alert('Please input a valid URL.');
		return false;
	}
	
	var title = diigoUtil.string.strip($('#txt-title').val());
	if (!title) {
		alert('Please input title.');
		return false;
	}
	
	diigoUtil.extend(bm, {
		url: $('#txt-url').val(),
		tags: tags,
		mode: $('#check-private').is(':checked') ? D.PRIVACY_MODE_PRIVATE : D.PRIVACY_MODE_PUBLIC,
		unread: $('#check-unread').is(':checked'),
		alert: $('#check-alert').is(':checked')
	});
	
	if(image&&image!=null){
		diigoUtil.extend(bm, {
			image_title: title,
			image_description: $('#txt-desc').val()
		});		
	}else{
		diigoUtil.extend(bm, {
			title: title,
			description: $('#txt-desc').val()
		});				
	}
	
	//group
	if ($('#check-shareToGroup').is(':checked')) {
		var value = $('#select-shareToGroup')[0].value;
		if (value != -1) {
			bm.toShareToGroups = [value];
			//remember last selected group
			D.prefs.val('bookmark.selectedGroup', value);
			bm.toShareExistingAnnotations = $('#check-shareExistingAnnotations').is(':checked');
			
			//group comment
			var t = diigoUtil.string.strip($('#txt-groupComment')[0].getValue());
			if (t) {
				bm.toAddGroupComment = t;
				//remember to delete the temp prop later
			}
		}
	}
	
	//list
	//if ($('#check-addToList').is(':checked')) {
		var value = $('#select-addToList')[0].value;
		if (value != -1) {
			bm.toAddToLists = [value];
			//remember last selected list
			D.prefs.val('bookmark.selectedList', Number(value));
		}else{
			D.prefs.val('bookmark.selectedList', Number(0));
		}
	//}
		
	bm.privacyModeSetByUser = true;
	return bm;
}

function doOK() {
	if (!UIToData(bm)) return false;
	var moreData = {};
	
	//adding a group comment 
	if (bm.toAddGroupComment) {
		moreData.pageComment = {
			content: bm.toAddGroupComment,
      mode: null,
      groups: bm.toShareToGroups,
      justForGroups: true
		};
		
		//clear the temp property
		delete bm.toAddGroupComment;
	}
	
	var callback=null;
	bm.uploading=$('#check-upload').is(':checked');
	if(bm.uploading){
		D.handle('capturePage', bm);
		
		D.notify(D.strings.getString('upload.processing'),15000);
	}
	
	if(!gContext||gContext==null){
		gContext=D.getCurrentContext();
		bm.context=gContext;
		gContext.__tempBm=bm;
	}
	
//	var isImage=$('#select-bm-type')[0].selectedIndex==1&&image;
//	
//	if(isImage){
//		D.handle('uploadBmImage', bm,{
//			type:image._type?image._type:"image",
//			twitter:$('#check-twitter').is(':checked'),
//			url:$('#bm-image-preview').attr('durl'),
//			dtype:image._type=='capture'?'png':$('#bm-image-preview').attr('dtype'),
//			name:image._type=='capture'?'':$('#bm-image-preview').attr('dname'),
//			extra:{left:$('#bm-image-preview').attr('dleft'),top:$('#bm-image-preview').attr('dtop')}
//		},gContext);
//	}else{
		D.WebAPI.saveBookmark(bm, moreData, gContext);
//	}
	
	if ($('#check-twitter').is(':checked')) {
			D.handle('twitterThis', bm);
		//D.utils.fork((function(D, bm) {return function() {D.TwitterThis.update(bm)};})(D, bm));	
	}
	
	if ($('#check-fanfou').is(':checked')) {
		D.utils.fork((function(D, bm) {return function() {D.TwitterThis.update(bm, true)};})(D, bm));	
	}
	tempBm.image=null;
	return true;
}

function doCancel() {
	tempBm.image=null;
	bm.image=null;
}

function saveAndForward() {
	if (doOK()) {
		D.handle('sendTo',null,null,$('#txt-desc').val());
		bm.image=null;
		window.close();
	}
}

/**
 * Escapes a tag so that it can be used for an element id
 */
function escapeTagForElementId(tag) {
	return encodeURIComponent(tag).replace(/[.%:]/g, '');
}

/**
 * 2008-01-17 15:02:19 UTC
 * This is no longer used because the recommended tags generation has changed
 * 
 * Extract possible tags from document
 * Looks in <meta nama="keywords|description"> and document title
 * title+keywords+descriptions
 * 
 * @return {Array}
 */
//function extractTagsFromDocument(doc) {
//	if (!D.isHTMLDocument(doc)) return [];
//	var tags = diigoUtil.string.split(doc.title, /\s+|[,\uff0c]/);
//	
//	var desc = diigoUtil.toArray(doc.getElementsByTagName('meta'))
//		.filter(function(ele) {
//			return ele.name.toLowerCase() == 'description';
//		})[0];
//	
//	var keywords = diigoUtil.toArray(doc.getElementsByTagName('meta'))
//		.filter(function(ele) {
//			return ele.name.toLowerCase() == 'keywords';
//		})[0];
//	
//	if (keywords) {
//		diigoUtil.array.concatMe(tags, diigoUtil.string.split(keywords.content, /[,\uff0c]/)); //\uff0c is Chinese comma
//	} if (desc) {
//		diigoUtil.array.concatMe(tags, diigoUtil.string.split(desc.content, /\s+|[,\uff0c]/)); //\uff0c is Chinese comma
//	}
//		
//	return diigoUtil.array.unique(tags.map(function(t) {return diigoUtil.string.strip(t);}));
//}

function catchTheLinks() {
	window.addEventListener('click', function(event) {
		//ignore right click
		if (event.button == 2) return;
		
		var t = $(event.target);
		
		//catch a.link
		if (t.is('label.link')) {
			D.utils.firefox.openAndReuseOneTabPerURL(t.attr('href'));
			event.preventDefault();
			event.stopPropagation();
		}
	}, true); 
}

/**
 * Usage: new SelfEvidentTextBox();
 */
function SelfEvidentTextBox(ele, tip) {
	var j = $(ele);
	j[0].tip = tip = tip || j.val();
	j[0].addEventListener('focus', function() {
		if (j.val() == tip) {
			j.removeClass('tip').val('');
		}
	}, true);
	
	j[0].addEventListener('blur', function() {
		if (j.val() == '') {
			j.addClass('tip').val(tip);
		}
	}, true);
	
	j[0].getValue = function() {
		return this.value == tip ? '' : this.value;
	};
}