/**
 * Works with jQuery in HTML (Firefox only) Usage: var jTagInput =
 * $('#bm-search-input-tag'); //tag autosuggestion new AutoComplete(jTagInput, {
 * resultsClass: 'diigolet ac_results', data: D.env.myTags, mode: 'multiple',
 * multipleSeparator: ' ,', });
 */

var AutoComplete = function(input, options) {
	var i = $(input), timeout;

	/**
	 * We store the AutoComplete instance as a property of the input. However,
	 * innerHTML asignment may wipe out the property. There's no way to solve
	 * the wipe out problem.
	 */
	if (i[0].autoCompleter) {
		i[0].autoCompleter.destroy();
	}
	i[0].autoCompleter = this;
	var o = options = $.extend( {
		// Set default values for required options
		inputClass :"ac_input",
		resultsClass :"ac_results",
		minChars :1,
		delay :100,
		matchCase :0,
		matchSubset :1,
		matchContains :0,
		mustMatch :0,
		loadingClass :"ac_loading",
		selectFirst:false,
		selectOnly :false,
		mode :"multiple",
		multipleSeparator :' '
	}, options || {});

	if (typeof o.multipleSeparator == 'string') {
		o.multipleSeparator = o.multipleSeparator.split('');
	}
	
	if(o.data.length>2){
		o.data.sort(function(a, b) {
			a=diigoUtil.string.trim(a.toLowerCase());
			b=diigoUtil.string.trim(b.toLowerCase());
			a0=a[0],a1=a[1];
			if(a0 == "\"" ||a0 == "\'"){
				a0=a[1];
				a1=a[2];
			}
			b0=b[0],b1=b[1];
			if(b0 == "\"" ||b0 == "\'"){
				b0=b[1];
				b1=b[2];
			}
			return (a0 > b0 ? 1 : ((a0 == b0&&a1 > b1)? 1 : -1));
		});
	}
	/**
	 * Returns the last index of any multiple separator
	 */                                     
	function lastIndexOfMultipleSeparator(str) {
		var index = -1, sep = ' ', tail = '';
		arr=D.parseTags(str);
		
		if(arr.length>0){
			tail=arr.pop();
		}
		newarr=D.unparseTags(arr);
		index=newarr.length;
		return [ index, sep ,newarr, tail];
	}

	function onScroll() {
		r.hide();
	}
	function onKeyDown(e) {
		switch (e.keyCode) {
		case 38: // up
			e.preventDefault();
			moveSelect(-1,false);
			break;
		case 9: // tab
		case 40: // down
			e.preventDefault();
			moveSelect(1,false);
			break;
		// case 188: //comma
		case 13: // return
			if (selectItem()) {
				e.stopPropagation();
				e.preventDefault();
				//if (e.keyCode == 13)
				//	i[0].enterOnAutocomplete = true;
			//} else {
			}
			o.onStartSearch();
			r.hide();
			break;
		default:
			active = -1;
			if (timeout)
				clearTimeout(timeout);
			timeout = setTimeout( function() {
				requestData(i.val());
			}, o.delay);
			break;
		}
	}

	function selectItem() {
		if (!r.is(':visible'))
			return false;

		if (active < 0) return false;
		//if (active < 0)
		//	active = 0; // auto select the first one

		var v = r.find('li').eq(active);
		if(v.is(".suggestionEdit")){
			o.onClickEditTag(v.attr("head"));
			return false;
		}else if(v.is(".separater")){
			return false;
		}
		v=v.html();
		if(/\s+/.test(v)){
			v="\""+v+"\"";
		}

		if (o.mode == "multiple") {
			var old_value = i.val();
			var sep = lastIndexOfMultipleSeparator(old_value);
			if (sep[0] >= 1) {
				var value = sep[2]+sep[1];
				new_value = value + v + sep[1];
			} else {
				new_value = v;// + o.multipleSeparator;
			}
		} else {
			new_value = v;
		}
		i.val(new_value);

		//r.hide();

		// NOTICE: stupid IE! I have to setTimeout
		setTimeout( function() {
			i[0].focus();
			// set caret position to the end. need for IE and safari
				( function(ele, pos) {
					// if(ele.createTextRange) {
					// /* Create a TextRange, set the internal pointer to
					// a specified position and show the cursor at this
					// position
					// */
					// var range = ele.createTextRange();
					// range.move("character", pos);
					// range.select();
					// } else
					// 
					if (ele.selectionStart >= 0) {
						/*
						 * Gecko is a little bit shorter on that. Simply focus
						 * the element and set the selection to a specified
						 * position
						 */
						ele.focus();
						ele.setSelectionRange(pos, pos);
					}
				})(i[0], i.val().length);
			}, 13);

		return true;
	}

	function moveSelect(step,mouse) {
		var lis = r.find('li');
		if (lis.size() == 0)
			return;

		active += step;

		if (active < 0) {
			active = lis.size() - 1;
		} else if (active >= lis.size()) {
			active = 0;
		}

		cur=lis.removeClass("over").eq(active);
		
		if(cur.attr('class')=='tag'&&!mouse)
			selectItem();
		
		cur.addClass('over');
		cur[0].scrollIntoView(false);

		// Weird behaviour in IE
		// if (lis[active] && lis[active].scrollIntoView) {
		// lis[active].scrollIntoView(false);
		// }

	}

	function requestData(q) {
		if (o.mode == "multiple") {
			var sep = lastIndexOfMultipleSeparator(q);
			if (sep[0] > 0) {
				q = $.trim(sep[3]);
			}
		}
		if (q.length < o.minChars) {
			r.hide();
			return;
		}
		// 2007-07-22 15:01:55 UTC Arrix: we don't use $.map here because it's
		// slow
		// pistos was totally crazy about the performance issue
		// http://groups.diigo.com/Diigo_HQ/forum/topic/1017
		var q = q.toLowerCase();
		if(q[0]=='\"'||q[0]=='\''){
			q=q.substr(1);
		}
		var candidates = [];
		var finded=false;
		for ( var i = 0, v; v = o.data[i], i < o.data.length; i++) {
			if (v.toLowerCase().indexOf(q) == 0) {
				candidates.push(v);
				finded=true;
			}else{
				if(finded)
					break;
			}
		}
		receiveData(q, candidates);
	}

	function receiveData(q, data) {
		if (data && data.length > 0) {
			// if (data.length > 10) {
			// //NOTICE: Stupid IE. If the second arg is missing, IE and Opera
			// won't do anything
			// data.splice(9, 99999);
			// }
			// Set default values for results
			function findPos(obj) {
				var curleft = obj.offsetLeft || 0;
				var curtop = obj.offsetTop || 0;
				while (obj = obj.offsetParent) {
					curleft += obj.offsetLeft;
					curtop += obj.offsetTop;
				}
				var t = 0, l = 0;
				//				
				return {
					x :curleft + l,
					y :curtop + t
				};
			}
			var pos = findPos(i[0]);

			// unbind all events on lis
			r.find('li').unbind();
			rhtml=$.map(data, function(v) {
				return '<li class=\"tag\">' + v + '</li>';
			}).join('');
			rhtml+="<li class=\"separater\" disabled=\"disabled\">-----------------</li>";
			rhtml+="<li head=\""+encodeURIComponent(q)+"\" class=\"suggestionEdit\">Edit these tags</li>";
			
			r.find('ul').html(rhtml).end().css( {
				top :pos.y + i[0].offsetHeight,
				left :pos.x
			}).show();

			r.find('li').filter(function(){
				return $(this).attr('class')=='tag';
			}).mouseover( function(e) {
				active = r.find('li').removeClass("over").index(e.target);
				var cur=$(e.target);
				cur.addClass('over');
				//e.target.scrollIntoView(false);
				//moveSelect(0,true);
			}).mousedown( function(e) {
				active = r.find('li').removeClass("over").index(e.target);
				var cur=$(e.target);
				cur.addClass('over');
				selectItem();
				r.hide();
				return false;
			});
			
			r.find('.suggestionEdit').mouseover( function(e) {
				active = -1;
			}).mousedown(function(e) {
				o.onClickEditTag($(this).attr("head"));
				r.hide();
				return false;
			});
			
			r.find("li").eq(0)[0].scrollIntoView(false);
			

			// select the first item by default
			if (o.selectFirst)
				moveSelect(1,true);
		} else {
			r.hide();
		}
	}

	function onBlur(e) {
		r.hide();
	}

	this.destroy = function() {
		i.unbind('keydown', onKeyDown).unbind('blur', onBlur);
		// r.remove();
		// if (!$.browser.supportPositionFixed) {
		$(window).unbind('scroll', onScroll);
		// }
		i[0].autoCompleter = null;
	};

	i.attr('autocomplete', 'off').addClass(o.inputClass).bind('keydown',
			onKeyDown).bind('blur', onBlur);

	if (!$.browser.supportPositionFixed) {
		$(window).bind('scroll', onScroll);
	}

	// make sure there's only one result div
	var r = $('#diigolet-ac');
	if (r.size() == 0) {
		r = $('<div id="diigolet-ac" style="overflow:auto;max-height:200px;position:fixed;width:auto;"><ul></ul></div>')
				.addClass(o.resultsClass).hide().appendTo(document.body);
	}
};
