(function() {
	var D = window.diigo;
	var Utils = D.utils;
	
	var $ = D.$;
	
	var BookmarkElsewhere = D.BookmarkElsewhere = {
		
		/**
		 * Saves a bookmark to other services or locally accroding to preferences
		 */
		post: function(bm) {
			var z = this;
			
			var services = D.prefs.val('bookmark.otherServices');
			if (services) {
				services.split(',').forEach(function(serviceId) {
					var account = diigoUtil.array.find(D.env.otherServices, function(s) {
						return s.service == serviceId;
					});
					
					var options = {};
					
					if (account) {
						options.username = account.username;
						options.password = account.password;
					}
					
					z.postTo(bm, serviceId, options);
				});
			}
			
			if (D.prefs.val('bookmark.addToLocal'))	{
				z.addToLocal(bm);
			}
		},
		
		/**
		 * Post the bookmark to a specific service
		 */
		postTo: function(bm, serviceId, options) {
			var service = this.services[serviceId];
			if (service) {
				D.utils.dump('[Bookmark elsewhere]', service.name);
				
				service.post(bm, options);
			}
		},
		
		addToLocal: function(bm) {
			try{
			D.utils.dump('[Bookmark elsewhere] local');
			
			D.LocalBookmarks.save(bm);
				
				//			// Get the bookmarks service
//			var bookmarksService = Components.classes["@mozilla.org/browser/bookmarks-service;1"]
//			                           .getService(Components.interfaces.nsIBookmarksService);
//			
//			if (!bookmarksService.isBookmarked(bm.url)) {
//				// Create the bookmark
//				bookmarksService.createBookmarkInContainer(
//					bm.title, // bookmark name
//	                bm.url, // URI of the bookmark
//	                null, // shortcut
//	                bm.description, // description
//	                bm.characterSet || null, // charset
//	                null, // postData
//	                bookmarksService.getBookmarksToolbarFolder(), // bookmark folder
//	                0); // index in the folder
//			}
			}catch(e){
				throw('addToLocal: '+e);
			}
			
		},
		
		services: {
			1: {
				name: 'Blinklist',
				post: function(bm) {
					
				}
			},
			2: {
				name: 'Delicious',
				/*
				https://api.del.icio.us/v1/posts/add?
				Add a post to del.icio.us
				Arguments
				&url (required) - the url of the item.
				&description (required) - the description of the item.
				&extended (optional) - notes for the item.
				&tags (optional) - tags for the item (space delimited).
				&dt (optional) - datestamp of the item (format "CCYY-MM-DDThh:mm:ssZ").
				
				Requires a LITERAL "T" and "Z" like in ISO8601 at http://www.cl.cam.ac.uk/~mgk25/iso-time.html for example: "1984-09-01T14:21:31Z"
				&replace=no (optional) - don't replace post if given url has already been posted.
				&shared=no (optional) - make the item private
				Example Response
				If the post was successful:
				
				<result code="done" />
				
				If the post failed:
				
				<result code="something went wrong" />
				*/
				
				post: function(bm, options) {
					var usr = options.username, pwd = options.password;
					 
					var url = 'https://api.del.icio.us/v1/posts/add?';
					var params = {
						url: bm.url,
						description: bm.title,
						extended: bm.description,
						tags: bm.tags.join(' ')
					};
					
					if (bm.mode == D.PRIVACY_MODE_PRIVATE)
						params.shared = 'no';
						
					url += diigoUtil.string.toQueryString(params);
					
					Utils.dump('[post to delicious] url', url, options);
					setTimeout(function() {
//						var req = new XMLHttpRequest();
//						req.open('GET', url, true, usr, pwd);
//						req.onreadystatechange = function(aEvt) {
//							if (req.readyState == 4) {
//								if (req.status == 200) {
//									Utils.dump('[post to delicious]', req.responseText);
//								}
//							}
//						};
//						
//						req.send(null);
						
						$.ajax({
							type: "GET",
							url: url,
							dataType: 'xml',
							beforeSend: function(xhr) {
								//xhr.setRequestHeader('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US; rv:1.8.1.8) Gecko/20071008 Firefox/2.0.0.8');	
							},
							
							success: function(xml) {
								Utils.dump('[post to delicious] ', $(xml).find('result').attr('code'));
							}
						});
					}, 10);
				}
			},
			3: {
				name: 'Magnolia',
				post: function(bm, options) {
					var usr = options.username, pwd = options.password;
					 
					var url = 'https://api.del.icio.us/v1/posts/add?';
					var params = {
						url: bm.url,
						description: bm.title,
						extended: bm.description,
						tags: bm.tags.join(' ')
					};
					
					if (bm.mode == D.PRIVACY_MODE_PRIVATE)
						params.shared = 'no';
				}
			},
			4: {}
		}
	};

})();