/**
 * HTML pages opened with chrome=yes do not have default tooltip.
 */
var ChromeTooltip = {
	_ele: null,
	
	showDelay: 500,
	showTimer: null,
	
	hideDelay: 3000,
	hideTimer: null,
	
	cancelShow: function() {
		clearTimeout(this.showTimer);
		this.showTimer = null;
	},
	
	cancelHide: function() {
		clearTimeout(this.hideTimer);
		this.hideTimer = null;
	},
	
	scheduleShow: function(event, tip) {
		var z = this;
		var clonedEvent = {clientX: event.clientX, clientY: event.clientY};
		
		z.cancelHide();
		z.cancelShow();
		
		z.showTimer = setTimeout(function() {
			z.show(clonedEvent, tip);
		}, z.showDelay);
	},
	
	scheduleHide: function() {
		var z = this;
		
		z.cancelHide();
		z.cancelShow();
		
		z.hideTimer = setTimeout(function() {z.hide();}, z.hideDelay);
	},
	
	show: function(event, tip) {
		this.cancelHide();
		
		this._ele.innerHTML = tip;
		this._ele.style.display = 'block';
		
		this._ele.style.left = event.clientX + 5 + 'px';
		this._ele.style.top = event.clientY + 5 + 'px';
		
		this.scheduleHide();
	},
	
	hide: function() {
		this.cancelShow();
		this._ele.style.display = 'none';
	},
		
	_createEle: function() {
		this._ele = diigoUtil.dom.buildOne('div', {
			id: 'chromeTip',
			style: 'z-index:9999;border:1px solid black;font-size:12px;font-family: arial, helvetica, sans-serif;position:fixed;background-color:#f7f7ee;padding:2px;display:none'
		});	
		
		document.body.appendChild(this._ele);
	},
	
	run: function() {
		var z = this;
		
		z._createEle();
		
		document.addEventListener('mouseover', function(event) {
			var ele = event.target;
			if (ele.nodeType == 1 && ele.title) {
				z.scheduleShow(event, ele.title);
			}
		}, false);
		
		document.addEventListener('mouseout', function(event) {
			var ele = event.target;
			if (ele.nodeType == 1 && ele.title) {
				z.hide();
			}
		}, false);
	}
};