(function() {
	var D = window.diigo;
	var Utils = D.utils;
	
	var WebAPI;
	var DlgIC;
	D.registerRunLater(function () {
		WebAPI = D["WebAPI"];
		DlgIC = D["DlgIC"];
	});
	
	var $ = D.$;
	
	/**
	 * Context selection menu
	 */
	var Csm = D.Csm = {
		ele: null,
		j: null,
		eleId: 'menupopup#diigotb-csm',
		
		//in firefox3, we can use popupmenu.state to tell whether it's shown
		shown: false,
		
		clear: function() {
			//this.j = null;
			//this.ele = null;
			this.shown = false;
		},
		
		/**
		 * Whether current settings allows showing the popup menu
		 */
		okToPopup: function() {
			return D.hasSignedIn() && D.prefs.val('csm.enabled');
		},
		
		init: function() {
			var z = this;
			
			this.j = $(this.eleId);
			this.ele = this.j[0];
			
			z.j.bind('popupshown', function() {z.shown = true;})
			   .bind('popupshowing', function(event) {z.onPopupShowing(event);})
			   .bind('popuphidden', function() {z.shown = false;})
			
			/**
			 * Allow Ctrl + C when popup is shown
			 * popups can't receive keyboard events (because they can't have focus?)
			 * popups don't bubble keyboard events up to the document unless ignorekeys="true"
			 */
			 
			 document.addEventListener('keydown', function(event) {
			 	if (z.shown && event.keyCode == 67/*c*/ && event.ctrlKey) {
			 		Utils.dump('[Csm] Ctrl + C');
			 		z.hide();
			 		goDoCommand('cmd_copy'); 
			 	}
			 }, true);
		},
		
		onPopupShowing: function(event) {
			//why can't I get the element by document.getElementById. but only $('#id') is OK ?
			// no need to hide, just show it 2008-01-16 14:10:18 UTC
			// $('#diigotb-csm-highlightAndBookmark')[0].hidden = D.getCurrentContext().bookmark.saved;
		},
		
		show: function(event) {
			$('#diigotb-csm-search').attr({label: D.Search.getSearchMenuLabel(D.getFocusedFrame().getSelection().toString())});
			
			var x = event.screenX + 3, y = event.screenY + 3;
			
			//clear the popupNode to use screen coordinates
			//popupNode is set after showing an attached popup
			//seems that x and y are relative to popupNode
			
			document.popupNode = null;
			//this.ele.showPopup(document.documentElement, x, y, 'context');
			this.ele.openPopupAtScreen(x,y,true);
			
			this.shown = true;
		}, 
		
		hide: function() {
			this.ele.hidePopup();
			this.shown = false;
		}
	};
	
	/**
	 * Show this menu when mouseovering a highlight without any inline comments
	 */
	var AnnotationContextMenu = D.AnnotationContextMenu = {
		j: null,
		ann: null,
		context: null,
		p:null,
		
		// some buffer time can greatly reduce "jumps"
		// delay after mouseover highlight before showing
		showDelay: 200,
		showTimer: null,
		
		//delay after mouseout before hiding
		hideDelay: 300,
		hideTimer: null,
		
		shown: false,
		
		clear: function() {
			//this.j = null;
			this.ann = null;
			this.context = null;
			this.hideTimer = null;
			this.showTimer = null;
			this.p = null;
			this.shown = false;
		},
		
		cancelShow: function() {
			clearTimeout(this.showTimer);
			this.showTimer = null;
		},
		
		cancelHide: function() {
			clearTimeout(this.hideTimer);
			this.hideTimer = null;
		},
		
		/**
		 * Returns true if the dlg is shown or a show is scheduled
		 */
		aboutToShow: function() {
			return this.shown || this.showTimer;
		},
		
		aboutToHide: function() {
			return !this.shown || this.hideTimer;
		},
		
		scheduleShow: function(event, ann) {
			var z = this;
			var clonedEvent = {
				screenX: event.screenX, 
				screenY: event.screenY
			};
			
			z.cancelHide();
			z.cancelShow();
			
			z.showTimer = setTimeout(function() {
				if(z.p==null){
					z.showInComment(clonedEvent, ann);
				}else{
					z.show(clonedEvent, ann);
				}
			}, z.showDelay);
		},
		
		scheduleHide: function() {
			var z = this;
			
			z.cancelHide();
			z.cancelShow();
			
			z.hideTimer = setTimeout(function() {z.hide();}, z.hideDelay);
		},
		
		init: function() {
			var z = this;
			
			this.j = $('menupopup#diigotb-anncm')
			.bind('mouseout', function() {
				z.scheduleHide();
				if(z.p&&z.p!=null){
					z.p.scheduleHide();
					z.p.scheduleToggleEdit(false);
				}
			})
			.bind('mouseover', function() {
				z.cancelHide();
				if(z.p&&z.p!=null){
					z.p.cancelHide();
					z.p.cancelToggleEdit();
				}
			});
		},
		
		show: function(event, ann) {
			try{
			this.cancelHide();
			this.cancelShow();
			
			//make sure that the csm is hidden, if both menupopups are shown, firefox has difficulty to hide the highlight context menu
			if (Csm.shown) Csm.hide();
			if (D.DlgIC.shown) D.DlgIC.hide();
			
//			if (this.aboutToShow() && this.ann == ann) return;
			
			this.ann = ann;
			this.context = D.getCurrentContext();
			
			var x = event.screenX + 3, y = event.screenY + 3;
			
			//clear the popupNode to use screen coordinates
			//popupNode is set after showing an attached popup
			//seems that x and y are relative to popupNode
			
			document.popupNode = null;
			
			this.buildMenu(false);
			
			item=this.p.j[0];
			Utils.dump('[showMenu]: ', item);
			//this.j[0].showPopup(item, -1, -1, 'popup','bottomleft','topleft');
			this.j[0].openPopup(item,'after_start',0,0,false,false);
			
			this.shown = true;
			}catch(e){
				//alert(e);
			}
		},
		
		showInComment: function(event, ann) {
			this.cancelHide();
			this.cancelShow();
			
			//make sure that the csm is hidden, if both menupopups are shown, firefox has difficulty to hide the highlight context menu
			if (Csm.shown) Csm.hide();
			
			this.ann = ann;
			this.context = D.getCurrentContext();
			
			var x = event.screenX + 3, y = event.screenY + 3;
			
			//clear the popupNode to use screen coordinates
			//popupNode is set after showing an attached popup
			//seems that x and y are relative to popupNode
			
			document.popupNode = null;
			
			this.buildMenu(true);
			//this.j[0].showPopup(document.documentElement, x, y, 'context');
			this.j[0].openPopup(document.documentElement,'overlap',x,y,true,false);
						
			this.shown = true;
		},		
		hide: function() {
			this.cancelHide();
			this.cancelShow();
			
			this.shown = false;
			this.j[0].hidePopup();
		},
		
		buildMenu: function(inCommentDlg) {
			var ann = this.ann;
			var z = this;
			
			var j = this.j;
			j.empty();
			
			//menuitem add inline comment
			if (ann.canAddComments()&&!inCommentDlg)
			j.append($(Utils.dom.buildOne(
				'menuitem', {
					label: 'Add sticky note',
					accesskey: 'A'
				}
			)).bind('command', function() {
				var x = z.j[0].boxObject.x, 
				    y = z.j[0].boxObject.y;
				DlgIC.show_(x, y, z.ann, true);
			}));
			
			//menuitem delete
			if (ann.comments.length == 0 && ann.canDelete()) {
				j.append($(Utils.dom.buildOne(
					'menuitem', {
						label: 'Delete',
						accesskey: 'D'
					}
				)).bind('command', function() {
					if (!ann.onlyInGroup) ann.del();
					
					//deleting from groups changes ann.groups
					//so we need to map the array
					ann.groups.map(function(g) {return g.name}).forEach(function(groupName) {
						ann.del(groupName);
					});
				}));
			}
			
			if(ann.user == D.env.user){
				j.append($(Utils.dom.buildOne(
						'menuitem', {
							label: 'Get annotated link ...',
							accesskey: 'G'
						}
					)).bind('command', function() {
						openDialog('chrome://diigotb/content/copyAnnotatedLink.xul', 'dlgCopyAnnotatedLink', 'centerscreen,innerWidth=501,innerHeight=167').focus();
					}));
				
				j.append($(Utils.dom.buildOne(
						'menuitem', {
							label: 'View in my library',
							accesskey: 'V',
							url: D.urls.getUserBookmarksPageURLMiddleView(),
							oncommand: "diigo.utils.firefox.openAndReuseOneTabPerURL(this.getAttribute('url'));"
						}
					)));	
				
				if(ann.type == D.ANNOTATION_TYPE_IMAGE||ann.type == D.ANNOTATION_TYPE_TEXT){
					j.append($(Utils.dom.buildOne(
							'menuseparator', {}
						)));
					
					D.Highlighter.colorPen.forEach(function(v) {
						var select="";
						if(ann.extra.color==v||((!ann.extra.color||ann.extra.color==null||ann.extra.color.length<=0)&&v=='yellow')){
							select=" colorSelect";
						}
						j.append($(Utils.dom.buildOne(
								'menuitem', {
									label: v,
									'class':'menuitem-iconic diigotb-menuItem iconic diigotb-icon-highlight '+v+select
								}
							)).bind('command', function() {
								D.handle('changeHighlightColor', v, ann);;
							}));
					});
				}
			}
			
			if(!inCommentDlg||inCommentDlg==null){
				j.append($(Utils.dom.buildOne(
						'menuseparator', {}
					)));			
				//tip
				j.append(Utils.dom.build2(
					'menuitem', {
						label: this.tipMsg(ann,false),
						'class': 'diigotb-menuItem iconic highlight-tip'
					}
				));
			}
		},
		
		tipMsg: function(ann,addlink) {
			var tip = "#{MODE} #{WHAT} by #{REALNAME}";
			var tipData = {
				REALNAME: ann.realName
			};
			if(addlink&&addlink!=null){
				tipData.REALNAME = "<a class='link' href='"+D.urls.getUserHomepageURL(ann.user)+"'>"+ann.realName+"</a>";
			}
			
			if (ann.type == D.ANNOTATION_TYPE_FLOATNOTE)
				tipData.WHAT = 'floating sticky note'
			else
				tipData.WHAT = 'highlight'
				
			if (ann.isPublic())
				tipData.MODE = 'Public'
			else if (ann.isPrivate())
				tipData.MODE = 'Personal'
			else
				tipData.MODE = 'Group'
				
			if (ann.inAnyGroups()) {
				tip += ', shared to group #{GROUPS}';
				var groups = Utils.array.unique(ann.groups.map(function (g) {
															
															return g.displayName;
														}));
				
				if (groups.length == 1)
					tipData.GROUPS = groups[0];
				else {
					tipData.GROUPS = groups.slice(0, groups.length - 1).join(', ') + ' and ' + groups[groups.length - 1];
				}
			}
			
			return Utils.string.trim(Utils.string.showTpl(tip, tipData))+'.';
		}
	};
	
	var AnnotationHeader = D.AnnotationHeader = {
			j: null,
			ann: null,
			context: null,
			
			// some buffer time can greatly reduce "jumps"
			// delay after mouseover highlight before showing
			showDelay: 200,
			showTimer: null,
			
			//delay after mouseout before hiding
			hideDelay: 300,
			hideTimer: null,
			
			editDelay:350,
			editTimer:null,
			
			shown: false,
			
			clear: function() {
				this.j = null;
				this.ann = null;
				this.context = null;
				this.hideTimer = null;
				this.showTimer = null;
				this.editTimer = null;
				this.shown = false;
			},
			
			cancelShow: function() {
				clearTimeout(this.showTimer);
				this.showTimer = null;
			},
			
			cancelHide: function() {
				clearTimeout(this.hideTimer);
				this.hideTimer = null;
			},
			
			/**
			 * Returns true if the dlg is shown or a show is scheduled
			 */
			aboutToShow: function() {
				return this.shown || this.showTimer;
			},
			
			aboutToHide: function() {
				return !this.shown || this.hideTimer;
			},
			
			scheduleShow: function(event, ann) {
				var z = this;
				var clonedEvent = {
					screenX: event.screenX, 
					screenY: event.screenY
				};
				
				z.cancelHide();
				z.cancelShow();
				
				z.showTimer = setTimeout(function() {z.show(clonedEvent, ann);}, z.showDelay);
			},
			
			scheduleHide: function() {
				var z = this;
				
				z.cancelHide();
				z.cancelShow();
				
				z.hideTimer = setTimeout(function() {z.hide();}, z.hideDelay);
			},
			hideCallback: function(){
				this.shown=false;
				this.ann=null;
				if (D.AnnotationContextMenu.aboutToShow())
					D.AnnotationContextMenu.scheduleHide();
			},
			showMenu:function(event,z,isclick){
					z.cancelHide();
					z.cancelToggleEdit();
					if(!z.ann||z.ann==null)return;
					
					if(z.ann.comments.length == 0){
						try{
						var annChanged = D.AnnotationContextMenu.ann != z.ann;
						D.AnnotationContextMenu.p=z;

						if (annChanged || !D.AnnotationContextMenu.shown ||isclick)
							D.AnnotationContextMenu.scheduleShow(event, z.ann);
						else 
							D.AnnotationContextMenu.cancelHide();
						}catch(e){throw(e);}
					}else{
						var annChanged = D.DlgIC.ann != z.ann;
						
						if (!D.DlgIC.pinned && !D.DlgIC.editing) {
							if ((annChanged || !D.DlgIC.shown)&&!isclick)
								D.DlgIC.scheduleShow(event, z.ann);
							else
								D.DlgIC.cancelHide();
						}
					}
			},
			
			reset: function(ann) {
				try{
				var z = this;
				this.removeEditMode();
				this.hide();
				
				this.ann = ann;
				this.context = D.getCurrentContext();
				
				this.j = ann.context.$('div.' + D.Highlighter.HIGHLIGHT_ID_CLASS + ann.id);//edit.
				
				this.j.bind('mouseout', function() {
					z.scheduleHide();
				})
				.bind('click', function(event){
					z.showMenu(event,z,true);
				})
				.bind('mousemove', function(event){
					z.showMenu(event,z,false);
				});
				
				}catch(e){
					Utils.dump('reset...', e);
				}
//				this.j.children().bind('click', function(event){
//					z.showMenu(event,z,true);
//				})
//				.bind('mousemove', function(event){
//					z.showMenu(event,z,false);
//				});
				
			},
			
			show: function(event, ann) {
				
				//make sure that the csm is hidden, if both menupopups are shown, firefox has difficulty to hide the highlight context menu
				if (Csm.shown) Csm.hide();
				
				if(ann.comments.length <= 0){
					var hi;
					if(ann.type==D.ANNOTATION_TYPE_TEXT){
						this.j.css({top:-23});
					}else{
						var offset=ann.getPageOffset();
						this.j.css({left:offset.left,top:offset.top});
					}
				}

				try{
				this.j.show();
				}catch(e){
					this.j.css('display','block');
				}
				
				this.shown = true;
			},
			scheduleToggleEdit: function(edit){
				try{
				var z = this;
				if(this.ann==null||this.ann.comments.length <= 0){
					return;
				}

				if(edit&&edit!=null){
					z.j = z.ann.context.$('div.' + D.Highlighter.HIGHLIGHT_ID_CLASS + z.ann.id)
					z.j.toggleClass('edit', true);
				}else{
					z.cancelToggleEdit();
					z.editTimer = setTimeout(function() {
						z.removeEditMode();
					}, z.editDelay);
				}
				}catch(e){
					//ssalert(e);
				}
			},
			removeEditMode: function(){
				if(this.ann&&this.ann!=null&&this.ann.comments.length > 0){
					this.j.toggleClass('edit', false);
					//.unbind()
					//.attr("title",D.AnnotationContextMenu.tipMsg(this.ann));
					this.ann=null;
				}
			},
			cancelToggleEdit: function(){
				clearTimeout(this.editTimer);
				this.editTimer = null;
			},			
			hide: function() {
				this.cancelHide();
				this.cancelShow();
				
				this.shown = false;
				if(this.j&&this.j!=null){
					this.j.hide(1,this.hideCallback);
				}
			}
		};	
	var PageMessage = D.PageMessage = {
			j: null,
			context: null,
			url:'',
			
			// some buffer time can greatly reduce "jumps"
			// delay after mouseover highlight before showing
			showDelay: 150,
			showTimer: null,
			
			//delay after mouseout before hiding
			hideDelay: 100,
			hideTimer: null,
			
			shown: false,
			
			clear: function() {
				this.j = null;
				this.url = '';
				this.context = null;
				this.hideTimer = null;
				this.showTimer = null;
				this.shown = false;
			},
			
			cancelShow: function() {
				clearTimeout(this.showTimer);
				this.showTimer = null;
			},
			
			cancelHide: function() {
				clearTimeout(this.hideTimer);
				this.hideTimer = null;
			},
			
			/**
			 * Returns true if the dlg is shown or a show is scheduled
			 */
			aboutToShow: function() {
				return this.shown || this.showTimer;
			},
			
			aboutToHide: function() {
				return !this.shown || this.hideTimer;
			},
			
			scheduleShow: function(status, msg) {
				var z = this;

				z.cancelHide();
				z.cancelShow();
				
				z.showTimer = setTimeout(function() {z.show(status, msg);}, z.showDelay);
			},
			
			scheduleHide: function() {
				var z = this;
				
				z.cancelHide();
				z.cancelShow();
				
				z.hideTimer = setTimeout(function() {z.hide();}, z.hideDelay);
			},
			hideCallback: function(){
				this.shown=false;
			},
			reset: function() {
				var z = this;
				//this.hide();
				this.context = D.getCurrentContext();
				
				
			},
			
			show: function(status,msg) {
				
				this.j = this.context.$('.diigotb-notice-msg');//D.captureTemplate.imagePanel
				if(this.j.size()<=0){
					this.j = this.context.$(D.captureTemplate.pageMessage)
					.appendTo(this.context.doc.body.parentNode).hide();
				}
				
				//make sure that the csm is hidden, if both menupopups are shown, firefox has difficulty to hide the highlight context menu
				//if (Csm.shown) Csm.hide();
				this.j.removeClass('success failed info process')
				.find('.diigotb-notice-text').html('');
				

				if(status==0){
					var sucMessage=(msg&&msg.length>0)?msg:'Done. <a target="_blank" href="'+this.url+'">Check the captured image in your Diigo library.</a>';
					this.j.find('.diigotb-notice-text').html(sucMessage);
					this.j.addClass('success');
					this.j.find('.diigotb-notice-close').show();
				}else if(status==1){
					var errorMessage=(msg&&msg.length>0)?msg:'Oops! Image cannot be captured now. Please try again or contact us. ';
					this.j.find('.diigotb-notice-text').html(errorMessage);
					this.j.addClass('failed');
					this.j.find('.diigotb-notice-close').hide();
				}else if(status==2){
					this.j.find('.diigotb-notice-text').html(msg);
					this.j.addClass('info');
					this.j.find('.diigotb-notice-close').show();
				}else{
					this.j.addClass('process');
					this.j.find('.diigotb-notice-text').html('Uploading...');
					this.j.find('.diigotb-notice-close').hide();
				}

				var pos={
						left:(this.context.$(content).width()-this.j.width())/2,
						top:10
				};

				try{
				this.j.css(pos).show();
				}catch(e){
					this.j.css({
						'display':'block',
						left:(this.context.$(content).width()-this.j.width())/2,
						top:10
						});
				}
				
				var z=this;
				this.j.find('.diigotb-notice-close').click(function(){
					$(this).parents('.diigotb-notice-msg').hide();
				});
				
				this.shown = true;
			},

			hide: function() {
				this.cancelHide();
				this.cancelShow();
				
				this.shown = false;
				if(this.j&&this.j!=null){
					this.j.hide(1,this.hideCallback);
				}
			}
		};	
	
	var ImagePanel = D.ImagePanel = {
			j: null,
			context: null,
			target:null,
			jTarget:null,
			border:null,
			tip:null,
			tipoffset:null,
			
			// some buffer time can greatly reduce "jumps"
			// delay after mouseover highlight before showing
			showDelay: 350,
			showTimer: null,
			
			//delay after mouseout before hiding
			hideDelay: 100,
			hideTimer: null,
			
			shown: false,
			
			clear: function() {
				this.j = null;
				this.target = null;
				this.context = null;
				this.hideTimer = null;
				this.showTimer = null;
				this.jTarget = null;
				this.border = null;
				this.tip = null;
				this.tipoffset = null;
				this.shown = false;
			},
			
			cancelShow: function() {
				clearTimeout(this.showTimer);
				this.showTimer = null;
			},
			
			cancelHide: function() {
				clearTimeout(this.hideTimer);
				this.hideTimer = null;
			},
			
			/**
			 * Returns true if the dlg is shown or a show is scheduled
			 */
			aboutToShow: function() {
				return this.shown || this.showTimer;
			},
			
			aboutToHide: function() {
				return !this.shown || this.hideTimer;
			},
			
			scheduleShow: function(image) {
				var z = this;
				var doc=z.context.doc;
				z.jTarget=z.context.$(image);

				var curwin=z.context.win,pOffset={left:0,top:0},scrollLeft=0,scrollTop=0;
				
				var re=z.jTarget.parents().filter(function(index){
					try{
					var over=curwin.getComputedStyle(this, null).getPropertyValue("position");
					if(over=='relative'){
						pOffset.left+=z.context.$(this).offset().left;
						pOffset.top+=z.context.$(this).offset().top;
						scrollLeft+=z.context.$(this).scrollLeft();
						scrollTop+=z.context.$(this).scrollTop();
					}
					}catch(e){}
				});
				
				var offset=z.jTarget.offset();
				
				var pos={
					left:offset.left+z.jTarget.outerWidth()-z.j.width()-10,//-bodyoffset.left,
					top:offset.top+z.jTarget.outerHeight()-z.j.height()-10//-bodyoffset.top
				}
				
				var scrollTop = Math.max(doc.documentElement.scrollTop, doc.body.scrollTop);

				try{
				if(pos.top>=scrollTop+this.context.$(content).height()){
					pos.top=offset.top+10;
				}
				}catch(e){
					//alert(e);
				}

				z.cancelHide();
				z.cancelShow();
				
				z.showTimer = setTimeout(function() {z.show(pos,image);}, z.showDelay);
			},
			
			scheduleHide: function() {
				var z = this;
				
				z.cancelHide();
				z.cancelShow();
				
				z.hideTimer = setTimeout(function() {z.hide();}, z.hideDelay);
			},
			hideCallback: function(){
				this.shown=false;
			},
			onclickHelp:function(event){
				D.utils.firefox.openTab(D.urls.getImportHelpURL());
				return true;
			},
			onclickQuickSave: function(event){
				if(!D.env.permissions.image||D.env.permissions.image==null){
					return true;
				}
				if(ImagePanel.target.__processing&&ImagePanel.target.__processing!=null)
					return true;
				if(ImagePanel.target.__saved&&ImagePanel.target.__saved!=null){
					var id=ImagePanel.target.__urlId;
					if(id&&id!='undefined'&&id!=null){
						ImagePanel.target.__processing=true;
						ImagePanel.showTip(ImagePanel.tip,ImagePanel.target);
						WebAPI.deleteBookmark({urlId:id},null,function(){
							ImagePanel.target.__saved=false;
							ImagePanel.target.__processing=false;
							D.ImagePanel.j.removeClass("processing").removeClass("hassaved");
							D.ImagePanel.j.children().attr("title","Save this image to Diigo");
							if(ImagePanel.tip&&ImagePanel.tip!=null)
								ImagePanel.tip.hide();
						});
					}
					return true;
				}
				
				D.handle('clipImage',ImagePanel.target);
				
				ImagePanel.j.addClass("processing");
				//ImagePanel.hide();
				return true;
				
			},			
			reset: function(ctx) {
				var z = this;
				//this.hide();
				if(ctx&&ctx!=null)
					this.context=ctx;
				else
					this.context = D.getCurrentContext();
				
				this.j = this.context.$('#diigotb-imagepanel');//D.captureTemplate.imagePanel
				if(this.j.size()<=0){
					this.j = this.context.$(D.captureTemplate.imagePanel)
					.appendTo(this.context.doc.body.parentNode).hide();
				}
				
				this.border=this.context.$(".diigotb-border");
				if(this.border.size()<=0){
					this.border=this.context.$("<div class='diigotb-border diigotb-left'/><div class='diigotb-border diigotb-top'/><div class='diigotb-border diigotb-right'/><div class='diigotb-border diigotb-bottom'/>")
					.appendTo(this.context.doc.body.parentNode).hide();
				}
				this.j.css({width:24});
				this.j.find("diigotb-btn").show();
				
				this.j.bind('mouseout', function() {
					z.scheduleHide();
				})
				.bind('click', function(event){
					z.cancelHide();
				})
				.bind('mouseover', function(event){
					z.cancelHide();
				});
				
	
				this.context.$('#diigotb-quick-save').click(this.onclickQuickSave);				
			},
			
			show: function(offset, image) {
				
				//make sure that the csm is hidden, if both menupopups are shown, firefox has difficulty to hide the highlight context menu
				//if (Csm.shown) Csm.hide();

				this.j.css({left:offset.left,top:offset.top}).removeClass("hassaved processing");
				if(image.__id&&image.__id!=null){
					this.tip=this.context.$("#"+image.__id);
				}
				if(!D.env.permissions.image||D.env.permissions.image==null){
					this.j.addClass("needpremium").find("#diigotb-quick-save").attr('title','Premium feature, please upgrade.');
				}else{
					this.j.removeClass("needpremium");
					
					if(image.__processing&&image.__processing!=null){
						this.j.addClass("processing");
						ImagePanel.showTip(this.tip,image);
					}else if(image.__saved&&image.__saved!=null){
						this.j.addClass("hassaved");
						D.ImagePanel.j.children().attr("title","Delete this image");
						ImagePanel.showTip(this.tip,image);
					}else{
						D.ImagePanel.j.children().attr("title","Save this image to Diigo");
					}
				}
				
				off=this.jTarget.offset();
				this.border.filter('.diigotb-left').css({
					height:this.jTarget.outerHeight(),
					width:1,
					left:off.left,
					top:off.top});
				this.border.filter('.diigotb-top').css({
					width:this.jTarget.outerWidth(),
					height:1,
					left:off.left,
					top:off.top});
				this.border.filter('.diigotb-right').css({
					height:this.jTarget.outerHeight(),
					width:1,
					left:off.left+this.jTarget.outerWidth(),
					top:off.top});
				this.border.filter('.diigotb-bottom').css({
					width:this.jTarget.outerWidth(),
					height:1,
					left:off.left,
					top:off.top+this.jTarget.outerHeight()});
				this.border.show();
				
				var z=this;
				this.border.bind('mousemove', function() {
					z.cancelHide();
				})
				.bind('mouseout', function() {
					z.scheduleHide();
				})
				.bind('mouseover', function(event){
					z.cancelHide();
				});

				try{
				this.j.show();
				}catch(e){
					this.j.css('display','block');
				}

				this.target=image;
				this.tipoffset={left:off.left+(this.jTarget.outerWidth()-(this.tip!=null?this.tip.width():106))/2,top:offset.top};
				if(this.tip&&this.tip!=null){
					this.tip.css(this.tipoffset);
				}
				
				this.shown = true;
			},
			showTip: function(tip,img){
				if(img.__processing&&img.__processing!=null){
					tip.removeClass("hassaved").addClass("processing").show().find(".diigotb-imagetip-text").text("Uploading...");
				}else if(img.__saved&&img.__saved!=null){
					tip.removeClass("processing").addClass("hassaved").show().find(".diigotb-imagetip-text").text("Saved to Diigo");
				}
				
			},
			hide: function() {
				this.cancelHide();
				this.cancelShow();
				
				this.shown = false;
				if(this.j&&this.j!=null){
					this.j.hide(1,this.hideCallback);
				}
				if(this.border&&this.border!=null){
					this.border.hide();
				}
				if(this.tip&&this.tip!=null){
					this.tip.hide();
				}
			}
		};	
	
	 var RightClickMenu = D.RightClickMenu = {
	 	//position of the menu. used when adding a float note
		x: 0,
		y: 0,
		
	 	init: function() {
	 		var j = $('#contentAreaContextMenu');
	 		var z = this;
	 		
			j[0].addEventListener('popupshowing', function(event) {
				if (event.target != j[0]) return;
				z.x = event.clientX; z.y = event.clientY;
	 			z.buildMenu();
			}, false);
			
			//NOTICE: in ff2(maybe ff3 too?) If I use j.bind (even a blank j.bind('popupshowing', function(event) {});) instead of addEventListener here, snaplinks will fail to prevent the context menu from showing after selecting an area
			//snaplinks uses e.preventDefault() to stop the context menu
			//here is the code from snaplinks
			//function eventPopupshowing(e){
			////	diigo.utils.dump((snaplStopPopup==true) && (snaplButton==snaplRMB), e); // the dump line is added by me when testing, strangly, with the dump line, the context menu won't show up!
			//	if((snaplStopPopup==true) && (snaplButton==snaplRMB)){
			//		e.preventDefault();
			//		snaplStopPopup=false;
			//		return false;
			//	}
			//}

//			j.bind('popupshowing', function(event) {});

	 	},
	 	
	 	buildMenu: function() {
	 		var cm = gContextMenu;
	 		
	 		var j = $('#contentAreaContextMenu');
	 		
	 		//hide every thing added by diigo first
	 		j.find('>.diigotb').attr({hidden: true});
	 		
	 		//if not signed in, return immediately
	 		if (!D.hasSignedIn()) {
	 			return;
	 		}
	 		
	 		//show/hide menuitems
	 		if (!cm.onTextInput && !cm.isContentSelected && !cm.onLink && !cm.onImage) 
	 			$('#diigotb-cm-bookmark, #diigotb-cm-floatNote').attr({hidden: false});
	 		
	 		if (cm.onLink)
	 			$('#diigotb-cm-bookmarkLink').attr({hidden: false});
	 		
	 		var img = D.runtime._focusedNode;
	 		if ((cm.onImage) && !cm.onTextInput){
	 			var content=D.getCurrentContext();
	 			if(content.imageClipable&&content.imageClipable!=null)
	 				$('#diigotb-cm-clipImage').attr({hidden: false});
	 			if(!D.env.permissions.image||D.env.permissions.image==null){
	 				$('#diigotb-cm-clipImage').attr({
	 					tooltiptext: "Premium feature, please upgrade.",
	 					disabled: true});
	 			}else{
	 				$('#diigotb-cm-clipImage').attr({
	 					tooltiptext: "",
	 					disabled: false});
	 			}
	 			$('#diigotb-cm-bookmark').attr({hidden: false});
	 		}else if ((cm.isContentSelected&&cm.isContentSelected!=null) && (!cm.onTextInput||cm.onTextInput==null))
	 			$('#diigotb-cm-highlight,#diigotb-cm-highlightAndBookmark').attr({hidden: false});
	 		
	 		if ((cm.isContentSelected&&cm.isContentSelected!=null)
	 				&& (!cm.onTextInput||cm.onTextInput==null)
	 				&& D.isMoa != 'true')
	 			$('#diigotb-cm-copyAsPlainText,#diigotb-cm-copyWithUrl').attr({hidden: false});
	 		
	 		/*if(D.isMoa == 'true'&&!D.prefs.val('toolbar.showItems.diigotb-tb-search')){
	 			$('#diigotb-cm-search').attr({hidden: true});
	 		}else */if ((cm.isContentSelected&&cm.isContentSelected!=null)
	 				&& (!cm.onTextInput||cm.onTextInput==null))
	 			$('#diigotb-cm-search').attr({hidden: false, label: D.Search.getSearchMenuLabel(D.getFocusedFrame().getSelection().toString())});
	 		
	 		
	 		
	 		var onTop = D.prefs.val('cm.insertAtTop');
	 		var items = 'bookmark bookmarkLink floatNote highlight highlightAndBookmark clipImage search'
	 					.split(' ')
	 					.map(function(v) {return document.getElementById('diigotb-cm-' + v);});
	 		if (onTop&&onTop!=null) {
	 			j.prepend($('#diigotb-cm-sep'));
	 			j.prepend($(items));
	 		} else {
	 			j.append($('#diigotb-cm-sep'));
	 			j.append($(items));
	 		}
	 	}
	 };
})();