(function() {
	var D = window.diigo;
	var Utils = D.utils;
	
/////////////////////////////////////////////////////////////////////////////////
/**
 * In code I use "clip", the users will see "Collect". Shit happens, don't get lost.
 */
var Clip = D.Clip = {
	inClipMode: false,
	
	init: function() {
		var z = this;
		window.addEventListener('keypress', function(event) {
			if (event.keyCode == 27) { //ESC
				z.toggleClipMode(false);
			}
		}, false);
	},
	
	changeLocation: function() {
		this.toggleClipMode(false, true);
	},
	
	toggleClipMode: function(b, force) {
		if (b === undefined) 
			b = !this.inClipMode;
			
		if (!force && !!b == this.inClipMode) return; //so pressing ESC is ok
		
		b = this.inClipMode = !!b;
		D.Toolbar.refresh('clipMode');
		
		if (b) {
			this.messUp(D.getCurrentContext());
		} else {
			this.cleanUp(D.getCurrentContext());
		}
	},
	
	messUp: function(context) {
		if (!context) return;
		var z = this;
		z._messUp(context);
		
		context.getSubContexts(function(c) {
			if (c.highlightable) z._messUp(c);
		});
	},
	
	cleanUp: function(context) {
		if (!context) return;
		var z = this;
		
		z._cleanUp(context);
		
		context.getSubContexts(function(c) {
			z._cleanUp(c);
		});
		
	},
	
	//detect video and show clip button 
	_messUp: function(context) {
		if (!context.$) return;
		
		var doc = context.doc;
		var objects=D.utils.toArray(doc.getElementsByTagName('object'));
		var embeds = D.utils.toArray(doc.getElementsByTagName('embed'));
		context.$.merge(embeds,objects).forEach(function(em) {
			if (em.type != 'application/x-shockwave-flash') return;
			
			var box = context.$(em), bodyBox = context.$(doc.body);
			
			//ignore small swf
			if (box.width() * box.height() < 900) return;
			
			var div = context.$('<div class="diigotb diigoClipVideo"><span class="diigotb">Collect</span></div>').appendTo(doc.body);
			
			div.css({top: Math.max(0, box.offset().top - bodyBox.offset().top - div.height()), left: box.offset().left + box.width() - bodyBox.offset().left - div.width() - 1});
			
			//div.css({top: box.y + 1, right: box.x + box.width - 1});
			div.find('span').click(function() {
				
				if (!div.hasClass('clipped')) {
					div.addClass('clipped');
					this.innerHTML = 'Collected';
					//TODO save the clip
					
					Utils.dump('Clipping a flash');
					
					var info = {};
					var content = GetVideoHtml.dependOnDomain(doc,em,1,info);
				
					var data = {
						user: D.env.user,
						realName: D.env.myProfile.realName,
						content: content,
						type: info.type,
						_embedNode: em
					};
					
					var ann = D.Annotation.add(context, data);
				} else {
//					this.innerHTML = 'Clip';
//					//TODO delete the clip
//					var annId = div.attr('diigoannid');
//					D.Annotation.find(context.getTopLevelContext(), annId).del();
					
				}
				return false;
			});
			
			//is it already clipped?
			var absUrl = D.ImageHighlight.makeAbsUrl((GetVideoHtml.dependOnDomain(doc,em,1,{}).match(/<embed.*?\s+src=['"]?(.*?)['"]?[\s>]/im) || [])[1] || '', doc.URL);
			if (D.utils.array.find(context.getTopLevelContext().annotations, function(a) {
				return (a.type == D.ANNOTATION_TYPE_FLASH || a.type == D.ANNOTATION_TYPE_VIDEO) &&
								a.getSrc() == absUrl;
			})) {
				div.addClass('clipped');
				div.find('span').text('Collected');
			}
		});
	},
	
	_cleanUp: function(context) {
		if (!context.$) return;
		context.$('div.diigoClipVideo').remove();
	}

};


var GetVideoHtml = {

	formYoutobe: function(doc)
	{
		var listInput=doc.getElementsByName("embed_code");
		if(listInput&&listInput.length>0){
			nodeList=listInput[0];
			if(nodeList){
				return nodeList.value
			}
		}
		return "";
	},
	formAol: function(doc)
	{
		var listInput=doc.getElementById("snag");
		if(listInput){
			return listInput.value
		}
		return "";
	},
	formVimeo: function(doc)
	{
		var listInput=doc.getElementsByTagName("textarea");
		if(listInput&&list.length>0){
			for(n in list){
				nodeList=list[n];
				if(typeof nodeList=="function"){continue;}
				if(nodeList){
					valueStr=nodeList.value;
					if(valueStr&&valueStr.length>0&&valueStr.search("<embed")>=0){
						return valueStr;
					}
				}
			}
		}
		return "";
	},
	formStupidvideos: function(doc)
	{
		var listInput=doc.getElementById("md_embed");
		if(listInput){
			return listInput.value
		}
		return "";
	},
	formMetacafe: function(doc)
	{
		var listInput=doc.getElementById("embeddedPlayerLink");
		if(listInput){
			return listInput.value
		}
		return "";
	},
	formIfilm: function(doc)
	{
		var listInput=doc.getElementById("embed_link");
		if(listInput){
			return listInput.value
		}
		return "";
	},
	formBreak: function(doc)
	{
		var listInput=doc.getElementsByName("EmbedTextBox");
		if(listInput&&listInput.length>0){
			nodeList=listInput[0];
			if(nodeList){
				return nodeList.value
			}
		}
		return "";
	},
	formDailymotion: function(doc)
	{
		var listInput=doc.getElementById("video_player_embed_code_text");
		if(listInput){
			return listInput.value
		}
		return "";
	},
	formMyspace: function(doc)
	{
		var listInput=doc.getElementsByName("video_play");
		if(listInput&&listInput.length>0){
			nodeList=listInput[0];
			if(nodeList){
				return nodeList.value
			}
		}
		return "";
	},
	formGoogle: function(doc)
	{
		var listInput=doc.getElementById("embedhtml");
		if(listInput){
			return listInput.value
		}
		return "";
	},
	formYahoo: function(doc)
	{
		var listInput=doc.getElementsByName("embedsource");
		if(listInput&&listInput.length>0){
			nodeList=listInput[0];
			if(nodeList){
				return nodeList.value
			}
		}
		return "";
	},
	formBoit: function(doc)
	{
		var listInput=doc.getElementsByTagName("input");
		if(listInput&&listInput.length>0){
			for(n in listInput){
				nodeList=listInput[n];
				if(typeof nodeList=="function"){continue;}
				if(nodeList){
					valueStr=nodeList.value;
					if(valueStr&&valueStr.length>0&&valueStr.search("<embed")>=0){
						return valueStr;
					}
				}
			}
		}
		return "";
	},
	formAutofilms: function(doc)
	{
		var listInput=doc.getElementsByTagName("input");
		if(listInput&&listInput.length>0){
			for(n in listInput){
				nodeList=listInput[n];
				if(typeof nodeList=="function"){continue;}
				if(nodeList){
					valueStr=nodeList.value;
					if(valueStr&&valueStr.length>0&&valueStr.search("<embed")>=0){
						return valueStr;
					}
				}
			}
		}
		return "";
	},
	
	formYouku: function(doc) {
		var html = '';
		
		var ele = doc.getElementById('link3');
		if (ele && ele.localName.toLowerCase() == 'input') {
			html = ele.value;	
		}
		return html;
	},
	
	form56: function(doc) {
		var html = '';
		var pattern = '<embed src="SWF_URL"  type="application/x-shockwave-flash" width="450" height="390"></embed>';
		var ele = doc.getElementById('input_swf_html');
		if (ele && ele.localName.toLowerCase() == 'input') {
			html = pattern.replace('SWF_URL', ele.value);	
		}
		return html;
	},
	
	formTudou: function(doc) {
		var html = '';
		var ele = doc.getElementById('clipHTMLr');
		if (ele && ele.localName.toLowerCase() == 'input') {
			html = ele.value;	
		}
		return html;
	},
	
	dependOnDomain: function(doc,target,len,backobj)
	{
		var htmlCode="";
		try{
			var doString=doc.domain.toLowerCase();
			if(doString.search("youtube")>=0){
				if(target.id=="movie_player"){
					htmlCode=this.formYoutobe(doc);
				}
			}else if(doString.search("google")>=0){
				if(target.id=="VideoPlayback"){
					htmlCode=this.formGoogle(doc);
				}
			}else if(doString.search("aol")>=0){
				if(target.getAttribute("name")=="browser"||target.id=="browser"){
					htmlCode=this.formAol(doc);
				}
			}else if(doString.search("stupidvideos")>=0){
				if(target.id=="myFlash"){
					htmlCode=this.formStupidvideos(doc);//??
				}
			}else if(doString.search("ifilm")>=0){
				if(target.id=="PRODUCT_OBJECT"){
					htmlCode=this.formIfilm(doc);
				}
			}else if(doString.search("atomfilms")>=0){
				if(target.getAttribute("name")=="flashVideo"||target.id=="flashVideo"){
					htmlCode=this.formAutofilms(doc);
				}
			}else if(doString.search("bolt")>=0){
				if(target.getAttribute("name").search("video_play")>=0||target.id.search("video_play")>=0){
					htmlCode=this.formBoit(doc);
				}
			}else if(doString.search("break")>=0){
				if(target.id=="break_player"){
					htmlCode=this.formBreak(doc);
				}
			}else if(doString.search("vimeo")>=0){
				if(target.id=="vimeo_clip"){
					htmlCode=this.formVimeo(doc);
				}
			}else if(doString.search("dailymotion")>=0){
				if(target.id=="video_player"){
					htmlCode=this.formDailymotion(doc);
				}
			}else if(doString.search("myspace")>=0){
				if(target.id=="vplayer"){
					htmlCode=this.formMyspace(doc);
				}
			}else if(doString.search("yahoo")>=0){
				if(target.id=="vidPlayer"){
					htmlCode=this.formYahoo(doc);
				}
			}else if(doString.search("metacafe")>=0&&len<=1){
					htmlCode=this.formMetacafe(doc);
			} else if (doString.search('youku.') != -1) {
				if(target.id=="movie_player"){
					htmlCode=this.formYouku(doc);
				}
			} else if (doString.search('56.') != -1) {
				if(target.parentNode.id=="object_flash_player"){
					htmlCode=this.form56(doc);
				}
			} else if (doString.search('tudou.') != -1) {
				if(target.id=="playerObject"){
					htmlCode=this.formTudou(doc);
				}
			}
			htmlCode=D.utils.string.strip(htmlCode);
			if(htmlCode.length>0){
				backobj.type=D.ANNOTATION_TYPE_VIDEO;
//				backobj.url=__GetEmbedSourcefromHtml(htmlCode);
			}else{
				htmlCode=D.utils.dom.getElementXML(target);
				
				//absolutize url
				var r = /<embed.*?\s+src=['"]?(.*?)['"]?[\s+>]/im;
				var m = htmlCode.match(r);
				if (m && m[1]) {
					htmlCode = htmlCode.replace(r, function(s, s1) {
						var absUrl = D.ImageHighlight.makeAbsUrl(s1, doc.URL);
						D.utils.dump('[Absolutizing url]', s1, absUrl);
						return s.replace(/\s+src=['"]?(.*?)['"]?[\s+>]/im, ' src="' + absUrl + '" ');
					});
				}
				
//				backobj.url=target.src;
				backobj.type=D.ANNOTATION_TYPE_FLASH;
			}
		}catch(e){
			D.utils.dump("dependOnDomain: "+e);
		}
		
		D.utils.dump("dependOnDomain: ", htmlCode, backobj.type);
		return htmlCode;
	}
};
/////////////////////////////////////////////////////////////////////////////////
})();