(function() {
	var D = window.diigo;
	var Utils = D.utils;
	
/////////////////////////////////////////////////////////////////////////////////

/**
 * Browing event, open tab
 * Timer
 * Special urls
 * Try to catch special diigo urls that indicate data changes e.g. add/del list/group etc.
 */
var EventMachine = D.EventMachine = {
	_locationCounter: 1,
	
	onRequesting: function(url) {
		//handle special urls
		if (/^https?:\/\/([^.]+\.)?diigo\./.test(url)) {
			//we are at a diigo page
			//the browser is requesting the url, but after operation is done, we'll be redirected to a different url
			//we should delay loading longer so that the operation will probably be finished
			Utils.dump('[EventMachine onRequesting] special url', url);
			
			
			//group changes
			if (url.indexOf('group') > -1) {
				var p = [
					'/group_mana/quit_group',
					'/group_mana/delete_group',
				];
				
				for (var i = 0; i < p.length; i++) {
					if (url.indexOf(p[i]) != -1) {
						setTimeout(function() {
							D.WebAPI.loadMyStuff('myGroups');
						}, 5000);
						break;
					}
				}
			} 
			//bookmark and contact list changes
			else if (url.indexOf('list') > -1) {
				var p = [
					'/ditem_list/save_list',
					'/ditem_list/delete_list'
				];
				
				for (var i = 0; i < p.length; i++) {
					if (url.indexOf(p[i]) != -1) {
						setTimeout(function() {
							D.WebAPI.loadMyStuff('myBookmarkLists myList outliners');
						}, 5000);
						break;
					}
				}
				
				var p = [
					'/contact/list/edit',
					'/contact/delete_list'
				];
				
				for (var i = 0; i < p.length; i++) {
					if (url.indexOf(p[i]) != -1) {
						setTimeout(function() {
							D.WebAPI.loadMyStuff('myContactLists');
						}, 5000);
						break;
					}
				}
				
			}
		}// end of if
	},
	
	changeLocation: function(event) {
		var z = this;
		//the location change counter event
		var count = z._locationCounter++;
		if (count % 20 == 0) {
			Utils.dump('[EventMachine] changeLocation MessageAlert.refresh()');
			D.MessageAlert.refresh();
		}
		if (count % 30 == 0) {
			//trigger surfing event here
			Utils.dump('[EventMachine] changeLocation WebAPI.loadMyStuff()');
			
			D.WebAPI.loadMyStuff();
		}
		
		//don't make it too large
		if (count > 16777215) z._locationCounter = 1;
		
		var url = content.document.URL;
		//handle special urls
		if (/^https?:\/\/([^.]+\.)?diigo\./.test(url)) {
			//we are at a diigo page
			//the browser stops at current url, an operation is probably done
			Utils.dump('[EventMachine changeLocation] special url', url);
			
			
			//group changes
			if (url.indexOf('group') > -1) {
				var p = [
					'/group_mana/after_join_group',
					'/group_mana/step_2',
					'/edu/step_2',
					'/group_mana/member_manage'
				];
				
				for (var i = 0; i < p.length; i++) {
					if (url.indexOf(p[i]) != -1) {
						setTimeout(function() {
							D.WebAPI.loadMyStuff('myGroups');
						}, 1000);
						break;
					}
				}
			} else if (url.indexOf('message.diigo.') > -1 && (url.indexOf('/message/') > -1 || url.indexOf('/' + D.env.user + '?tab=2') > -1)) {
//				
//caojun: http://message.diigo.com/user/XXXX?tab=2

				D.MessageAlert.refresh();
			}
			
		} // end of if
	}
	
};
/////////////////////////////////////////////////////////////////////////////////
})();