(function() {
	var D = window.diigo;
	var Utils = D.utils;

	var Bookmark;
	var Annotation;
	var Toolbar;
	var Sidebar;
	var WebAPI;
	var PageContext;
	D.registerRunLater(function () {
		Annotation = D["Annotation"];
		Bookmark = D["Bookmark"];
		Toolbar = D["Toolbar"];
		Sidebar = D["Sidebar"];
		WebAPI = D["WebAPI"];
		PageContext = D["PageContext"];
	});
	
	var $ = D.$;
	
/////////////////////////////////////////////////////////////////////////////////
Utils.extend(D, {
	//e.g. onclick="diigo.handle('action', event, arg1, arg2, ...)"
	handle: function(what, event) {
		Utils.dump('[handle]', what);
		
		var args = [].slice.call(arguments, 1);
		
		return D.eventHandlers[what].apply(D, args);
	},
	
	eventHandlers: {
		restartFirefox: function() {
			//const APP_START = Components.classes['@mozilla.org/toolkit/app-startup;1'].getService(Components.interfaces.nsIAppStartup);
			//APP_START.quit(APP_START.eRestart | APP_START.eAttemptQuit);
		},
		
		uninstall: function() {
			D.runtime.uninstalling = true;
			D.utils.firefox.openTab(D.urls.getToolbarUninstallURL());
		},
		
		/**
		 * Highlight display on/off
		 */
		toggleHighlight: function(value) {
			var off;
			if(typeof value == 'undefined')
				off = !D.prefs.val('hl.dontPaint');
			else
				off = value;
			D.prefs.val('hl.dontPaint', off);
			Toolbar.refresh('toggleHighlight');
			
			var context = D.getCurrentContext();
			if (context) context[(off ? 'un' : '') + 'paintAllAnnotations']();	
		},
		
		//message alert button
		message: function() {
			D.MessageAlert.clearAlert();
			Utils.firefox.openTab(D.urls.getMyMessagesURL());
		},
		capturePage:function(bookmark){
			setTimeout(function(){
				Doc=D.getCurrentContext().doc;
				
				D.upload.SaveTempFile(bookmark,function(succ){
					try{
						if(!bookmark.charset||bookmark.charset.length<=0){
							bookmark.charset=Doc.characterSet;
						}
						if(!bookmark.contentType||bookmark.contentType.length<=0){
							bookmark.contentType=Doc.contentType;
						}
						if(!succ){
							D.uploadNetwork.callbackError(bookmark,null);
						}else{
							var _intervalTime, interNo=0;

							if(bookmark.captured){
								if(D.upload.ReadfileLocal(bookmark.urlId+"-2",true).n>10485760){
									D.uploadNetwork.callbackError(bookmark,null,"You are not allowed to upload snapshot larger than 10M.");
								}else{
									D.handle('uploadPageOnFF', bookmark);
								}
							}else{
								_intervalTime=setInterval(function(){
									interNo++;
									try{
									if(bookmark.captured){
										if(D.upload.ReadfileLocal(bookmark.urlId+"-2",true).n>10485760){
											D.uploadNetwork.callbackError(bookmark,null,"You are not allowed to upload snapshot larger than 10M.");
										}else{
											D.handle('uploadPageOnFF', bookmark);
										}
										clearInterval(_intervalTime); 
									}else if(interNo>240){
										clearInterval(_intervalTime);
										D.uploadNetwork.callbackError(bookmark,null);
									}
									}catch(e){
										clearInterval(_intervalTime);
										D.uploadNetwork.callbackError(bookmark,null);
										throw(e);
									}
								},1000)
							}
						}	
					}catch(e){
						D.uploadNetwork.callbackError(bookmark,null);
						throw(e);
					}				
				});
			},50);
		},
		uploadPageOnFF:function(bookmark){
			if(D.ff3up){
				D.handle('uploadPage', bookmark);
			}
		},
		uploadPage:function(bookmark){
			try{
			D.uploadNetwork.MD5Check(bookmark,2,
				function(succ,batchId,msg){
				try{
					if(!succ){
						D.uploadNetwork.callbackError(bookmark,batchId,msg);
						return;
					}
					var sendbinary=D.uploadNetwork.sendBinary;

					sendbinary(bookmark.urlId,batchId,
							bookmark.contentType,2,
							bookmark.charset,D.upload.ReadfileLocal(bookmark.urlId+"-2",true),
							function(success,msg){
								try{
									if(success){
										if(D.isNormalPage(bookmark)){
											D.upload.uploadNormalPage(bookmark,batchId,sendbinary);
										}else{
											D.uploadNetwork.callbackSucc(bookmark,batchId);
										}
									}else{
										D.uploadNetwork.callbackError(bookmark,batchId,msg);
									}
								}catch(e){
									D.uploadNetwork.callbackError(bookmark,null);
									throw(e);
								}
							},false);
					}catch(e){
						D.uploadNetwork.callbackError(bookmark,null);
						throw(e);
					}
				});
			}catch(e){
				D.uploadNetwork.callbackError(bookmark,null);
				throw(e);
			}
		},
		
		onDiigoPopupShowing: function(event,hlid,cachId){

			var menu = document.getElementById(hlid);
			var labelText='';
			var filter=D.prefs.val('filter');
			if(typeof filter!="string"){
				D.prefs.val('filter','_all');
				filter='_all';
			}
			if(filter == '_all'){
				labelText='See All Annotations';
			}else if(filter == '_nonepublic'){
				labelText='See Private and Group Annotations';
			}else if(filter == '_public'){
				labelText='See only Public Annotations';
			}else if(filter == '_private'){
				labelText='See only Private Annotations';
			}else if(filter == '_none'){
				labelText='Don\'t Show Annotation';
			}else{
				labelText='See annotations from group '+ 
				D.env.myGroups.filter(function(v){
					if(v.name==filter){
						return true;
					}
					return false;
				})[0].displayName;
			}
			menu.setAttribute('label', labelText);
			
			var cachItem=document.getElementById(cachId);
			if(cachItem){
				D.runtime._focusedContext = D.getCurrentContext();
				if(D.runtime._focusedContext){
					var cached=D.runtime._focusedContext.bookmark.cached;
					if(cached==2){
						cachItem.setAttribute('label', 'Snapshot of this page');
						cachItem.setAttribute('hidden', 'false');
					}else if(cached==1){
						cachItem.setAttribute('label', 'Cached version of this page');
						cachItem.setAttribute('hidden', 'false');
					}else{
						cachItem.setAttribute('hidden', 'true');
					}
				}
			}
			
		},
		hideNotes: function(event){
			D.runtime._focusedContext = D.getCurrentContext();
			
			var res={
						filterAll:false,
						doit:false
					};
			window.openDialog('chrome://diigotb/content/noticeSelectPages.xul', '', 'centerscreen,modal',res).focus();
			if(res.doit==true){
				D.prefs.val(D.env.user+'.useBlacklist',true);
				var url=D.runtime._focusedContext.bookmark.url.toLowerCase();
				
				if(!D.isSelectedURL(url)){		
					D.env.myBlackList.push(url);
					D.prefs.val(D.env.user+'.Blacklist',Utils.json.toJSON(D.env.myBlackList));
				}
				
				D.handle('toggleHighlight',false);				
				D.runtime._focusedContext.unpaintAllAnnotations();
				D.runtime._focusedContext.paintAllAnnotations();
				
				Sidebar.refresh('annotations', D.runtime._focusedContext, true);
			}
			
			if(res.filterAll==true){
				D.handle('switchFilter', '_nonepublic');
			}
		},
		
		onFilterPopupShowing: function(event){
			var j = $(event.target);
			j.empty();
			
			j.append(Utils.dom.build2(
				'menuitem', {
					label: 'Select an annotation filter below',
					'class': 'diigotb-menuItem iconic highlight-tip'
				},
				'menuseparator', {},
				'menuitem', {
					label: 'See All Annotations',
					'val': '_all',
					type: 'radio',
					oncommand: "diigo.handle('switchFilter', this.getAttribute('val'))"
				},
				'menuitem', {
					label: 'See Private and Group Annotations',
					'val': '_nonepublic',
					type: 'radio',
					oncommand: "diigo.handle('switchFilter', this.getAttribute('val'))"
				},				
				'menuitem', {
					label: 'See only Public Annotations',
					'val': '_public',
					type: 'radio',
					oncommand: "diigo.handle('switchFilter', this.getAttribute('val'))"
				},				
				'menuitem', {
					label: 'See only Private Annotations',
					'val': '_private',
					type: 'radio',
					oncommand: "diigo.handle('switchFilter', this.getAttribute('val'))"
				},				
				'menuitem', {
					label: 'Don\'t Show Annotation',
					'val': '_none',
					id: 'diigotb-tb-menuitem-toggleHighlight',
					type: 'radio',
					oncommand: "diigo.handle('switchFilter',this.getAttribute('val'));"
				}
			));
			
			if(D.env.myGroups.length>0){
				j.append(Utils.dom.build2(
					'menuseparator', {}
				));
			}
				
			D.env.myGroups.forEach(function(v) {
					j.append(Utils.dom.build2('menuitem', {
					label: v.displayName,
					'val': v.name,
					type: 'radio',
					oncommand: "diigo.handle('switchFilter', this.getAttribute('val'))"
				}));
			});
			
			var filter=D.prefs.val('filter');
			if(typeof filter!="string"){
				D.prefs.val('filter','_all');
				filter='_all';
			}		
			
			j.children().filter(function(i){
				return $(this).attr('val')==filter;
			}).attr({checked:true});
		},
		
		onHighPenPopupShowing: function(event){
			var szColor=D.prefs.val('penColor');
			D.Highlighter.colorPen.forEach(function(v) {
				$('menuitem.'+v).toggleClass('colorSelect',szColor==v);
			});
			
		},
		
		toggleColor: function(szColor){
			D.prefs.val('penColor',szColor);
			D.Highlighter.colorPen.forEach(function(v) {
				$('.diigotb-icon-highlight').toggleClass(v,szColor==v);
			});		
			function changeClass(con){
				var szColor=D.prefs.val('penColor');
				D.Highlighter.colorPen.forEach(function(v) {
					$(con.doc.body).toggleClass(v,szColor==v);
				});	
			}
			var context=D.runtime._focusedContext;
			if(context.isHighlightPen){
				changeClass(context);
				context.getSubContexts(function(c) {
					if (c.highlightable){
						changeClass(c);
					}
				});
			}
		},
		changeHighlightColor: function(color,ann){
			ann.extra.color=color;
			D.WebAPI.updateExtra(ann, ann.context);
			var highlights;
			if(ann.type==D.ANNOTATION_TYPE_TEXT){
				highlights=ann.context.$('em.' + D.Highlighter.HIGHLIGHT_ID_CLASS + ann.id);
			}else{
				highlights=ann.getEle();
			}
			D.Highlighter.colorPen.forEach(function(w) {
				highlights.each(function(i, v) {
					var jj = ann.context.$(v);
					jj.toggleClass(w,color==w);
				}); 
			});
		},
		
		switchFilter: function(nodeval) {
			D.runtime._focusedContext = D.getCurrentContext();
			var filter = nodeval;
			D.prefs.val('filter',filter);
			if(filter == '_none'){
				D.handle('toggleHighlight',true);
			}else{
				D.handle('toggleHighlight',false);				
				D.runtime._focusedContext.unpaintAllAnnotations();
				D.runtime._focusedContext.paintAllAnnotations();
			}
			D.runtime._focusedContext.filterMode=filter;
			sidewin=Sidebar.getSidebarWindow();
			if(sidewin)
				sidewin.AnnTab.switchFilterMode(filter,true);
		},
		
		oneClickSaveOptions: function() {
			window.openDialog('chrome://diigotb/content/quickSaveTag.xul', '', 'centerscreen,innerWidth=310,innerHeight=110').focus();
		},
		
		//installs the new xpi
		update: function() {
			InstallTrigger.install({'Diigo Bookmarks and Annotations': D._updateUrl})
		},
		
		/**
		 * Notice: does not support copy as plain text with url now!!!
		 * 
		 * TODO: better copy with url implementation
		 * @see http://developer.mozilla.org/en/docs/Using_the_Clipboard
		 * 
		 * @param {Boolean} asPlainText
		 * @param {Boolean} withUrl
		 */
		copy: function(event, asPlainText, withUrl) {
			var focusedWindow = document.commandDispatcher.focusedWindow;
			if ( !focusedWindow || focusedWindow == window ) {
				focusedWindow = window._content;
			}
			
			var selection = focusedWindow.getSelection();
			if (!selection.rangeCount > 0)
				return;
				
			if (!asPlainText && !withUrl)
				goDoCommand('cmd_copy');
			else {
				if (asPlainText) {
					Utils.firefox.copyString(selection.toString());
				} else {
					var range = selection.getRangeAt(0);
					var clonedSelection = range.cloneContents();
					var div = focusedWindow.document.createElement('div');
					div.appendChild(clonedSelection);
					
					var url = focusedWindow.document.__diigo.bookmark.url;
					var html = div.innerHTML + Utils.string.showTpl('<br><a href="#{0}">#{0}</a>', [url]);
					var text = selection.toString() + '\r\n' + url;
	
					D.copy(html, text, focusedWindow);
				}
			}
		},
		
		aboutThisPage: function() {
			Utils.firefox.openAndReuseOneTabPerURL(D.urls.getAboutThisPageURL(D.getCurrentContext().bookmark.url));
		},
		
		openCached: function() {
			Utils.firefox.openAndReuseOneTabPerURL(D.urls.getCachedPageURL(D.getCurrentContext().bookmark.url));
		},
		
		/**
		 * bookmark saved
		 * http://www.diigo.cn/blog_this/draft_blog?title=xx&url=xx
		 */
		blogThis: function() {
			var url = D.urls.getBlogThisURL();
			var context=D.getCurrentContext();
			if(context){
				var bm = context.bookmark;
				url += '?' + diigoUtil.string.toQueryString({
					url: bm.url,
					title: bm.title
				});
			}
			//2008-8-19 used to post b_id but it's no longer needed. we can do both get and post now. I keep posting because we may add data in future	
			Utils.firefox.post(url, null, '', false);
		},
		
		twitterThis: function(bm) {
			
			var top=(window.outerHeight-320)/2, left=(window.outerWidth-580)/2;
			var context=D.getCurrentContext();
			if(context){
				if(!bm)
					bm = context.bookmark;
				if (context && (context.pageComments.length > 0 || context.annotations.length > 0)) {
					D.AnnotatedLink.get(bm.url, 3, function(annotatedUrl) {
						window.open('http://twitter.com/share?url='+encodeURIComponent(annotatedUrl)+'&via=Diigo&text='+encodeURIComponent(bm.getTitle())+'&related=diigo','Diigo','toolbar=0,status=0,width=580,height=320,'+'left='+left+',top='+top);
					}, context);
				} else {
					D.TwitterThis.shortenUrl(bm.url, function(tinyUrl){
						window.open('http://twitter.com/share?url='+encodeURIComponent(tinyUrl)+'&via=Diigo&text='+encodeURIComponent(bm.getTitle())+'&related=diigo','Diigo','toolbar=0,status=0,width=580,height=320,'+'left='+left+',top='+top);
					});
				}
			}else{
				window.open('http://twitter.com/share','Diigo','toolbar=0,status=0,width=580,height=320,'+'left='+left+',top='+top);
			}
			//openDialog('chrome://diigotb/content/twitterThis/twitterThis.xul', 'dlgTwitterThis', 'centerscreen,innerWidth=400,innerHeight=320', bm).focus();
		},
		
		shareOnFacebook: function() {
			var top=(window.innerHeight-436)/2, left=(window.innerWidth-626)/2;
			var context=D.getCurrentContext();
			if(context){
				var bm = context.bookmark;
				window.open('http://www.facebook.com/sharer.php?u='+encodeURIComponent(bm.url)+'&t='+encodeURIComponent(bm.getTitle()),'sharer','toolbar=0,status=0,width=626,height=436,'+'left='+left+',top='+top);
			}else{
				window.open('http://www.facebook.com/sharer.php','sharer','toolbar=0,status=0,width=626,height=436,'+'left='+left+',top='+top);
			}
		},
		
		sendToBtn: function(){
			var text='';
			var c = D.runtime._focusedContext;
			
			if(c&&c.highlightable){
				/*if (!c.highlightable) {
					D.notifyError(D.strings.getString('send.cannotSelect'));
				  	return null;
				}*/
				var sel = c.textHighlighter.checkSelection();
				
				text=c.bookmark.description+"\r\n";
				if(sel.ok)
					text=text+"\r\n"+sel.txt2;
			}
			
			window.openDialog('chrome://diigotb/content/sendTo/sendTo.html', 'dlgSendTo', 'dialog=no,centerscreen,chrome,resizable=no,innerWidth=580,innerHeight=480,scrollbars=no', null, null,text).focus();
		},
		
		sendTo: function(defaultRecipient, postANote,description) {
			window.openDialog('chrome://diigotb/content/sendTo/sendTo.html', 'dlgSendTo', 'dialog=no,centerscreen,chrome,resizable=no,innerWidth=580,innerHeight=480,scrollbars=no', defaultRecipient, postANote,description).focus();
		},
		
		viewFilterbm: function(event,filterId){
			filter = D.QAF.find(filterId);
			if(filter){
				var type = filter.type,url;
			    if (type == D.QAF.TYPE_UNREAD) {
			    	url = D.urls.getUnreadBookmarksURL();
			    } else if (type == D.QAF.TYPE_RECENT) {
			    	url = D.urls.getUserBookmarksPageURL();
			    } else if (type == D.QAF.TYPE_LIST) {
			    	
			    	list=Utils.array.find(D.env.myList, function(a) {
					    		return a.id == filter.criteria.listId;
					    	});
					if(!list){
						list=Utils.array.find(D.env.outliners, function(a) {
					    	return a.id == filter.criteria.listId;
					    });
					}
			    	url = D.urls.getListURL(list.uri);
			    } else if (type == D.QAF.TYPE_TAG) {
			    	url = D.urls.getUserTagBookmarksURL(D.unparseTags(filter.criteria.tags));
			    	if(filter.criteria.unread)
			    		url=url+"?tab=251";
			    }
			    event.target.setAttribute('url',url);
			    D.handle('openMenuItemUrl', event);
			}
		},
		
		enableCsm: function(enable) {
			D.prefs.val('csm.enabled', enable);	
		},
		
		TogglePen: function(context) {
			context.isHighlightPen=!context.isHighlightPen;
			var btn=$('#diigotb-tb-highlight');
			if(context.isHighlightPen){
				btn.attr('checked','true');
				btn.attr('label','Highlighter');
			}else{
				btn.attr('checked','false');
				btn.attr('label','Highlight');
			}
			function changeClass(con){
				var szColor=D.prefs.val('penColor');
				$(con.doc.body).toggleClass('diigoHiPen');
				D.Highlighter.colorPen.forEach(function(v) {
					$(con.doc.body).toggleClass(v,szColor==v);
				});	
			}
			changeClass(context);
			context.getSubContexts(function(c){
				if (c.highlightable){
					changeClass(c);
				}
			});
		},
		onFind: function(event) {
			gFindBar.onFindCommand();
			D.handle('OnInsertDiigoFindLink');
		},
		
		OnInsertDiigoFindLink:function(){
			
			var findContainer=document.getAnonymousElementByAttribute(
					document.getElementById("FindToolbar"), "anonid", "findbar-container");
			if(findContainer&&findContainer!=null){
				labelItem=document.getAnonymousElementByAttribute(
						document.getElementById("FindToolbar"), "class", "diigotb-findbar-label");
				if(!labelItem||labelItem==null){
					var item = Utils.dom.buildOne('label', {
						'class': 'diigotb-findbar-label', 
						value: "Find more on the web", 
						onclick: "diigo.Search.goSearchFindbar();"
					});
					var afterItem=document.getAnonymousElementByAttribute(
							document.getElementById("FindToolbar"), "anonid", "match-case-status");
					findContainer.insertBefore(item,afterItem);
				}
			}
			
		},
		
		highlight: function(event) {
			var c = D.runtime._focusedContext;
			
			if (!c.highlightable) {
				D.notifyError(D.strings.getString('highlight.cannotHighlight2'));
			  	return null;
			}
			
			var sel = c.textHighlighter.checkSelection();
			Utils.dump('[highlight]', sel);
			
			if (sel.ok) {
				Utils.dump('[highlight] Making a text highlight');
				//NOTICE: we don't add groups here
				//WebAPI will add groups according to bookmark groups
				var data = {
					user: D.env.user,
					realName: D.env.myProfile.realName,
					content: sel.html,
					type: D.ANNOTATION_TYPE_TEXT,
					//groups: c.bookmark.getGroupNamesSharedByMe(),
					nth: sel.nth - 1// warning: the nth param on sel means the count of the selected text and the nth param on ann means the *th text in total!
				};

				var ann = Annotation.add(c, data);
			} else {
				if(sel.pen){
					D.handle('TogglePen',c);
				}else{
					D.notifyError(sel.msg);
				}
			}	
			return ann;
		},
		
		clipImage: function(overImage) {
			var ctx = D.getCurrentContext();
			
			//if (!ctx.highlightable) return null;

			var img;
			if(overImage)
				img=overImage;
			else
				img = D.runtime._focusedNode;
			
			if (img.tagName.toLowerCase() == 'img') {
				
				ctx.bookmark.image=img;
				ctx.bookmark.image._type="image";
				ctx.bookmark.image.__processing=true;//
				
				var id=Utils.string.md5(Math.random() + Math.random() + new Date().getTime().toString());
				ctx.bookmark.image.__id=id;
				
				if(ctx.$){
					var doc=ctx.doc;
					var tip=ctx.$("#"+id);
					if(tip.size()<=0){
						tip=ctx.$(D.captureTemplate.imageTip)
						.appendTo(doc.body.parentNode)
						//.css(D.ImagePanel.tipoffset)
						.attr("id",id).hide();
					}
					D.ImagePanel.showTip(tip,img);
					
					var imageTar=ctx.$(img);
					var offset=imageTar.offset();
					var pos={
						left:offset.left+(imageTar.outerWidth()-tip.width())/2,//-bodyoffset.left,
						top:offset.top+imageTar.outerHeight()-tip.height()-10//-bodyoffset.top
					}					
					
					var scrollTop = Math.max(doc.documentElement.scrollTop, doc.body.scrollTop);
					try{
					if(pos.top>=scrollTop+ctx.$(content).height()){
						pos.top=offset.top+10;
					}
					}catch(e){
						//alert(e);
					}
					tip.css(pos);
				}
				
				ctx.bookmark.image._name=D.upload.CaptureImageFromUrl(img.src,
						function(succ){
					if(succ)
						D.handle('bookmark', true);
					ctx.bookmark.image=null;
				});
				
//				var data = {
//					user: D.env.user,
//					realName: D.env.myProfile.realName,
//					content: '',
//					type: D.ANNOTATION_TYPE_IMAGE,
//					_focusedNode: img
//				};
//				
//				var ann = Annotation.add(c, data);
			}
		},
		
		//no longer used 2008-01-16 14:19:28 UTC
		highlightAndComment: function() {
			var ann = diigo.handle('highlight');
			
			if (!ann) return;
			
			ann.jumpHere(false, true);
		},
		
		highlightAndBookmark: function() {
			var ann = diigo.handle('highlight');
			
			diigo.handle('bookmark', false, D.getCurrentContext());
		},
		
		
		//add float note
		addStickyNote: function(addedFromRightClickMenu) {
			var c = D.runtime._focusedContext;
			
			if (!c.highlightable) return null;
			
			var data = {
				user: D.env.user,
				realName: D.env.myProfile.realName,
				content: '',
				type: D.ANNOTATION_TYPE_FLOATNOTE
			};
			
			if (addedFromRightClickMenu) {
				var x = D.RightClickMenu.x, y = D.RightClickMenu.y;
				data.extra = {left: x, top: y};
			}
			
			var ann = Annotation.add(c, data, {dontSave: true});
			ann.jumpHere(false, true);
		},
		
		toggleClipMode: function(b) {
			D.Clip.toggleClipMode(b);
		},
		
		togglesilentMode: function(E){
			var show=D.prefs.val('dontShowSilentMode');
			if(!show){
				var res={doit:false};
				openDialog('chrome://diigotb/content/NoticeSilentMode.xul', '', 'centerscreen,modal',res).focus();
				if(!res.doit)
					return;
			}
			var mode=D.prefs.val('silentMode');
			D.prefs.val('silentMode',!mode);
			E.checked=!mode;
			Toolbar.refresh('silentMode');
		},
		
		capture:function(This){
			try{
			
			if(!D.env.permissions.capture){
				D.notifyError("Premium feature ~ please upgrade. Enable screenshot capture & annotation. ");
				return;
			}
			var c = D.runtime._focusedContext;
			if (!c.highlightable&&!c.isPdfReader) {
				D.notifyError(D.strings.getString('highlight.cannotcapture'));
			  	return;
			}
			if(context.isPdfReader){
				var unsafeWin = context.doc.defaultView.wrappedJSObject || context.doc.defaultView;
				c.bookmark.title=unsafeWin.document.title;
			}
			if(This.checked){
				D.captureMode.exitCaptureMode();
				This.checked=false;
			}else{
				D.captureMode.enterCaptureMode(D.getCurrentContext().doc);
				This.checked=true;
			}
			}catch(e){
				//alert(e);
			}
		},
		
		captureEntire:function(){
			try{
				if(!D.env.permissions.capture){
					D.notifyError("Premium feature ~ please upgrade. Enable screenshot capture & annotation. ");
					return;
				}
				var c = D.getCurrentContext();
				if (!c.highlightable) {
					D.notifyError(D.strings.getString('highlight.cannotcapture'));
				  	return;
				}
				D.PageMessage.reset();
				D.PageMessage.scheduleShow(3);
				
				var bm=c.bookmark;
				D.upload.capturePng(true,bm,function(object){
					if(object.n<0){
						D.PageMessage.scheduleShow(2, "Failed. The image size is larger than the maximum size (10M).");
						setTimeout(function(){
							D.PageMessage.hide();
						},_timer);
						return ;
					}
					var name=Utils.string.md53(object.v);
					D.upload.savefileLocal(name, object);
					
					bm.image_title="";
					bm.image_description="";
					bm.name=name;
					if(!bm.saved){
						bm.mode=D.prefs.val('bookmark.privateByDefault') ? D.PRIVACY_MODE_PRIVATE : D.PRIVACY_MODE_PUBLIC;
						bm.unread=D.prefs.val('bookmark.quickSaveUnread');
						
						var quickSaveTags = D.parseTags(D.prefs.val('bookmark.quickSaveTag') || '');
						bm.tags=quickSaveTags;
					}
					bm.fileUploaded=true;
					
					D.WebAPI.uploadImage(bm,
							"capture",
							false,
							object.v,
							{left:0,top:0},
							"png",
							"",
							context,
							function(data,ct,code){
								var _timer=10000;
								if(code==1){
									D.PageMessage.url=data.url.replace('DIIGO_FILE_HOME',D.urls.getDiigoURL());
									D.PageMessage.scheduleShow(0);
									_timer=60000;
								}else{
									D.PageMessage.scheduleShow(1);
								}
								setTimeout(function(){
									D.PageMessage.hide();
								},_timer);
							});
				});
				}catch(e){
					throw(e);
				}
			},
		
		/**
		 * Opens the sidebar(if not already) 
		 * and displays Add Comment UI in public section
		 */
		goAddPageComment: function() {
			Sidebar.open('annotations', function() {
				//show add comment UI
				Sidebar.getSidebarWindow().AnnTab.goAddPageComment();
			});	
		},
		
		newInlineComment: function(context,bm) {
					window.openDialog(
						'chrome://diigotb/content/dlgInlinecomment.xul', 
						'inlinecomment', 
						'width=320,height=200,dependent,centerscreen,titlebar=no',
						context,
						bm
					).focus();
		},
		
		bookmark: function(star, context) {
			context = context || D.getCurrentContext();
			
			//diigofy current page
			//when a user clicks bookmark, the page may not be domready, but I think it's safe to diigofy now
			if (!context) {
				context = PageContext.diigofy(content.document);
			}
			
			if (context) {
				//star quick save
				if (star && (!context.bookmark.saved||context.bookmark.image)) {
					Bookmark.star(context);
				} else {
					window.openDialog(
						'chrome://diigotb/content/addBookmark.xul', 
						'addBookmark', 
						'width=500,height=380,resizable=yes,minimizable',
						context
					).focus();
				}
			}
		},
		
		readLater: function() {
			var context = D.getCurrentContext();
			if (!context) return;
			
			var bm = context.bookmark;
			/*var isInunrad=D.isBookmarkInUnreadList(bm);
			if (isInunrad) {
				//mark as read
				D.env.removeUnreadBookmark({url: bm.url});
				D.WebAPI.markAsRead([bm.url]);
			} else {*/
				//save as unread and add to unread list
				if (!D.prefs.val('dontShowReadLater')) {
					var res={doit:false};
					openDialog('chrome://diigotb/content/FirstReadLater.xul', '', 'centerscreen,modal',res).focus();
					if(!res.doit)
						return;
				}
				
				bm.unread = true;
				if (!bm.saved) {
					WebAPI.saveBookmark(bm, {mode:D.PRIVACY_MODE_PRIVATE}, context);
				} else {
					WebAPI.markAsUnread([bm.url]);
					D.env.addUnreadBookmark(bm);
				}
				
				
				var tabs=gBrowser.mTabContainer.childNodes;
				if(tabs.length>1){
					setTimeout(function() {
						//close current tab
						gBrowser.removeCurrentTab();
	
					}, 200);
				}
			//}
			
			Toolbar.refresh('readLater');
		},
		
		readLater_dblclick: function() {
			var context = D.getCurrentContext();
			if (!context) return;
		},
		
		bookmarkLink: function(event, linkEle) {
			var j = $(linkEle);
			if (!j.is('a')) j = j.parents('a:first');
			
			var bm = new Bookmark({
				title: diigoUtil.string.trim(j.attr('title') || j.text()),
				url: j[0].href,
				context: true
			});
			
			bm.context = null;
						
			//NOTICE: code duplication here
			window.openDialog(
				'chrome://diigotb/content/addBookmark.xul', 
				'addBookmark', 
				'width=500,height=380,chrome,resizable=yes,minimizable',
				null,
				bm
			).focus();
			
		},
		getImageBookmark: function(url){
			var bm = new Bookmark({
				//title: diigoUtil.string.trim(j.attr('title') || j.text()),
				url: url,
				tags: [],
				context: true
			});
			
			bm.context = D.getCurrentContext();
			return bm;
		},
		
		unbookmark: function() {
			var context = D.getCurrentContext();
			WebAPI.deleteBookmark(context.bookmark, context);
		},
		
		signIn: function() {
			Utils.firefox.openTab(D.urls.getSignInURL());
		}, 
		
		signOut: function() {
			Utils.firefox.openTab(D.urls.getSignOutURL());
		},
		
		//click Add a filter on toolbar
		addQuickAccessFilter: function() {
			openDialog('chrome://diigotb/content/quickAccessFilter/addFilter.xul', 'dlgaddFilter', '').focus();
		},
		
		toggleToolbar:function(event){
			if(event.target.id=='diigotb-menu-toggle'||event.target.id=='diigotb-tb-toggle'){
				var item=$('#diigotb-menu-toggle');
				var toolbar=document.getElementById("diigotb-toolbar");
				if(toolbar&&toolbar.getAttribute("collapsed")=="true"){
					item.attr("label","Hide Diigo Toolbar");
					toolbar.setAttribute("collapsed","false");
					D.prefs.val('showToolbar',true)
					Toolbar.refresh('buttons');
				}else{
					item.attr("label","Show Diigo Toolbar");
					toolbar.setAttribute("collapsed","true");
					D.prefs.val('showToolbar',false)
				}
			}
			event.stopPropagation();
		},
		
		/*============= Menu =============*/
		onRecentlySavedMenuPopupShowing: function(event) {
			addBookmarksToPopup(event.target, 'recent');
		},
		
		onUnreadBookmarksMenuPopupShowing: function(event) {
			addBookmarksToPopup(event.target, 'unread');
		},
		
		onMyGroupsMenuPopupShowing: function(event) {
			addGroupsToPopup(event.target);
		},
		
		onMyListsMenuPopupShowing: function(event) {
			addListsToPopup(event.target);
		},
		
		openMyBookmarksInSidebar: function(event) {
			Sidebar.open('bookmarks');
		},
				
		deleteBmInfilterMenu:function(event){
			bmUrl=D.QAF.currentBmitem.getAttribute('url');
			bmFilterId=D.QAF.currentBmitem.getAttribute('belongfilter');
			var a = D.QAF.getBookmarksForFilter(bmFilterId), i = Utils.array.findIndex(a, function(v) {return v.url == bmUrl;});
			if(i>-1){
				bm=a.splice(i, 1)[0];
				
				WebAPI.deleteBookmark(bm,null,function(){
					D.env.removeRecentBookmark(bm);
					D.env.removeUnreadBookmark(bm);
					D.fireEvent('bm_del', [bm]);
					
					setTimeout(function(){
						Sidebar.refresh('bmResult');
					},500)
				});
				
			}
		},
		
		editBmInfilterMenu:function(event){
			bmUrl=D.QAF.currentBmitem.getAttribute('url');
			bmFilterId=D.QAF.currentBmitem.getAttribute('belongfilter');
			var a = D.QAF.getBookmarksForFilter(bmFilterId), i = Utils.array.findIndex(a, function(v) {return v.url == bmUrl;});
			if(i>-1){
				bm=a[i];
				
				var bmobj = new Bookmark({
					title: bm.title,
					url: bm.url,
					urlId: bm.urlId,
					b_id: bm.b_id,
					description: bm.description,
					user: bm.user,
					unread: bm.unread,
					mode: bm.mode, //defaults to public
					tags: D.parseTags(bm.tags,true),
					
					datetime: bm.datetime,
					saved: true,
					
					privacyModeSetByUser: true, 
					context: true
				});
				
				bmobj.context = null;
				
				//NOTICE: code duplication here
				window.openDialog(
					'chrome://diigotb/content/addBookmark.xul', 
					'addBookmark', 
					'width=500,height=380,chrome,resizable=yes,minimizable',
					null,
					bmobj
				).focus();
			}
		},		
		/**
		 * http://developer.mozilla.org/en/docs/Code_snippets:Tabbed_browser#Opening_a_URL_in_the_correct_window.2Ftab
		 */
		openMenuItemUrl: function(event, what/*optional*/) {
			var url = getUrl();
			closeMenus(event.target);
			//checkForMiddleClick(event.target, event)
			openUILink(url, event, false, true);
			
			//mark as read and show notice
			if (what == 'unread') {
				D.env.removeUnreadBookmark({url: url}, true);
				D.WebAPI.markAsRead([url]);
				
				//if the url happens to be the url of current bookmark
				var c = D.getCurrentContext();
				if (c && c.bookmark.url == url) {
					c.bookmark.unread = false;	
				}
				
				if (!D.prefs.val('dontShowMarkAsReadNotice')) {
					openDialog('chrome://diigotb/content/quickAccessFilter/markAsReadNotice.xul', '', 'centerscreen,modal').focus();
				}
			}
			
			function getUrl() {
				var url = event.target.getAttribute('url');
				if (!url && what) {
					if (what == 'myBookmarks'){
						url = D.urls.getUserBookmarksPageURL();
					} else if (what == 'myLists') {
						url = D.urls.getMyListsURL();
					} else if (what == 'myGroups') {
						url = D.urls.getUserGroupsURL();
					} else if (what == 'hotBookmarks') { 
						url = D.urls.getHotBookmarksURL();
					} else if (what == 'inviteFriends') {
						url = D.urls.getInviteFriendsURL();
					} else if (what == 'help') {
						url = D.urls.getToolbarHelpURL();
					} else if (what == 'feedback') {
						url = D.urls.getFeedbackURL();
					} else if (what == 'aboutThisPage') {
						url = D.urls.getAboutThisPageURL(D.getCurrentContext().bookmark.url);
					} else if (what == 'unreadBookmarks') {//not used now
						url = D.urls.getUnreadBookmarksURL();
					} else if (what == 'myNetwork') {//not used now
						url = D.urls.getMyNetworkURL();
					}else if(what == 'filterHelp'){
						url = D.urls.getFilterHelpURL();
					}
				}
				
				return url;
			}
		},
		OnCreateList:function(event,callback){
			var res={title:"",mode:2},response={isOK:false};
			openDialog('chrome://diigotb/content/CreateList.xul', '', 'centerscreen,modal',res,response).focus();
			if(response.isOK){
				D.WebAPI.CreateOneList(res,callback);
			}
		},
		
		//click open all in tabs in unread filter
		openAllUnreadInTabs: function(event) {
			var urls = D.$(event.target)
				.siblings('.openAllInTabs').get()
				.map(function (v) {return v.getAttribute('url');});
				
			urls.forEach(function(url) {
				gBrowser.addTab(url);
			});
			
			if (!D.prefs.val('dontShowMarkAsReadNotice')) {
				openDialog('chrome://diigotb/content/quickAccessFilter/markAsReadNotice.xul', '', 'centerscreen,modal').focus();
			}
			
			//mark all as read
			D.WebAPI.markAsRead(urls);
			
			var c = D.getCurrentContext();
			urls.forEach(function(url) {
				D.env.removeUnreadBookmark({url: url}, true);
				//if the url happens to be the url of current bookmark
				if (c && c.bookmark.url == url) {
					c.bookmark.unread = false;	
				}
			});
		},
		
		openAllInTabs: function(event) {
			var urls = D.$(event.target)
				.siblings('.openAllInTabs').get()
				.map(function (v) {return v.getAttribute('url');});
				
			urls.forEach(function(url) {
				gBrowser.addTab(url);
			});
		},
		
		/*========= Sidebar =========*/
		
		switchTagsidebar:function(filterId){
			filter = D.QAF.find(filterId)
			if(filter){
				var unread=filter.criteria.unread;
				switch(filter.type){
				case D.QAF.TYPE_RECENT:
					Sidebar.open('bookmarks',function(){
						Sidebar.getSidebarWindow().BookmarkTab.updateTagSearch("",false);
					});		
					break;
				case D.QAF.TYPE_UNREAD:
					Sidebar.open('bookmarks',function(){
						Sidebar.getSidebarWindow().BookmarkTab.updateTagSearch("",true);
					});		
					break;
				case D.QAF.TYPE_TAG:
					Sidebar.open('bookmarks',function(){
						Sidebar.getSidebarWindow().BookmarkTab.updateTagSearch(filter.name,unread);
					});		
					break;
				case D.QAF.TYPE_LIST:
					Sidebar.open('bookmarks',function(){
						Sidebar.getSidebarWindow().BookmarkTab.updateListSearch(filter.criteria.listId);
					});	
					break;
				}
			}

		},
		
		upgrade:function(){
			Utils.firefox.openTab(D.urls.getPremiumURL());
		},
		
		toggleSidebar: function() {
			toggleSidebar('viewDiigoSidebar');
		}
	}
});


function addBookmarksToPopup(popup, type) {
	var j = $(popup);
	j.empty();
	
	var bms = [];
	
	if (type == 'recent') {
		bms = D.env.recentlySavedBookmarks;
	} else if (type == 'unread') {
		bms = D.env.unreadBookmarks;
	}  
	
	bms.forEach(function(bm) {
		j.append(Utils.dom.build2('menuitem', {
			url: bm.url,
			label: bm.title,
			'class': 'bookmark openAllInTabs',
			onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event);"
		}));
	});
	
	if(bms.length>0){
		j.append(Utils.dom.build2('menuseparator',{},
			'menuitem', {
				label: 'Open All in Tabs',
				accesskey: 'O',
				oncommand: "diigo.handle('openAllInTabs', event);"}));
	}else{
		j.append(Utils.dom.build2(
				'menuitem', {
					label: '(empty)',
					disabled: 'true'}
		));		
	}
	
	
	//hook event handlers to mark bookmark as read
	if (type == 'unread') {
		j.find('menuitem.bookmark').bind('command', function() {
			var url = this.getAttribute('url');
			D.env.removeUnreadBookmark({url: url});
			D.WebAPI.markAsRead([url]);
		});
		
		// open all in tabs
		j.find('menuitem:last').bind('command', function() {
			var urls = $(this)
				.siblings('menuitem.bookmark')
				.get()
				.map(function(e) {return e.getAttribute('url');});
			
			urls.forEach(function(url) {
				D.env.removeUnreadBookmark({url: url});	
			});
			
			//don't send empty array
			if (urls.length > 0)
				D.WebAPI.markAsRead(urls);
		});
	}
		
 }
   
   function addGroupsToPopup(popup) {
	    if(popup.id.length>0)return;
		var j = $(popup);
		j.empty();
		j.append(Utils.dom.build2(
				'menuitem', {
					url: D.urls.getUserGroupsURL(),
					label: 'My groups home',
					accesskey: 'G',
					onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
					}
				));
		
		j.append(Utils.dom.build2(
				'menuseparator', {}
				));
		
		D.env.myGroups.forEach(function(v) {
			j.append(Utils.dom.build2('menuitem', {
				url: D.urls.getGroupURL(v.name),
				label: v.displayName,
				'class': 'group openAllInTabs',
				onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
			}));
		});
		if(D.env.myGroups.length>0){
			j.append(Utils.dom.build2(
					'menuseparator', {}
					));
		}
		
		if(D.env.myArchivedGroups.length>0){
			submenu=Utils.dom.build2(
					'menu', {
						container:"true",
						'class':"menu-iconic bookmark-item",
						label:"My archived groups" 
					});
			
			menupopup=Utils.dom.build2(
					'menupopup', {
						id:"diigotb-archived-groups"
					}
				);
			
			$(menupopup).append(Utils.dom.build2(
					'menuitem', {
						url: D.urls.getArchivedGroupsURL(),
						label: 'My archived group home',
						accesskey: 'a',
						onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
						}
					));
			$(menupopup).append(Utils.dom.build2(
					'menuseparator', {}
			));
			D.env.myArchivedGroups.forEach(function(v) {
				$(menupopup).append(Utils.dom.build2('menuitem', {
					url: D.urls.getGroupURL(v.name),
					label: v.displayName,
					'class': 'group',
					onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
				}));
			});
				
			$(submenu).append(menupopup);
			
			j.append(submenu);
			j.append(Utils.dom.build2(
					'menuseparator', {}
					));
		}
		

	j.append(Utils.dom.build2(
		'menuitem', {
			url: D.urls.getCreateGroupURL(),
			label: 'Create a Group',
			accesskey: 'C',
			onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
			}
		));
   }
   
   function addListsToPopup(popup) {
	    if(popup.id.length>0)return;
		var j = $(popup);
		j.empty();
		
		j.append(Utils.dom.build2(
				'menuitem', {
					url: D.urls.getMyListsURL(),
					label: 'My Outliners home',
					accesskey: 'L',
					onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
					}
				));
		
		j.append(Utils.dom.build2(
				'menuseparator', {}
				));
		
		D.env.outliners.forEach(function(v) {
			j.append(Utils.dom.build2('menuitem', {
				url: v.uri,
				label: v.title,
				'class': 'list openAllInTabs',
				onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
			}));
		});
		
		if(D.env.outliners.length>0){
			j.append(Utils.dom.build2(
					'menuseparator', {}
					));
		}
		
		D.env.myList.forEach(function(v) {
			j.append(Utils.dom.build2('menuitem', {
				url: D.urls.getListURL(v.uri),
				label: v.title,
				'class': 'list openAllInTabs',
				onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
			}));
		});
		
		if(D.env.myList.length>0){
			j.append(Utils.dom.build2(
					'menuseparator', {}
					));
		}
		
		if(D.env.myArchivedBookmarkLists.length>0){
			submenu=Utils.dom.build2(
					'menu', {
						container:"true",
						'class':"menu-iconic bookmark-item",
						label:"My archived lists" 
					});
			
			menupopup=Utils.dom.build2(
					'menupopup', {
						id:"diigotb-archived-groups"
					}
				);
			
			$(menupopup).append(Utils.dom.build2(
					'menuitem', {
						url: D.urls.getArchivedListsURL(),
						label: 'My archived list home',
						accesskey: 'a',
						onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
						}
					));
			$(menupopup).append(Utils.dom.build2(
					'menuseparator', {}
			));
			D.env.myArchivedBookmarkLists.forEach(function(v) {
				$(menupopup).append(Utils.dom.build2('menuitem', {
						url: D.urls.getListURL(v.uri),
						label: v.title,
						'class': 'list',
						onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
				}));
			});
				
			$(submenu).append(menupopup);
			
			j.append(submenu);
			j.append(Utils.dom.build2(
					'menuseparator', {}
					));
		}
		
		j.append(Utils.dom.build2(
			'menuitem', {
				label: 'Create an Outliner',
				accesskey: 'C',
				//onmouseup: "if(event.button==0||event.button==1)diigo.handle('openMenuItemUrl', event)"
				oncommand: "diigo.handle('OnCreateList', event);"
				}
			));
   }

/////////////////////////////////////////////////////////////////////////////////
})();