(function() {
	var D = window.diigo;
	var Utils = D.utils;
/////////////////////////////////////////////////////////////////////////////////

var marks={};

D.LocalBookmarks = {
	rootFolderName: 'Diigo-Bookmarks',
	
	getBookmarksService: function() {
//		var bmsvc = Components.classes['@mozilla.org/browser/nav-bookmarks-service;1']
//			.getService(Components.interfaces.nsINavBookmarksService);
//		
//		return bmsvc;
		return PlacesUtils.bookmarks;
	},
	
//	createFolder1: function(folderName) {
//		var bmsvc = this.getBookmarksService();
//		var folder = bmsvc.createFolder(bmsvc.bookmarksMenuFolder, folderName, -1);
//	},
	
	getChildFolderForFF4: function(parentId, folderTitle){
		var result=PlacesUtils.getFolderContents(parentId, true, true);
		if(result&&result.root){
			var relist=result.root;
			var childCount=relist.childCount;
			if(childCount&&childCount>0){
				for(var i=0;i<childCount;i++){
					var node=relist.getChild(i);
					if(node){
						if(node.title==folderTitle){
							return node.itemId;
						}
					}
				}
			}
		}
		return 0;
	},
	
	getOrCreateTagFolder: function(tag) {
		var bmsvc = this.getBookmarksService();
		var diigoRoot = this.getOrCreateRootFolder();
		var id;
		if(bmsvc.getChildFolder){
			id = bmsvc.getChildFolder(diigoRoot, tag);
		}else{
			id = this.getChildFolderForFF4(diigoRoot, tag);
		}

		if (id == 0) {
			id = bmsvc.createFolder(diigoRoot, tag, -1);
		}
		return id;
	},
	
	getOrCreateRootFolder: function() {
		var bmsvc = this.getBookmarksService();
		var id;
		if(bmsvc.getChildFolder){
			id = bmsvc.getChildFolder(bmsvc.bookmarksMenuFolder, 'Diigo-Bookmarks');
		}else{
			id = this.getChildFolderForFF4(bmsvc.bookmarksMenuFolder, 'Diigo-Bookmarks');
		}

		if (id == 0) {
			id = bmsvc.createFolder(bmsvc.bookmarksMenuFolder, this.rootFolderName, -1);
		}
		return id;
	},
		
	save: function(bm) {
		var z = this;
		
		var tags = bm.tags;
		if (!tags || tags.length == 0) tags = ['no_tag'];
		
		tags.forEach(function(tag) {
			var folder = z.getOrCreateTagFolder(tag);
			z._saveBookmark(folder, bm);
		});
		
	},
	
	_saveBookmark: function (folder, bm) {
		try{
		D.utils.dump('[LocalBookmarks] save bookmark with url', bm.url);
		var bmsvc = this.getBookmarksService();
		
		var historyService = PlacesUtils.history; //Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService);
		var options = historyService.getNewQueryOptions();
		var query = historyService.getNewQuery();
		
		//options.setGroupingMode([options.GROUP_BY_FOLDER],1);
		query.setFolders([folder], 1);
		
		var result = historyService.executeQuery(query, options);
		
		var rootNode = result.root;
		rootNode.containerOpen = true;
		
		// iterate over the immediate children of this folder and dump to console
		for (var i = 0; i < rootNode.childCount; i++) {
		  var node = rootNode.getChild(i);
			//D.utils.dump('[LocalBookmarks] existing bookmark', node.uri);
			if (PlacesUtils.nodeIsBookmark(node) && node.uri == bm.url) {
				var bmId = node.itemId;
				D.utils.dump('[LocalBookmarks] bookmark with url exists', bm.url, node);
				break;
			}
		}
		
		// close a container after using it!
		rootNode.containerOpen = false;
		
		var bmId = bmId || bmsvc.insertBookmark(folder, Utils.firefox.makeUri(bm.url), -1, bm.title);
		
		//TODO update the bookmark
		bmsvc.setItemTitle(bmId, bm.title);
		if (bm.tags.length > 0) {
			//tags as keywords
			bmsvc.setKeywordForBookmark(bmId, D.unparseTags(bm.tags));
			
			//
			var taggingService = PlacesUtils.tagging;
			taggingService.tagURI(D.utils.firefox.makeUri(bm.url), bm.tags, 1);
			
		}
		if (bm.description)
			PlacesUtils.annotations.setItemAnnotation(bmId, "bookmarkProperties/description", bm.description, 0, Ci.nsIAnnotationService.EXPIRE_NEVER);
		}catch(e){
			D.utils.dump('[LocalBookmarks] exception: ', e);
		}
	},
	adjustUrl: function(url)
	{
		var newUrl=url;
		var shepos=newUrl.search('#');
		if(shepos>0)
		{	newUrl=newUrl.substr(0,shepos);}
		while(newUrl.charAt(newUrl.length-1)=='/'){
			newUrl=newUrl.substr(0,newUrl.length-1);
		}
		return Utils.string.trim(newUrl);
	},	
	
//	readBookmarks_slow: function() {
//		var bms = [];
//		function f(node) {
//			if (node.type == 'bookmark') {
//				bms.push(node);
//			} else if (node.type == 'folder') {
//				for (var i = 0; i < node.children.length; i++)
//					f(node.children[i]);
//			}
//		}
//		
//		f(Application.bookmarks);
//		return bms.map(function(bm) {
//			return {title: bm.title, url: bm.uri.spec, description: bm.description, tags: D.parseTags(bm.keyword || '')};
//		});
//	},
	
	readBookmarks: function(getFilter,toolbarOnly) {
		var bms = [];
		
		var historyService = PlacesUtils.history, bmsvc = PlacesUtils.bookmarks, annsvc = PlacesUtils.annotations;
		var options = historyService.getNewQueryOptions();
		var query = historyService.getNewQuery();
		
		var specialFolderIds = [bmsvc.placesRoot, bmsvc.bookmarksMenuFolder, bmsvc.toolbarFolder, bmsvc.unfiledBookmarksFolder];
		var diigoRootFolderId = this.getOrCreateRootFolder();
		var bookmarkToolbarId = bmsvc.toolbarFolder;
				
		//folder names as tags
		var folderNames = [],z=this;
		
		function f(folder,isBookmarkbar,issubfolder,subfolderName) {
			//skip bookmarks added by diigo
			if (folder == diigoRootFolderId || folder == bmsvc.tagsFolder) return;
			marks={};
			var bmlist=null;
			var tempSubFolder="";
			
			if (specialFolderIds.indexOf(folder) == -1) {
				var folderName = bmsvc.getItemTitle(folder);
				if((typeof folderName=="string")&&folderName.length>0){
					if(isBookmarkbar){
						bmlist=getFilter(folderName);
						tempSubFolder=folderName
					}else if(issubfolder){
						bmlist=getFilter(subfolderName);
					}
					if(folderName.search(/\s+/i)>=0){folderName="\""+folderName+"\"";}
					folderNames.push(folderName);
				}
			}
			
			query.setFolders([folder], 1);
			var result = historyService.executeQuery(query, options);
		
			var rootNode = result.root;
			rootNode.containerOpen = true;

			for (var i = 0; i < rootNode.childCount; i++) {
			  var node = rootNode.getChild(i);
				//D.utils.dump('[LocalBookmarks] existing bookmark', node.uri);
				if (PlacesUtils.nodeIsBookmark(node)) {
					bm=makeBookmark(node,!toolbarOnly);
					if(bm==null)
						continue;
					bms.push(bm);
					if(bmlist!=null)
						bmlist.bms.push(bm);
				} else if (PlacesUtils.nodeIsFolder(node)) {
					f(node.itemId,folder == bookmarkToolbarId,
							(isBookmarkbar||issubfolder),isBookmarkbar?tempSubFolder:subfolderName);
				}
			}
			
			if (folderName && folderNames[folderNames.length - 1] == folderName) folderNames.pop();
			rootNode.containerOpen = false;
		}
		//options.setGroupingMode([options.GROUP_BY_FOLDER],1);
		if(toolbarOnly){
			f(bmsvc.toolbarFolder,true,false,"");
		}else{
			f([bmsvc.placesRoot],false,false,"");
		}
		
		function makeBookmark(node,addFoldername) {
			var desc = '', keyword = bmsvc.getKeywordForBookmark(node.itemId) || '';
			if (annsvc.itemHasAnnotation(node.itemId, 'bookmarkProperties/description'))
				desc = annsvc.getItemAnnotation(node.itemId, 'bookmarkProperties/description');
			
			var sztags=(node.tags || '') + ',' + keyword;
			arrtags = sztags.split(',');
			sztags="";
			for(var i=0;i<arrtags.length;i++){
				var tag=diigoUtil.string.trim(arrtags[i]);
				if(tag.length>0){
					if(tag.search(/\s+/g)){
						tag=('\"'+tag+'\"');
					}
					sztags+=(tag+' ');
				}
			}
			if(addFoldername)
				sztags+=(',' + folderNames.join(','));
			
			url=z.adjustUrl(node.uri);
			if(marks[url])
				return null;
			else
				marks[url]=true;

				
			return {
				title: node.title, 
				url: node.uri, 
				description: desc, 
				mode: D.PRIVACY_MODE_PRIVATE,
				tags: D.parseTags(sztags)
			};
		}
		
		return bms;
	}
};

/////////////////////////////////////////////////////////////////////////////////
})();