(function() {
	var D = window.diigo;
	
/////////////////////////////////////////////////////////////////////////////////
D.urls = {
	matrix: {
		cn: {
			www: 'http://www.diigo.cn',
			group: 'http://group.diigo.cn',
			dms: 'http://message.diigo.cn',
			toolbarServer: 'http://www.diigo.cn',
			uploadServer: 'http://www.diigo.cn',
			signIn: 'http://secure.diigo.cn/sign-in',
			signOut: 'http://www.diigo.cn/sign-out',
			resources: 'http://resources.diigo.cn',
			cookieDomain: '.diigo.cn'
		},
		
//		nl: {
//			www: 'http://www.diigo.nl',
//			group: 'http://group.diigo.nl',
//			dms: 'http://message.diigo.cn',
//			toolbarServer: 'http://www.diigo.nl',
//			signIn: 'http://secure.diigo.nl/sign-in',
//			signOut: 'http://www.diigo.nl/sign-out',
//			resources: 'http://resources.diigo.cn',
//			cookieDomain: '.diigo.nl'
//		},
		
		preview: {
			www: 'https://preview.diigo.com',
			group: 'https://preview-group.diigo.com',
			dms: 'https://preview-message.diigo.com',
			toolbarServer: 'https://preview.diigo.com',
			uploadServer: 'https://secure.diigo.com',
			signIn: 'https://preview.diigo.com/sign-in',
			signOut: 'https://preview.diigo.com/sign-out',
			resources: 'https://resources.diigo.com',
			cookieDomain: '.diigo.com'
		},
		
		www: {
			www: 'https://www.diigo.com',
			group: 'https://groups.diigo.com',
			dms: 'https://message.diigo.com',
			toolbarServer: 'https://toolbar3.diigo.com',
			uploadServer: 'https://secure.diigo.com',
			signIn: 'https://secure.diigo.com/sign-in',
			signOut: 'https://www.diigo.com/sign-out',
			resources: 'https://resources.diigo.com',
			cookieDomain: '.diigo.com'
		}
	},
	
	//diigo homepage
	getDiigoURL: function() {
		return this.matrix[D.prefs.val('server')].www;
	},
	
	//about this page
	getAboutThisPageURL: function(url) {
		url = url || content.location.href;
		return 'https://about.diigo.com/about/' + encodeURIComponent(url);
	},
	
	//cached page
	//http://preview.diigo.com/cached?url=http%3A%2F%2Fwww.mzdthought.com%2Fsc%2Fsx%2Fxue.htm
	getCachedPageURL: function(url) {
		return this.matrix[D.prefs.val('server')].www + '/cached?url=' + encodeURIComponent(url);
	},
	
	getBlogThisURL: function() {
		return this.matrix[D.prefs.val('server')].www + '/blog_this/draft_blog';
	},
	
	getCookieDomain: function() {
		return this.matrix[D.prefs.val('server')].cookieDomain;
	},
	
	//chappai/pv=13/ct=tb/cv=3.xx.xx/user=ken/cmd=bm_loadBookmark/
	getToolbarServerURL: function() {
		return this.matrix[D.prefs.val('server')].toolbarServer
			   + '/chappai/pv=#{pv}/ct=tb/cv=#{cv}/user=#{user}/cmd=#{cmd}/';
	},
	
	getGroupURL: function(group) {
		var url = this.matrix[D.prefs.val('server')].group;
		return group ? url + '/group/' + group : url;
	},
	
	getFilterHelpURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/help/tips.html#quick_access_what';
	},
	
	getAdUrl: function(keywords) {
		return this.matrix[D.prefs.val('server')].www+"/search_mana/enhancement_google?q="+encodeURIComponent(keywords);
	},
	
	getImportHelpURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/help/tips.html#import';
	},	
	//http://groups.diigo.com/diigo-team/forum
//	getGroupForumURL: function(group) {
//		var url = this.matrix[D.prefs.val('server')].group;
//		return url + '/' + group + '/forum';
//	},
	
	
	getCreateGroupURL: function() {
		var url = this.matrix[D.prefs.val('server')].group;
		return url + '/create';
	},

	getEasyBlogHelpURL: function() {
		return this.matrix[D.prefs.val('server')].dms + '/easy_blog_help.html';
	},
	
	//http://group.diigo.cn/user/arrix_
	getUserGroupsURL: function(user) {
		user = user || D.env.user;
		return this.matrix[D.prefs.val('server')].group + '/user/' + user;
	},
	//http://group.diigo.cn/user/arrix_
	getArchivedGroupsURL: function(user) {
		user = user || D.env.user;
		return this.matrix[D.prefs.val('server')].group + '/user/' + user + '?sort_by=activity&type=archived';
	},
	
	getArchivedListsURL: function(user) {
		user = user || D.env.user;
		return this.matrix[D.prefs.val('server')].www + '/list/' + user + '?tab=3';
	},	
	getMyNetworkURL: function(user) {
		user = user || D.env.user;
		return this.matrix[D.prefs.val('server')].www + '/network/' + user;
	},
	
	getUserHomepageURL: function(user) {
		return this.getUserProfileURL(user);
//				var url = this.matrix[D.prefs.val('server')].www;
//				return url + '/user/' + user;
	},
	
	getUserTagURL: function(user, tag) {
		return this.matrix[D.prefs.val('server')].www + '/user/' + user + '/' + encodeURIComponent(tag);
	},
		
	getEditTagsURL: function(user) {
		user = user || D.env.user;
		return this.matrix[D.prefs.val('server')].www + '/cloud/' + user + "?sort=1";
	},
	
	getUserBookmarksPageURL: function(user) {
		user = user || D.env.user;
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/user/' + user;
	},
	
	getUserBookmarksPageURLMiddleView: function(user) {
		user = user || D.env.user;
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/user/' + user + '?dm=middle';
	},
	
	getUnreadBookmarksURL: function(user) {
		user = user || D.env.user;
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/user/' + user + '?type=bookmark&read=n';
	},
		
	//http://www.diigo.cn/buzz/hot
	getHotBookmarksURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/buzz/hot';
	},
	
	getUserTagBookmarksURL: function(tagStr, user) {
		user = user || D.env.user;
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/user/' + user + '/' + encodeURIComponent(tagStr);
	},
	
	getUserProfileURL: function(user) {
		user = user || D.env.user;
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/profile/' + user;
	},
	
	//http://resources.diigo.cn/images/avatar/user/arrix__96.jpg
	getUserAvatarURL: function(user, size) {
		size = size || 48;
		var url = this.matrix[D.prefs.val('server')].resources;
		//TODO user static link
		return url + '/images/avatar/user/' + user + '_' + size + '.jpg';
	},
		
	getListURL: function(listOrUri) {
		var listUri = (typeof listOrUri == 'string') ? listOrUri : listOrUri.uri;
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/list/' + D.env.user + '/' + listUri;
	},
	
//	getContactListURL: function() {
//		
//	},
//	
  
	getUploadURL: function() {
		var url = this.matrix[D.prefs.val('server')].uploadServer;
		return url + '/upload/index?';
	},	
	getUploadCheckURL: function() {
		var url = this.matrix[D.prefs.val('server')].uploadServer;
		return url + '/upload/check_transaction?';
	},	
	getUploadSuccessURL: function() {
		var url = this.matrix[D.prefs.val('server')].uploadServer;
		return url + '/upload/upload_complete?';
	},	
	getUploadMD5Check: function() {
		var url = this.matrix[D.prefs.val('server')].uploadServer;
		return url + '/upload/before?';
	},	
	getEditListURL: function(listOrUri) {
		var url = this.getListURL(listOrUri);
		return url;
	},
	
	//http://www.diigo.cn/list/arrix_
	getMyListsURL: function(user) {
		user = user || D.env.user;
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/outliner';// + user;
	},
	
	//http://preview.diigo.com/people/search/url?type=url&query=http%3A%2F%2Fwww.baidu.com
	getPageReadersURL: function(url) {
		return this.matrix[D.prefs.val('server')].www + '/people/search/url?type=url&query=' + encodeURIComponent(url);
	},
  
  getReadersAlsoBookmarkedURL: function(url) {
		return this.matrix[D.prefs.val('server')].www + '/reader_bookmarks?url=' + encodeURIComponent(url);
	},
	
	getSiteReadersURL: function(domain) {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/community/reader/' + encodeURIComponent(domain);
	},
	
	getSignInURL: function() { 
		var url = this.matrix[D.prefs.val('server')].signIn;
		return url;
	},
	
	getSignOutURL: function() {
		var url = this.matrix[D.prefs.val('server')].signOut;
		return url;
	},
	
	getPremiumURL: function() {
		var url = this.matrix[D.prefs.val('server')].www+"/premium";
		return url;
	},
	
	//http://message.diigo.com/arrix_/message/269
	getMessageURL: function(username, id) {
		var url = this.matrix[D.prefs.val('server')].dms;
		return url + '/message/' + id;
	},
	
	//http://message.diigo.com/user/arrix_
	getMyMessagesURL: function(user) {
		user = user || D.env.user;
		return this.matrix[D.prefs.val('server')].dms + '/user/' + user;
	},
	
	//http://message.diigo.com/inbox/arrix_
	getSendMessageToUserURL: function(username) {
		var url = this.matrix[D.prefs.val('server')].dms;
		return url + '/inbox/' + username;
	},
	
	//http://www.diigo.cn/dmail/draft_forward
	getForwardURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/dmail/draft_link_forward';
	},
	
	/**
	 * http://www.diigo.cn/search?adSScope=my&what=aaa
	 * 
	 * @param {String} scope optional, one of 'my' | 'all' | 'diigo'(default)
	 * @param {Boolean} expand Whether to expand advanced search options
	 */
	getFullTextSearchURL: function(what, scope, expand) {
		var url = this.matrix[D.prefs.val('server')].www + '/search_mana/advanced';
		//if (true || what)
		//	url += '?what=' + encodeURIComponent(what || '');
		//if (scope)
		//	url += '&adSScope=' + encodeURIComponent(scope);
		//if (expand)
		//	url += '&ad=1';
		return url;
	},
	
	getCustomizedSearchURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/customize_search';
	},
	
	//http://groups.diigo.com/Diigo_HQ/forum
	getFeedbackURL: function() {
		return 'https://groups.diigo.com/Diigo_HQ/forum';
	},
	
	//http://help.diigo.com
	getToolbarHelpURL: function() {
		return 'https://help.diigo.com';
	},
	
	//http://preview.diigo.com/friends/arrix_
	getMyFriendsURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/friends/' + D.env.user;
	},
	
	//http://www.diigo.cn/friends/invite/email
	getInviteFriendsURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/friends/invite/email';
	},
	
//	//http://www.diigo.cn/friends/invite/im
//	getInviteFriens2URL: function() {
//		var url = this.matrix[D.prefs.val('server')].www;
//		return url + '/friends/invite/im';
//	},
	
	//http://preview.diigo.com/friends/find
	getFindFriendsURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/friends/find';
	},
	
	//http://preview.diigo.com/browse/people
  //obsolute
//	getBrowsePeopleURL: function() {
//		var url = this.matrix[D.prefs.val('server')].www;
//		return url + '/browse/people';
//	},
	
	//http://www.diigo.cn/main/done.jsp
	getToolbarWelcomeURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/main/done.jsp';
	},
	
	//http://www.diigo.com/main/uninstall.jsp?version=0.5.2007100601&refer=http://www.diigo.com/user/arrix_/
	getToolbarUninstallURL: function() {
		var url = this.matrix[D.prefs.val('server')].www;
		return url + '/main/uninstall.jsp?version=' + encodeURIComponent(D.version);
	}
};


})();