(function() {
	var D = window.diigo;
	var Utils = D.utils;
	
	var $ = D.$;
	
	var DlgIC = D.DlgIC = {
		//the iframe
		j: null,
		pageWindow: null,
		cloud:null,
		
		//boxObject of the inline comment dialog
		box: null,
		Indexpos: null,
		
		shown: false,
		
		pinned: false,
		editing: false,
		
		//used by draggable
		mx: 0, my: 0, dragging: false,
		mw:0,mh:0,resizing:false,
		
		// some buffer time can greatly reduce "jumps"
		// delay after mouseover highlight before showing
		showDelay: 200,
		showTimer: null,
		
		//delay after mouseout before hiding
		hideDelay: 300,
		hideTimer: null,
		
		currentContext: null,
		ann: null,
		
		init: function() {
			//2008-6-28 13:36:0 UTC <box><html:iframe id="id" /></box> in Firefox 2.0.0.14 document.getElementById(id) returns null
			var j = this.j = $('#diigotb-dlgIC,iframe#diigotb-dlgIC').eq(0); // $('#diigotb-dlgIC');
			this.box = j[0].parentNode.boxObject;
			this.pageWindow = j[0].contentWindow;
			
			var z = this;
			
			j.bind('mouseout', function(event) {
				return z._mouseOut(event);	
			});
			
			j.bind('mouseover', function(event) {
				return z._mouseOver(event);	
			});
			
		},
		
		changeLocation: function() {
			var t = D.getCurrentContext();
			
			if (t) {
				if (this.currentContext != t) {
					if (this.currentContext) {
						this.currentContext.removeEventListener('ann_add', this);
						this.currentContext.removeEventListener('ann_del', this);
						this.currentContext.removeEventListener('ann_changeMode', this);
						
						this.currentContext.removeEventListener('ic_add', this);
						this.currentContext.removeEventListener('ic_del', this);
						this.currentContext.removeEventListener('ic_edit', this);
					}
					
					//TODO persist current state
					this.currentContext = t;
					
					//TODO restore previous state
					this.currentContext.addEventListener('ann_add', this);
					this.currentContext.addEventListener('ann_del', this);
					this.currentContext.addEventListener('ann_changeMode', this);
					
					this.currentContext.addEventListener('ic_add', this);
					this.currentContext.addEventListener('ic_del', this);
					this.currentContext.addEventListener('ic_edit', this);
					
					this.hide();
				}
			}
		},
		
		cancelShow: function() {
			clearTimeout(this.showTimer);
			this.showTimer = null;
		},
		
		cancelHide: function() {
			clearTimeout(this.hideTimer);
			this.hideTimer = null;
		},
		
		/**
		 * Returns true if the dlg is shown or a show is scheduled
		 */
		aboutToShow: function() {
			return this.shown || this.showTimer;
		},
		
		aboutToHide: function() {
			return !this.shown || this.hideTimer;
		},
		
		scheduleShow: function(event, ann) {
			var z = this;
			var clonedEvent = {clientX: event.clientX, clientY: event.clientY};
			
			z.cancelHide();
			z.cancelShow();
			
			z.showTimer = setTimeout(function() {
				z.show(clonedEvent, ann);
			}, z.showDelay);
		},
		
		scheduleHide: function() {
			var z = this;
			
			z.cancelHide();
			z.cancelShow();
			
			z.hideTimer = setTimeout(function() {z.hide();}, z.hideDelay);
		},
		
		show: function(event, ann, showAndAdd) {
			var referenceBox = gBrowser.mCurrentBrowser.boxObject;
			
			var x = 5 + event.clientX + referenceBox.x, 
				y = 5 + event.clientY + referenceBox.y;
				
			return this.show_(x, y, ann, showAndAdd);
		},
		
		show_: function(x, y, ann, showAndAdd) {
			var z = this;
			z.ann = ann; 
			
			if(D.AnnotationContextMenu.shown) D.AnnotationContextMenu.hide();
//			if (this.shown) return;
			z.cancelHide();
			z.cancelShow();
			
			//get currentContext
			if (!z.currentContext) 
				z.currentContext = D.getCurrentContext();
			
			z.pageWindow.gContext = z.currentContext;
			
			Utils.dump('[IC] showing...');
			
			z.pageWindow.populateAnnotations();
			z.pageWindow.x=x;
			z.pageWindow.y=y;
			
			z.j.parent().css({ left: x, top: y}).attr({hidden: false});
			z.Indexpos=z._adjustPos();
			z.shown = true;
									
			if (D.hasSignedIn()) {
				z.pageWindow.AnnTab.placeEditor();
			}
		},
		
		RefreshUser:function(){
			var z=this;
			z.pageWindow.AnnTab.editor.init();
		},
		
		/**
		 * adjusts position so that the window doesn't appear off the edges
		 */
		_adjustPos: function() {
			var box = this.box;
			var x = box.x, y = box.y;
			
			//bouding rect restriction
			var boundingBox = document.getElementById('appcontent').boxObject;
			
			if (x < boundingBox.x) x = boundingBox.x;
			if (x + box.width > boundingBox.x + boundingBox.width) x = boundingBox.x + boundingBox.width - box.width;
			if (y < boundingBox.y) y = boundingBox.y;
			if (y + box.height > boundingBox.y + boundingBox.height) y = boundingBox.y + boundingBox.height - box.height;
			
			//Utils.dump('[IC] dragging...', dx, dy);
			
			this.j.parent().css({ left: x, top: y });
			return { left: x, top: y };
		},
		
		getDlgPos:function(){
			var off= this.Indexpos;
			return off;
		},
		
		hide: function() {
			this.cancelHide();
			this.cancelShow();
			
			if (!this.shown) return;
			
			Utils.dump('[IC] hiding...');
			this.j.parent().attr({hidden: true});
			this.shown = this.editing = this.pinned = false;
			
			//this.cloud.css({display:'none'});
			//remove empty unsaved "bubble"
			
			var ann = this.ann;
			ann.activate(false,ann.id);
			if (ann && ann.type == D.ANNOTATION_TYPE_FLOATNOTE && !ann.saved && !ann.saving) {
				ann.del();
			}
			
		},
		startResize: function(e) {
			//Utils.dump('[IC] startDrag...');
			this.resizing = true;
			
			document.addEventListener('mousemove', this._documentResizeMove, true);
			document.addEventListener('mouseup', this._documentResizeUp, true);
			
			this.mw = this.box.width;
			this.mh = this.box.height;	
			this.mx = e.screenX;
			this.my = e.screenY;			
		},
		_documentResizeMove: function(e) {
			var eventX = e.screenX, eventY = e.screenY;
			var z=DlgIC;
			var box = z.box;

			var newW=z.mw+eventX-z.mx,newH=z.mh+eventY-z.my;
			newW=newW<400?400:newW;
			newH=newH<220?220:newH;
			
			newW=newW>1000?1000:newW;
			newH=newH>600?600:newH;
			
			z.j.width(newW);
			z.j.height(newH);
			
			//z.mx = e.screenX;
			//z.my = e.screenY;			
		},
		_documentResizeUp: function(e) {
			var z = DlgIC;
			z.resizing = false;
			document.removeEventListener('mousemove', z._documentResizeMove, true);
			document.removeEventListener('mouseup', z._documentResizeUp, true);
		},			
		startDrag: function(e) {
			//Utils.dump('[IC] startDrag...');
			this.dragging = true;
			
			document.addEventListener('mousemove', this._documentMouseMove, true);
			document.addEventListener('mouseup', this._documentMouseUp, true);
			
			this.mx = e.screenX;
			this.my = e.screenY;
		},
	
		/**
		 * It drove me crazy to finish the draggable
		 * 1. dumping to the error console seems to be async (blocking) and time consuming
		 * 2. accessing event.xxx after dumping is a bad idea 
		 *    because firefox doesn't wait for slow event handlers and just go on and change the event object
		 * 3. the event object is somehow shared and reused
		 * 
		 * Advises are
		 * 1. copy event.xxx you need to local variables as early as possible
		 * 2. use copied variables instead of event.xxx
		 * 3. dumping could change execution order, watch out!
		 */
		_documentMouseMove: function(e) {
			var eventX = e.screenX, eventY = e.screenY;
			var z = DlgIC;
			
			//bouding rect restriction
			var boundingBox = document.getElementById('appcontent').boxObject;
			var xOutOfBound = (eventX < boundingBox.screenX + 10 || eventX > boundingBox.screenX + boundingBox.width - 10);
			var yOutOfBound = (eventY < boundingBox.screenY + 10 || eventY > boundingBox.screenY + boundingBox.height - 10);
			
			var box = z.box;
			var x = box.x, y = box.y;
			
			//deltax and deltay
			var dx = xOutOfBound ? 0 : eventX - z.mx;
			var dy = yOutOfBound ? 0 : eventY - z.my;
			
			//Utils.dump('[IC] dragging...', dx, dy);
			
			z.j.parent().css({
				left: x + dx,
				top: y + dy
			});
			
			var referenceBox = gBrowser.mCurrentBrowser.boxObject;
			//z.cloud.css({
			//	left:x-referenceBox.x-20,
			//	top:y-referenceBox.y-19});
			
			z.mx = eventX;
			z.my = eventY;
			
			e.stopPropagation();
			e.preventDefault();
		},
		
		/**
		 * Stop dragging
		 */
		_documentMouseUp: function() {
			//Utils.dump('[IC] stop dragging...');
			var z = DlgIC;
			z.dragging = false;
			
			document.removeEventListener('mousemove', z._documentMouseMove, true);
			document.removeEventListener('mouseup', z._documentMouseUp, true);
		},
		
		_mouseOut: function(event) {
			//something I don't understand. when I quickly mousein the iframe, a mouseout is triggered with 
			//event.target == the iframe and event.relatedTarget == <browser contextmenu="fbContextMenu" tooltip="fbTooltip" anonid="browser" inherits="tooltip=paneltooltip,contextmenu=panelcontextmenu">
			//have to be more strict here
			
			//ignore mouseout events unrelated to the iframe
			if (this.dragging || event.target != this.j[0] || this.currentContext.draggingFloatNote) return;
			
			//do not auto hide when editing
			if (this.editing) return;
			
			if (this.resizing) return;
			
			var box = this.box;
			var dx = event.screenX - box.screenX,
				dy = event.screenY - box.screenY;
			
			//inside?	
			if (dx >=0 && dx < box.width && dy >= 0 && dy < box.height) {
				return;
			}
			
			//D.utils.dump('[IC] valid mouseout');
			
			this.scheduleHide();
		},
		
		_mouseOver: function(event) {
			if (this.dragging || event.target != this.j[0] || this.currentContext.draggingFloatNote) return;
			
			var box = this.box;
			var dx = event.screenX - box.screenX,
				dy = event.screenY - box.screenY;
			
			//inside?	
			if (!(dx >=0 && dx < box.width && dy >= 0 && dy < box.height)) {
				return;
			}
			//D.utils.dump('[IC] valid mouseover ', event.target, event.relatedTarget);
			
			this.cancelHide();
		}
	};
	
	//context event handlers
	'ic_add ic_edit ic_del ann_add ann_del ann_changeMode'.split(' ')
	.forEach(function(eventName) {
		DlgIC['on' + eventName] = function() {
			if (!this.shown) return;
			var w = this.pageWindow;
			
			var f = w.AnnTab['on' + eventName];
			if (f) f.apply(w.AnnTab, [].slice.call(arguments, 1));
		}
	});
})();
