var mainWindow = window.opener;
var D = mainWindow.diigo;
var context = D.getCurrentContext();
var AnnotationFormatter = D.AnnotationFormatter;

function copy(all) {
	var doc = document.getElementById("content").contentDocument;
	if (all) {
		var html = doc.body.innerHTML;
		var selection = doc.defaultView.getSelection();
		selection.selectAllChildren(doc.body)
		
		//selection.toString() returns nicely formatted plain text
		var text = selection.toString();
		selection.removeAllRanges();
	} else {
		var selection = doc.defaultView.getSelection();
		if (!selection.rangeCount > 0)
			return null;
				
		var range = selection.getRangeAt(0);
		var clonedSelection = range.cloneContents();
		var div = doc.createElement('div');
		div.appendChild(clonedSelection);
		
		var html = div.innerHTML;
		var text = selection.toString();
	}
	
	D.copy(html, text, doc.defaultView);
	
	D.notifyOK(D.strings.getString('extractAnnotations.copied'));
};

function getAnnotatedLinkMode() {
	var a = $('#check-a').is(':checked');
	var b = $('#check-b').is(':checked');
	
	var mode = 0;
	if (!a) mode += 2;
	if (!b) mode += 1;
	
	return mode;
}

function update() {
	var doc = document.getElementById("content").contentDocument;
	
	doc.body.innerHTML = diigoUtil.string.showTpl('<p><a id="link-annotatedLink" target="_blank" href="#{0}" title="#{1}">#{1}</a></p>', ['#', context.bookmark.title]) + 
						 AnnotationFormatter.format(context, {mode: getAnnotatedLinkMode(), includePageComments: true});
	D.AnnotatedLink.get(context.bookmark.url, getAnnotatedLinkMode(), function(url) {
		var doc = document.getElementById("content").contentDocument;
		doc.getElementById('link-annotatedLink').setAttribute('href', url);
	}, context);
}

$(window).load(function() {
	$('#check-a,#check-b').bind('click', function() {
		update();
	});
	
	update();
});
	
