/* 
 *
 *   Copyright(C) 2005-2006 by Diigo Inc.   
 *   All Rights Reserved.
 *
 *   
 *
 */
 
 
var __RDFS		= Components.classes["@mozilla.org/rdf/rdf-service;1"].
				getService(Components.interfaces.nsIRDFService);	

var __BMROOT	= __RDFS.GetResource("NC:BookmarksRoot");
var __BM_NAME	= __RDFS.GetResource("http://home.netscape.com/NC-rdf#Name");
var __BM_TYPE	= __RDFS.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
var __BM_URL	= __RDFS.GetResource("http://home.netscape.com/NC-rdf#URL");
var __BM_TAG	= __RDFS.GetResource("http://home.netscape.com/NC-rdf#ShortcutURL");
var __BM_DESCRIPTION	= __RDFS.GetResource("http://home.netscape.com/NC-rdf#Description");

// Returns an iterator (container) for the contents of a Bookmarks folder
function __GetBookmarkContainer(path) {
	var container = Components.classes["@mozilla.org/rdf/container;1"].
		createInstance(Components.interfaces.nsIRDFContainer);                		
	container.Init(__BMDS, path);
	return container;
}

var DiigoBookmarksService=
{
	RDFService	:	null,
	DataSource	:	null,
	Container	:	null,
	urlArc:null,

	Init:function(){
		try{
			this.RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
			this.Container = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
			this.DataSource=this.RDFService.GetDataSource( "rdf:bookmarks" );
			this.DataSource.QueryInterface(Components.interfaces.nsIBookmarksService);
			this.RDFCUtils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils);
			this.Container.Init(this.DataSource,this.RDFService.GetResource("NC:BookmarksRoot"));

			this.urlArc=this.RDFService.GetResource( "http://home.netscape.com/NC-rdf#URL");
			this.nameArc=this.RDFService.GetResource( "http://home.netscape.com/NC-rdf#Name");
			this.descArc=this.RDFService.GetResource("http://home.netscape.com/NC-rdf#Description");
			this.typeArc=this.RDFService.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
			this.folderValue=this.RDFService.GetResource("http://home.netscape.com/NC-rdf#Folder");
		}catch(e){
			//DiigoLogger.log("DiigoBookmarksService Init: "+e); 
		}
	},

	getBookmarkByName:function(aName){
		try{
			var elements=this.Container.GetElements();
			while(elements.hasMoreElements()){
				var element=elements.getNext();
				element.QueryInterface(Components.interfaces.nsIRDFResource);
				if(this.DataSource.hasArcOut(element,this.urlArc)){
					var target=this.DataSource.GetTarget(element,this.nameArc,true);
					if(target && target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value == aName)
					{	return element;}
				}
			}
		}catch(e){
			DiigoLogger.log("getBookmarkByName: "+e); 
		}
		return null;
	},
	
	getBookmarkByUrlInFolder:function(url,folder){
		try{
			var elements=__GetBookmarkContainer(folder).GetElements();
			while(elements.hasMoreElements()){
				var element=elements.getNext();
				element.QueryInterface(Components.interfaces.nsIRDFResource);
				if(!this.RDFCUtils.IsContainer(this.DataSource,element)){
					var urlObj = this.DataSource.GetTarget(element, __BM_URL, true);
					var _url = urlObj.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
					_url=DiigoAdjustor.adjustUrl(_url); 
					if(_url==url){ return element;}
				}
			}
		}catch(e){
			DiigoLogger.log("getBookmarkByUrlInFolder: "+e);
		}
		return null;
	},

	getFolderByName:function(aName,root){
		try{
			var folders=new Array();
			if(root){
				folders.push(root);
			}else{
				folders.push(__BMROOT);
			}

			for(var i=0;i<folders.length;i++){
				var folder=folders[i];
				var elements=__GetBookmarkContainer(folder).GetElements();
				while(elements.hasMoreElements()){
					element=elements.getNext();
					element.QueryInterface(Components.interfaces.nsIRDFResource);
					if(this.RDFCUtils.IsContainer(this.DataSource,element)){
						var target=this.DataSource.GetTarget(element,this.nameArc,true);
						//DiigoLogger.log(target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value);
						if(target && target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value == aName)
						{	return element;}
						folders.push(element);
					}
				}
			}
		}catch(e){
			DiigoLogger.log("getFolderByName: "+e);
		}
		return null;
	},
	
	
	changeBookmark: function (bookmark,name,url,keyword,desc)
	{
		try{
			this.Unassert(this.DataSource,bookmark);

			var keywordArc= this.RDFService.GetResource("http://home.netscape.com/NC-rdf#ShortcutURL");
			var dateArc= this.RDFService.GetResource("http://home.netscape.com/NC-rdf#BookmarkAddDate");

			var nameTarget= this.RDFService.GetLiteral(name);
			var urlTarget= this.RDFService.GetLiteral(url);
			var keywordTarget=this.RDFService.GetLiteral(keyword);
			var descTarget=this.RDFService.GetLiteral(desc);
			var dateTarget=this.RDFService.GetDateLiteral(this.getDate());

			this.DataSource.Assert(bookmark,this.nameArc,nameTarget,true);
			this.DataSource.Assert(bookmark,this.urlArc,urlTarget,true);
			this.DataSource.Assert(bookmark,keywordArc,keywordTarget,true);
			this.DataSource.Assert(bookmark,this.descArc,descTarget,true);
			this.DataSource.Assert(bookmark,dateArc,dateTarget,true);
		}catch(e){
			DiigoLogger.log("changeBookmark: "+e); 
		}
	},


	createBookmark: function (id,name,url,keyword,desc){
		try{
			var keywordArc= this.RDFService.GetResource("http://home.netscape.com/NC-rdf#ShortcutURL");
			var dateArc= this.RDFService.GetResource("http://home.netscape.com/NC-rdf#BookmarkAddDate");

			var nameTarget= this.RDFService.GetLiteral(name);
			var urlTarget= this.RDFService.GetLiteral(url);
			var keywordTarget=this.RDFService.GetLiteral(keyword);
			var descTarget=this.RDFService.GetLiteral(desc);
			var dateTarget=this.RDFService.GetDateLiteral(this.getDate());

			//bookmark is a brand new resource.
			var bookmark=null;

			if(id) {
				bookmark=this.RDFService.GetResource(id);
				if(this.DataSource.isBookmarkedResource(bookmark))
				{	bookmark=this.RDFService.GetAnonymousResource();}
			}
			else{	bookmark=this.RDFService.GetAnonymousResource();}

			//Write New Data
			this.Container.AppendElement(bookmark);
			this.DataSource.Assert(bookmark,this.nameArc,nameTarget,true);
			this.DataSource.Assert(bookmark,this.urlArc,urlTarget,true);
			this.DataSource.Assert(bookmark,keywordArc,keywordTarget,true);
			this.DataSource.Assert(bookmark,this.descArc,descTarget,true);
			this.DataSource.Assert(bookmark,dateArc,dateTarget,true);
		}catch(e){
			DiigoLogger.log("createBookmark: "+e); 
		}
	},

	getDate: function (){
		var date= ((new Date()).getTime())*1000;
		date=parseInt(date,10).toString();
		return date;
	},

	// RDF wrapping functions
	Assert: function (ds,resource,arc,target){
		var oldtarget=ds.GetTarget(resource,arc,true);
		if(oldtarget){ ds.Change(resource,arc,oldtarget,target);}
		else{ ds.Assert(resource,arc,target,true);}
	},
	
	Unassert: function (ds,node){
		try{
			var props=ds.ArcLabelsOut(node);
			while(props.hasMoreElements()){
 				var prop=props.getNext();
				var target=ds.GetTarget(node,prop,true);
				ds.Unassert(node,prop,target);
			}
		}catch(e){
			DiigoLogger.log("Unassert: "+e); 
		}
	},

	createFolder: function (name,desc,parent){
		try{
			var folder=this.getFolderByName(name,parent);
			if(!folder){
				folder = this.DataSource.createFolderInContainer ( name , parent , 0 );
			}
			//if(desc){
			//	var descTarget=this.RDFService.GetLiteral(desc);
			//	this.DataSource.Assert(folder,this.descArc,descTarget,true);
			//}
			return folder;
		}catch(e){
			DiigoLogger.log("createFolder: "+e); 
		}
		return null;
	},
	
	CreateDiigoBookmarkFolder: function (){
		try{
			var diigofolder="Diigo-Bookmarks";
			var folder=this.getFolderByName(diigofolder);
			if(!folder){
				//alert('before creating folder');
				folder=this.createFolder(diigofolder,"",this.RDFService.GetResource("NC:BookmarksRoot"));
				//alert('after creating folder');
			}
			return folder;
		}catch(e){
			DiigoLogger.log("CreateDiigoBookmarkFolder: "+e); 
		}
		return null;
	},
	
	CreateDiigoBookmark: function (name,url,tags){
		try{
			var root=this.CreateDiigoBookmarkFolder();
			var splitkey=' ';
			var folders=DiigoStringUtil.fullSplit(DiigoStringUtil.fullTrim(tags));//!@#
			for(var i=0;i<folders.length;i++){
				//if(folders[i].isEmpty()) continue;
				try{
					var foldername=folders[i];
					if(foldername.isEmpty()){ foldername=DIIGO_NO_TAG;}
					var folder=this.createFolder(foldername,"",root);
					var bookmark=this.getBookmarkByUrlInFolder(url,folder);
					if(bookmark){
						_Container = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
						_Container.Init(this.DataSource,folder);
						_Container.RemoveElement(bookmark,false);
					}
					this.DataSource.createBookmarkInContainer(name,url,"","","",null,folder,0);
					
				}catch(e){
					DiigoLogger.log("CreateDiigoBookmark: "+e);
				}
			}
		}catch(e){
			DiigoLogger.log("CreateDiigoBookmark: "+e); 
		}
	},
	/*
	createBookmarkInBT:function(name,url,tags){
		try{
			var s;
			if(tags.isEmpty()){
				s=new Array();
				s.push('');
			}else{
				var splitkey=' ';
				tags=splitkey+tags+splitkey;
				tags=tags.replace(/\slinks\s/ig,splitkey);
				tags=DiigoStringUtil.fullTrim(tags);
				s=tags.trim().split(splitkey);//!@#
			}
			if(!s){return;}
			//for(var i=0;i<s.length;i++){
				var fn=s[0];//s[i];
				var folder;
				if(fn.isEmpty()){
					folder=this.getBTFolder();
				}else{
					folder=this.createTopFolderByNameInBT(fn);
				}
				var bookmark=this.getBookmarkByUrlInFolder(url,folder);
				if(bookmark){
					var _Container = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
					_Container.Init(this.DataSource,folder);
					_Container.RemoveElement(bookmark,false);
				}
				this.DataSource.createBookmarkInContainer(name,url,"","","",null,folder,0 /* 0 - last, 1 - first );
			//}
		/*}catch(e){ DiigoLogger.log("createBookmarkInBT: "+e); } 
	},*/
	
	getBTFolder:function(){
		var rdfs = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var bmds = rdfs.GetDataSource("rdf:bookmarks"); 
		var btFolder = bmds.getBookmarksToolbarFolder();
		return btFolder;
	},
	
	createTopFolderByNameInBT:function(aName){
		try{
			var rdfs = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
			var bmds = rdfs.GetDataSource("rdf:bookmarks"); 
			var btFolder = bmds.getBookmarksToolbarFolder();

			var elements=__GetBookmarkContainer(btFolder).GetElements();
			while(elements.hasMoreElements()){
				var element=elements.getNext();
				element.QueryInterface(Components.interfaces.nsIRDFResource);
				if(this.RDFCUtils.IsContainer(this.DataSource,element)){
					var target=this.DataSource.GetTarget(element,this.nameArc,true);
					if(!target){ continue;}
					var folderNmae=target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
					//DiigoLogger.log(folderNmae);
					if(folderNmae.toLowerCase() == aName.toLowerCase())
					{	return element;}
				}
			}
			return this.DataSource.createFolderInContainer ( aName , btFolder , 0 /* 0 - last, 1 - first */ );
			
		}catch(e){
			DiigoLogger.log("createTopFolderByNameInBT: "+e);
		}
		return null;
	}
	
};
