var mainWindow = diigoUtil.firefox.getMostRecentWindow();
var D = mainWindow.diigo;

var gShortcuts = ['sidebar', 'quickBookmark', 'bookmark', 'floatNote', 'capture'];
function windowLoaded() {
	//hide the Quick Access Filter checkbox for ff<3
	if (!D.ff3up) {
		$('checkbox[diigobtn="diigotb-tb-quickAccessFilter-item"]').hide();
	};
	
	prefs2UI();
	
	//keyboard shortcut
	$(gShortcuts.map(function(s) {return '#row-keys-' + s;}).join(',')).each(function() {
		var j = $(this);
		//toggle enable
		j.find('checkbox.enabled').bind('command', function() {
			var k = j.find('.control, .alt, .key');
			if (this.checked) {
				//God damn it! You can't actually input in <textbox disabled="false"> although it looks "enabled"  
				k.removeAttr('disabled');
			} else {
				k.attr('disabled', 'true');
			}
		}).trigger('command');
		
		//ensure at least one modifier is checked
		var jj = j.find('.control, .alt');
		jj.bind('command', function() {
			if (!jj.is(':checked')) jj.not(this)[0].checked = true;
		});
		
		//key
		j.find('.key').keypress(function(event) {
//			D.utils.dump(event.charCode, event.keyCode, event.isChar);
			var value = String.fromCharCode(event.charCode);
			this.value = D.Keys.isValidKey(value) ? value : '';
			return false;
		});
	});

	if(D.env.user!='rick'){
		$('#check-openintab').hide();
	}
}

function keysEnabledOnChange () {
	
}

function popupEditWin () {
	openDialog('chrome://diigotb/content/selectUrlEdit.xul', '', 'centerscreen,modal').focus();

}

function save() {
	UI2prefs();
}

function prefs2UI() {
	//context menu
	$('#check-cmPos').attr({checked: D.prefs.val('cm.insertAtTop')});
	$('#check-enableCsm').attr({checked: D.prefs.val('csm.enabled')});
	$('#check-hidenotes').attr({checked: D.prefs.val(D.env.user+'.useBlacklist')});
	$('#check-SearchResult').attr({checked: D.prefs.val('insertSEs')});
	$('#check-openintab').attr({checked: D.prefs.val('opensearchintab')});
	$('#check-showimagepanel').attr({checked: D.prefs.val('showimagepanel')});
	
	//toolbar buttons
	$('#gb-toolbarButtons checkbox').attr({checked: true});
	D.Toolbar.getItemsToHide().forEach(function(b) {
		$('#gb-toolbarButtons checkbox[diigobtn~="' + b + '"]').attr({checked: false});	
	});
	
	//toolbar mode
	var toolbar = D.$('#diigotb-toolbar');
	var mode = toolbar.attr('mode') || 'full';
	var j = $('#radio-toolbarMode');
	j[0].selectedItem = j.find('radio[value="' + mode + '"]')[0];
	
	//highlight style
	j = $('#radio-highlightStyle');
	j[0].selectedItem = j.find('radio[value="' + (D.prefs.val('hl.style') || 'a_style') + '"]')[0];
	$('#check-highlightNumbering').attr({checked: D.prefs.val('hl.showNumbering')});
	
	//bookmark
	$('#check-bmPrivateAsDefault').attr({checked: D.prefs.val('bookmark.privateByDefault')});
	
	//$('#check-enableShortcut').attr({checked: D.prefs.val('keyboardShortcut.enabled')});
	
	//quick save tag
	$('#txt-quickSaveTag').attr('value', D.prefs.val('bookmark.quickSaveTag') || '');
	$('#check-quickSaveUnread').attr('checked', !!D.prefs.val('bookmark.quickSaveUnread'));
	
	//bookmark elsewhere
//	var otherServices = D.prefs.val('bookmark.otherServices');
//	otherServices = otherServices ? otherServices.split(',') : [];
//	
//	otherServices.forEach(function(serviceId) {
//		$('#gb-bookmarkElsewhere checkbox[serviceid="' + serviceId + '"]').attr({checked: true});
//	});
	
	$('#check-elsewhere-local').attr({checked: !!D.prefs.val('bookmark.addToLocal')});
	
	//keys
	gShortcuts.forEach(function(what) {
		var j = $('#row-keys-' + what);
		var enabled = D.prefs.val('keys.' + what + '.enabled');
		var keys = D.Keys.parsePref(D.prefs.val('keys.' + what + '.keys'));
		
		j.find('checkbox.enabled').attr('checked', !!(enabled && keys));
		if (keys) {
			j.find('checkbox.control').attr('checked', keys.modifiers.indexOf('control') != -1);
			j.find('checkbox.alt').attr('checked', keys.modifiers.indexOf('alt') != -1);
			
			j.find('textbox.key').val(keys.key);
		}
	});
	
}

function UI2prefs() {
	try{
	//context menu
	D.prefs.val('cm.insertAtTop', $('#check-cmPos').is(':checked'));
	D.prefs.val('csm.enabled', $('#check-enableCsm').is(':checked'));
	D.prefs.val(D.env.user+'.useBlacklist', $('#check-hidenotes').is(':checked'));
	D.prefs.val('insertSEs',$('#check-SearchResult').is(':checked'));
	D.prefs.val('opensearchintab',$('#check-openintab').is(':checked'));
	D.prefs.val('showimagepanel',$('#check-showimagepanel').is(':checked'));
	
	//toolbar buttons
	$('#gb-toolbarButtons checkbox').each(function() {
		var ch = $(this);
		//a checkbox can control one or more items
		ch.attr('diigobtn').split(',').forEach(function(id) {
				D.prefs.val('toolbar.showItems.' + id, ch[0].checked);
		});
	});

	if(D.prefs.val('toolbar.showItems.diigotb-tb-quickAccessFilter-item')){
		D.QAF.doEnable();
	}
	
	D.Toolbar.refresh('buttons');
	
	//toolbar mode
	var toolbar = D.$('#diigotb-toolbar').attr({mode: $('#radio-toolbarMode')[0].value});
	
	//highlight style
	j = $('#radio-highlightStyle');
	D.prefs.val('hl.style', $('#radio-highlightStyle')[0].value);
	D.prefs.val('hl.showNumbering', $('#check-highlightNumbering').is(':checked'));
	
	//bookmark
	D.prefs.val('bookmark.privateByDefault', $('#check-bmPrivateAsDefault').is(':checked'));
	
	//D.prefs.val('keyboardShortcut.enabled', $('#check-enableShortcut').is(':checked'));
	
	//quick save tag
	D.prefs.val('bookmark.quickSaveTag', diigoUtil.string.strip($('#txt-quickSaveTag').val()));
	D.prefs.val('bookmark.quickSaveUnread', $('#check-quickSaveUnread').is(':checked'));
	
	//bookmark elsewhere
//	var otherServices = $('#gb-bookmarkElsewhere checkbox[serviceid]:checked')
//						.map(function() {return this.getAttribute('serviceid');})
//						.get();
//	D.prefs.val('bookmark.otherServices', otherServices.join(','));
	
	D.prefs.val('bookmark.addToLocal', $('#check-elsewhere-local').is(':checked'));
	
	//keys
	gShortcuts.forEach(function(what) {
		var key, modifiers = [];
		var j = $('#row-keys-' + what);
		
		var enabled = j.find('checkbox.enabled').is(':checked');
		
		if (j.find('checkbox.control').is(':checked'))
			modifiers.push('control');
		if (j.find('checkbox.alt').is(':checked'))
			modifiers.push('alt');
		key = j.find('textbox.key').val();
		
		//if keys are invalid, set enabled to false
		if (modifiers.length == 0 || !D.Keys.isValidKey(key)) {
			enabled = false;
		}
		
		if (enabled) {
			D.prefs.val('keys.' + what + '.keys', modifiers.join('+') + '+' + key);
		}
		
		D.prefs.val('keys.' + what + '.enabled', enabled);
	});
	}catch(e){
		throw(e);
	}
}

function beginner() {
	//context menu
	$('#check-cmPos').attr({checked: false});
	$('#check-enableCsm').attr({checked: true});
	
	//toolbar buttons
	$('#gb-toolbarButtons checkbox').attr({checked: true});
	var hiddenButtons = 'diigotb-tb-comment,diigotb-tb-message'.split(',');
	hiddenButtons.forEach(function(b) {
		$('#gb-toolbarButtons checkbox[diigobtn~="' + b + '"]').attr({checked: false});	
	});
	
	//toolbar mode
	var toolbar = D.$('#diigotb-toolbar');
	var mode = 'full';
	var j = $('#radio-toolbarMode');
	j[0].selectedItem = j.find('radio[value="' + mode + '"]')[0];
	
	//highlight style
//	j = $('#radio-highlightStyle');
//	j[0].selectedItem = j.find('radio[value="' + (D.prefs.val('hl.style') || 'a') + '"]')[0];
//	$('#check-highlightNumbering').attr({checked: D.prefs.val('hl.showNumbering')});
//	
//	//bookmark
//	$('#check-bmPrivateAsDefault').attr({checked: D.prefs.val('bookmark.privateByDefault')});
//	
//	$('#check-enableShortcut').attr({checked: D.prefs.val('keyboardShortcut.enabled')});
	
}

function advanced() {
	//context menu
	$('#check-cmPos').attr({checked: true});
	$('#check-enableCsm').attr({checked: true});
	
	//toolbar buttons
	$('#gb-toolbarButtons checkbox').attr({checked: true});
	/*var hiddenButtons = ''.split(',');
	hiddenButtons.forEach(function(b) {
		$('#gb-toolbarButtons checkbox[diigobtn~="' + b + '"]').attr({checked: false});	
	});*/
	
	//toolbar mode
	var toolbar = D.$('#diigotb-toolbar');
	var mode = 'icons';
	var j = $('#radio-toolbarMode');
	j[0].selectedItem = j.find('radio[value="' + mode + '"]')[0];
	
	//highlight style
//	j = $('#radio-highlightStyle');
//	j[0].selectedItem = j.find('radio[value="' + (D.prefs.val('hl.style') || 'a') + '"]')[0];
//	$('#check-highlightNumbering').attr({checked: D.prefs.val('hl.showNumbering')});
//	
//	//bookmark
//	$('#check-bmPrivateAsDefault').attr({checked: D.prefs.val('bookmark.privateByDefault')});
//	
//	$('#check-enableShortcut').attr({checked: D.prefs.val('keyboardShortcut.enabled')});
	
}

