/*
 * Diigo inc.
 * PDF reader and annotations
 *
 * The main file deal with diigo data and annotation action.
 *
 * Jiangbin
 * April 2014
 *
 * */

function diigoData(url,title,file_md5, data){
    this.file_md5=file_md5;
    this.file_title=title;
    this.file_content = data;
    this.user = diigoUtils.getUsername()||null;
    this.bookmark={
        annotated: false,
        groups:[],
        saved:false,
        saving:false,
        uploaded:false,
        mode:2,
        description:'',
        lists:[],
        tags:[],
        title:title,
        link_id:window.DIIGO_LINK_ID||null,
        url:url,
        server_url:'',
        shared_url : null,
        server_urlId:null
    };

    this.env={
        myTags:[],
        myGroups:[],
        permissions:{premium:false,image:true,capture:true,snapshot:true},
        myProfile: {},
        outliners:[],
        myList:[]
    };


    this.highlights=[];
    this.floatnotes=[];

    this.currentColor = 'yellow';

    this.isLocalFile = url && !url.match(/^(http|https|ftp|ftps):\/\//);
    this.loaded = false;
    var that=this;
    
    if(this.user){
        $('#diigoTools button').attr('disabled',false);
    }

    diigoNetwork.bm_loadBookmark(this,"annotations bookmarkInfo",function(res){
        that.loaded=true;
        PDFView.setTitle(that.bookmark.title);
        if(that.bookmark.saved){
            $('#bTxtTitle').val(that.bookmark.title);
            $('#bTxtDesc').val(that.bookmark.description);
            var tag_str='';
            $.each(that.bookmark.tags,function(i,v){
                if(v.indexOf(' ')!=-1){
                    tag_str +='"'+v+'"';
                }else{
                    tag_str += v;
                }
                tag_str+=" ";
            });
            $('#bTxtTags').val(tag_str);
            $('#save').addClass('saved');
            diigoAnnotationHelper.setupLinks();
            PDFView.setupDiigoAnnotationsOnRendered();
        }else{
            $('#bTxtTitle').val(document.title);
        }
    });

    if(window.DIIGO_SHARE_KEY){
        $('body').addClass('shared');
        return;
    }
    diigoNetwork.loadMyStuff("myTags  myBookmarkLists outliners myList",this,function(res){
        console.log('Load user stuff successfully.');
        $.each(that.env.outliners,function(index,list){
            list.title=list.title.replace(/</,'&lt;').replace(/>/,'&gt;');
            $( "#addToListSelector-pdf" ).append( '<option value="'+list.id+'">'+list.title+'</option>');
        });
        
        if(that.env.myList.length>0){
        	$( "#addToListSelector-pdf" ).append( '<option value="-1">----------------</option>');
        }
        
        $.each(that.env.myList,function(index,list){
            list.title=list.title.replace(/</,'&lt;').replace(/>/,'&gt;');
            $( "#addToListSelector-pdf" ).append( '<option value="'+list.id+'">'+list.title+'</option>');
        });

        $.each(that.bookmark.lists,function(index,list){
            var id=list.id;
            var option = $("#addToListSelector-pdf option[value='"+id+"']");

            option.html(option.html()+' (Added)');
        });

    });


}

var DiigoData={};


var diigoAnnotationHelper = (function diigoAnnotationHelper(){

    var diigoAnnotationHelper = {};


    diigoAnnotationHelper.getQuadRectsFromRange=function getQuadRectsFromRange(pageIndex,rg){
        var parentRc=PDFView.pages[pageIndex].canvas.getBoundingClientRect();
        var offsetX=parentRc.left, offsetY=parentRc.top;

        var p=document.createElement('p');
        p.appendChild(rg.cloneContents());
        var d_list=$(p).children('div');
        var newList=[];
        var rects=rg.getClientRects();

        if(d_list.length==0){
            return [[rects[0].left-offsetX,rects[0].top-offsetY,rects[0].left-offsetX+rects[0].width,rects[0].top-offsetY+rects[0].height]];
        }

        for(var i=0;i<d_list.length;i++){
            var div=d_list[i];
            var left=parseInt(div.style.left);
            var top=parseInt(div.style.top);
            var width=parseInt(div.getAttribute('data-canvas-width'));
            var height=parseInt($(div).css('font-size'))*1.3; //line-height:1.3
            if(i==0){
                var clientRect=rects[0];
                var startOffset=(clientRect.left-offsetX)-left;
                left=clientRect.left-offsetX;
                width=width-startOffset;
            }
            if(i!=0&&i==d_list.length-1){
                var num=rects.length-1;
//                width=width>(rects[num].right-rects[num].left)?width:(rects[num].right-rects[num].left);
                width = rects[num].right - rects[num].left;
            }
            var rect=[left,top,left+width,top+height];
            newList.push(rect);
        }
        var resultList=[];
        var count = 0;
        var rect;
        var prevRect;
        for(var i=0;i<newList.length;i++){
            count = resultList.length;
            prevRect = resultList[count-1];
            rect = newList[i];
            if(i==0){
                resultList.push(rect);
                continue;
            }
            if(Math.abs(rect[1]-prevRect[1])<5&&(rect[0]-prevRect[2])<30){
                resultList[count-1][2]=rect[2];
            }else{
                resultList.push(rect);
            }

        }
        return resultList;
    };



    diigoAnnotationHelper.removeHighlight = function removeHighlight(h_id){
        var pageIndex;
        DiigoData.highlights = $.grep(DiigoData.highlights,function(ele,index){
            if(ele.id == h_id){
                pageIndex = ele.extra.pageIndex;
            }
            return ele.id != h_id;
        });
        if(pageIndex==undefined){
            return false;
        }
        diigoNetwork.deleteHighlightAndStickyNote(h_id,DiigoData,function(resp, ct ,code){
            console.log('Delete Highlight Success. Server code: ' + code)
        });
        var page = PDFView.pages[pageIndex];
        page.drawDiigoHighlights();
    };

    diigoAnnotationHelper.removeFloatnote = function removeFloatnote(f_id){
        var pageIndex;
        DiigoData.floatnotes = $.grep(DiigoData.floatnotes,function(ele,index){
            if(ele.id == f_id){
                pageIndex = ele.extra.pageIndex;
            }
            return ele.id != f_id;
        });

        if(pageIndex==undefined){
            return false;
        }

        diigoNetwork.deleteHighlightAndStickyNote(f_id,DiigoData,function(resp,ct,code){
            console.log('Delete floatnote successfully. Server code: ' + code);
        });

        var page = PDFView.pages[pageIndex];
        page.drawDiigoFloatnotes();

    };

    diigoAnnotationHelper.updateFloatnoteContent = function updateFloatnoteContent(f_id,content){
        var pageIndex,ic_id;
        $.each(DiigoData.floatnotes,function(index,ele){
            if(ele.id == f_id){
                ele.comments[0].content =  content;
                ic_id = ele.comments[0].id;
                pageIndex = ele.extra.pageIndex;
                return false;
            }
        });

        diigoNetwork.updateComment(ic_id,content,DiigoData,function(resp,ct,code){
            console.log('Update floatnote comment successfully. Server code: ' + code);
        });

        var page = PDFView.pages[pageIndex];
        page.drawDiigoFloatnotes();

    };

    diigoAnnotationHelper.updateFloatnotePos = function updateFloatnotePos(f_id, pos){
        var ann,page;
        $.each(DiigoData.floatnotes,function(index,ele){
            if(ele.id == f_id){
                page = PDFView.pages[ele.extra.pageIndex];
                var pdf_pos = page.getPagePoint(pos.left,pos.top);
                ele.extra.left = pdf_pos[0];
                ele.extra.top = pdf_pos[1];
                ann = ele;
                return false;
            }
        });

        diigoNetwork.updateHighlightAndStickyNote(ann,DiigoData,function(resp,ct,code){
            console.log('Update floatnote position successfully. Server code: ' + code);
        });

        page.drawDiigoFloatnotes();
    };

    diigoAnnotationHelper.updateFloatnoteColor = function updateFloatnoteColor(f_id, color){
        var pageIndex;
        var ann;
        $.each(DiigoData.floatnotes,function(index,ele){
            if(ele.id == f_id){
                if(ele.extra.color == color){
                    return false;
                }
                ele.extra.color=color;
                ann = ele;
                pageIndex = ann.extra.pageIndex;
                return false;
            }
        });
        if(pageIndex==undefined){
            return false;
        }
        var page = PDFView.pages[pageIndex];
        diigoNetwork.updateHighlightAndStickyNote(ann,DiigoData,function(resp,ct,code){
            console.log('Update floatnote color successfully. Server code: ' + code);
        });
        page.drawDiigoFloatnotes();
    }

    diigoAnnotationHelper.appendHighlight = function appendHighlight(pageIndex,text,range){
        var quadRects = this.getQuadRectsFromRange(pageIndex,range);
        var diigoHighlight = {};
        diigoHighlight.id = diigoUtils.md5(''+DiigoData.bookmark.server_url+pageIndex+text+quadRects+Date.now());
        diigoHighlight.mode = 2;  //0:public 2:private
        diigoHighlight.type=9;//TEXT: 0, IMAGE: 1, FLOATNOTE: 2, FLASH: 3, VIDEO: 4, PDF_HIGH: 5
        diigoHighlight.content=text;
        diigoHighlight.extra={};
        diigoHighlight.extra.pageIndex=pageIndex;
        diigoHighlight.extra.quadRects=[];
        diigoHighlight.saved=false;
        diigoHighlight.extra.color = DiigoData.currentColor;
        var rect_left=quadRects[0][0],rect_top=quadRects[0][1],rect_right=quadRects[0][2],rect_bottom=quadRects[0][3];

        var page = PDFView.pages[pageIndex];
        for(var i=0;i<quadRects.length;i++){
            var rc=quadRects[i];
            var pdf_rect = page.getPagePoint(rc[0],rc[1]).concat(page.getPagePoint(rc[2],rc[3]));
            diigoHighlight.extra.quadRects.push(pdf_rect);
            rect_left = rc[0]<rect_left?rc[0]:rect_left;
            rect_top = rc[1]<rect_top?rc[1]:rect_top;
            rect_right = rc[2]>rect_right?rc[2]:rect_right;
            rect_bottom = rc[3]>rect_bottom?rc[3]:rect_bottom;
        }

        diigoHighlight.extra.rect = page.getPagePoint(rect_left,rect_top).concat(page.getPagePoint(rect_right,rect_bottom));

        diigoHighlight.groups=[];
        diigoHighlight.comments=[];
        DiigoData.highlights.push(diigoHighlight);
		diigoNetwork.saveHighlightAndStickyNote(diigoHighlight, DiigoData, function(resp, ct, code){
            console.log('Add highlight successfully. Server code: ' + code)
		});
        page.drawDiigoHighlights();
    };


    diigoAnnotationHelper.emptySelection = function emptySelection(){
        if (window.getSelection) {
            if (window.getSelection().empty) {  // Chrome
                window.getSelection().empty();
            } else if (window.getSelection().removeAllRanges) {  // Firefox
                window.getSelection().removeAllRanges();
            }
        } else if (document.selection) {  // IE?
            document.selection.empty();
        }
    };

    diigoAnnotationHelper.updateHighlightColor = function updateHighlightColor(h_id,color){
        var pageIndex;
        var ann;
        $.each(DiigoData.highlights,function(index,ele){
            if(ele.id == h_id){
                if(ele.extra.color == color){
                    return false;
                }
                DiigoData.highlights[index].extra.color=color;
                ann = DiigoData.highlights[index];
                pageIndex = ann.extra.pageIndex;
                return false;
            }
        });
        if(pageIndex==undefined){
            return false;
        }
        var page = PDFView.pages[pageIndex];
        diigoNetwork.updateHighlightAndStickyNote(ann,DiigoData,function(resp,ct,code){
            console.log('Update diigo highlight color successfully. Server code: ' + code);
        });
        page.drawDiigoHighlights();
    };

    diigoAnnotationHelper.addInlineComment = function addInlineComment(h_id, content){
        var pageIndex;
        var comment = {
            mode:2, //0:public, 2:private
            content:content
        };

        var update = false;
        var ic_id;
        $.each(DiigoData.highlights,function(index,ele){
            if(ele.id == h_id){
                if(ele.comments.length){
                    ele.comments[0].content = content;
                    update = true;
                    ic_id = ele.comments[0].id;
                }else{
                    ele.comments.push(comment);
                }
                pageIndex = ele.extra.pageIndex;
                return false;
            }
        });

        if(pageIndex==undefined){
            return false;
        }
        if(update){
           diigoNetwork.updateComment(ic_id,content,DiigoData, function (resp,ct,code) {
              console.log('Update inline comment successfully. Server code: ' + code);
           })
        }else{
            diigoNetwork.addComment(h_id,comment,DiigoData,function(resp,ct,code){
                console.log('Add inline comment successfully. Server code: ' + code);
            });
        }

        var page = PDFView.pages[pageIndex];
        page.drawDiigoHighlights();

    };

    diigoAnnotationHelper.deleteInlineComment = function deleteInlineComment(h_id){
        var pageIndex;
        var ic_id;
        $.each(DiigoData.highlights,function(index,ele){
           if(ele.id == h_id){
               if(ele.comments.length){
                   ic_id = ele.comments[0].id;
                   ele.comments = [];
               }
               pageIndex = ele.extra.pageIndex;
               return false;
           }
        });
        if(pageIndex==undefined){
            return false;
        }

        diigoNetwork.deleteComment(ic_id,DiigoData,function(resp,ct,code){
            console.log('Delete inline comment successfully. Server code: ' + code);
        });

        var page = PDFView.pages[pageIndex];
        page.drawDiigoHighlights();
    };

    diigoAnnotationHelper.addFloatnote = function addFloatnote(pageIndex,pos,content){
        pageIndex = parseInt(pageIndex);
        var page = PDFView.pages[pageIndex];
        var pdf_pos = page.getPagePoint(pos.left,pos.top);
        var id=diigoUtils.md5(''+DiigoData.bookmark.server_url+pageIndex+content+Date.now());
        var floatnote = {};
        floatnote.id = id;
        floatnote.type = 2; //float note type
        floatnote.content = content;
        floatnote.comments = [
            {
                content:content
            }
        ];
        floatnote.extra = {
            left:pdf_pos[0],
            top:pdf_pos[1],
            pageIndex:pageIndex,
            color:DiigoData.currentColor
        };

        DiigoData.floatnotes.push(floatnote);

        diigoNetwork.saveHighlightAndStickyNote(floatnote,DiigoData,function(resp,ct,code){
            console.log('add floatnote successfully. Server code: ' + code );
        });

        page.drawDiigoFloatnotes();
    };

    diigoAnnotationHelper.addLink = function addLink(ann){
        var pageId= ann.extra.pageIndex + 1;
        var pageContainer;
        if($("#annotationView #pageLinkContainer"+pageId).length){
            pageContainer = $("#annotationView #pageLinkContainer"+pageId);
        }else{
            var div = document.createElement('div');
            pageContainer = $(div);
            pageContainer.attr('id','pageLinkContainer'+pageId);
            pageContainer.addClass('page-item');
            pageContainer.attr('data-page-id',pageId);
            pageContainer.append('<h3>Page '+pageId +'</h3>');
            if($('#annotationView .page-item').length==0){
                $('#annotationView')[0].appendChild(div);
            }else{
                var i=0;
                $('#annotationView .page-item').each(function(){
                    if($(this).attr('data-page-id')>pageId){
                        $(this).before(pageContainer);
                        return false;
                    }
                    i++;
                });

                if(i==$('#annotationView .page-item').length){
                    $('#annotationView').append(pageContainer);
                }
            }
        }

        var color = ann.extra.color;
        var dest;
        if(ann.type == 9){
            dest = (ann.extra.pageIndex+ 1)+'#'+(ann.extra.rect[0])+"#"+(ann.extra.rect[1]);
            pageContainer.append('<a href="#" data-dest="'+dest+'" title="'+ann.content+'" class="highlight-link '+color+'">'+ann.content+'</a>');
            if(ann.comments.length){
                pageContainer.append('<a href="#" data-dest="'+dest+'" title="'+ann.comments[0].content+'" class="stickynote-link '+color+'">'+ann.comments[0].content+'</a>');
            }
        }else if(ann.type==2){
            dest = (ann.extra.pageIndex+ 1)+'#'+(ann.extra.left)+"#"+(ann.extra.top);
            pageContainer.append('<a href="#" data-dest="'+dest+'" title="'+ann.comments[0].content+'" class="floatnote-link '+color+'">'+ann.comments[0].content+'</a>');
        }else{
            //do nothing
        }
        
    };

    diigoAnnotationHelper.setupLinks = function setupLinks(){
        var that = this;
        $.each(DiigoData.highlights.concat(DiigoData.floatnotes),function(index,ele){
            that.addLink(ele);
        })
    };

    return diigoAnnotationHelper;

})();

$(document).ready(function(){
    $('body').click(function(e){
        $('.dropdown').addClass('hidden');
    });
    $('#selectPen').click(function(e){
       $('#penlist').toggleClass('hidden');
        e.stopPropagation();
    });
    $('#penlist li').click(function(e){
        e.stopPropagation();
        $(this).addClass('selected').siblings().removeClass('selected');
        var color = $(this).attr('diigocolor');
        DiigoData.currentColor = color;
        $('#add_highlight').removeClass('yellow blue green pink').addClass(color);
        $('#add_note').removeClass('yellow blue green pink').addClass(color);
        $('body').removeClass('yellow blue green pink').addClass(color);
        $(this).parent().addClass('hidden');
    });


    $('#diigolet-annMenu').hover(function(){
        $(this).addClass('hovered');
    },function(e){
        $(this).removeClass('hovered');
        if(e.relatedTarget.className!='h_menu'){
            $(this).fadeOut('fast');
        }

    });

    $('#diigolet-annMenu-currentColor').bind('click',function(){
        $('#diigolet-annMenu-colorPicker-pdf').toggleClass('hidden');
    });

    $('#diigolet-annMenu-colorPicker-pdf b.ann-colorItem').bind('click',function(){
        var h_id = $(this).parents('#diigolet-annMenu').attr('data-diigo-id');
        var new_color = $(this).attr('color');
        diigoAnnotationHelper.updateHighlightColor(h_id,new_color);
    });

    $('#diigolet-annMenu-add').bind('click',function(e){
        var annMenu = $(this).parent();
        var id=annMenu.attr('data-diigo-id');
        var color=annMenu.attr('data-diigo-color');
        var pageIndex = annMenu.attr('data-page-index');
        var left = annMenu.attr('data-pos-left');
        var top = annMenu.attr('data-pos-top');
        var note;
        note = $("#pageContainer"+pageIndex).children('div.diigoAnnotationLayer').children('div.diigo-note[data-diigo-id="'+id+'"]');
        if(note && note.length!=0){
            //do nothing
        }else{
            note = $('body>div.diigo-note').clone(true);
            note.addClass('stickynote');
            note.find('.diigo-note-header span.diigo-note-title').html('Stickynote');
            note.attr('data-origin','').attr('diigo-note-type','stickynote').attr('data-diigo-id',id).removeClass('yellow blue green pink').addClass(color).css({left: left,top: top });
            $("#pageContainer"+pageIndex).children('div.diigoAnnotationLayer').append(note);
        }
        note.addClass('new');
        note.fadeIn('fast',function(){
            $(this).find('.diigo-note-input').focus();
        });
        $(this).parent().hide();
    });

    $('#diigolet-annMenu-del').bind('click',function(e){
        e.preventDefault();
        var id = $(this).parent().attr('data-diigo-id');
        diigoAnnotationHelper.removeHighlight(id);
        $('#diigolet-annMenu').hide();
    });

    $('a.diigo-note-cancel-edit').bind('click',function(e){
        e.preventDefault();
        $(this).parents('.diigo-note').hide();
    });

    $('#add_highlight').bind('click',function(){
        $('#add_note').removeClass('toggled');
        $(this).toggleClass('toggled');
        $('body').removeClass('add_note').toggleClass('add_highlight').removeClass('yellow blue green pink').addClass(DiigoData.currentColor);
    });

    $('#add_note').bind('click',function(){
        $('#add_highlight').removeClass('toggled');
        $(this).toggleClass('toggled');
        $('body').removeClass('add_highlight').toggleClass('add_note').removeClass('yellow blue green pink').addClass(DiigoData.currentColor);
    })

    $('#viewer').on('mousedown','div.textLayer',function(){
        if(window.DIIGO_SHARE_KEY){
            return true;
        }
        if (window.getSelection) {
            if (window.getSelection().empty) {  // Chrome
                window.getSelection().empty();
            } else if (window.getSelection().removeAllRanges) {  // Firefox
                window.getSelection().removeAllRanges();
            }
        } else if (document.selection) {  // IE?
            document.selection.empty();
        }
        $('#viewer div.highlight_icon').hide();
    });


    $('#viewer').on('mouseup','div.textLayer',function(e){
        if(window.DIIGO_SHARE_KEY){
            return false;
        }
        var color = DiigoData.currentColor;
        var page = $(this).parent();
        var pageOffset = page.offset();
        var left = e.pageX - pageOffset.left;
        var top = e.pageY - pageOffset.top;
        var self = this;
        var pageIndex=parseInt(page.attr('id').match(/pageContainer(\d+)/)[1]) - 1;
        if($('body').hasClass('add_note')){
            console.log('add note');
            var note;
            note = page.children('div.diigoAnnotationLayer').children('div.diigo-note');
            if(note && note.length!=0){
                //do nothing
            }else {
                note = $('body>div.diigo-note').clone(true);
                note.addClass('floatnote');
                note.find('.diigo-note-header span.diigo-note-title').html('Floatnote');
            }
            note.find('textarea.diigo-note-input').val("");
            note.attr('data-diigo-id','').attr('data-page-index',pageIndex).attr('diigo-note-type','floatnote').removeClass('yellow blue green pink').addClass(color).css({left: left+'px',top: top+'px' });
            page.children('div.diigoAnnotationLayer').append(note);
            $('#add_note')[0].click();
            note.addClass('new');
            note.fadeIn('fast',function(){
                $(this).find('.diigo-note-input').focus();
                $(this).draggable({handle:'.diigo-note-header', containment: "parent", opacity:0.8});
            });

            return false;
        }

        var selection = window.getSelection();
        if(!selection){
            return false;
        }

        var seleText='';
        if(selection.toString && typeof selection.toString == "function"){// safari
            seleText=selection.toString();
        }else if(selection.getRangeAt && typeof selection.getRangeAt == "function"){ //firefox, chrome
            seleText=selection.getRangeAt(0).toString();
        }else{
            seleText=selection.toString();
        }

        if(!seleText || seleText.length==0) {
            return false;
        }

        if($('body').hasClass('add_highlight')){
            var rg=selection.getRangeAt(0);
            diigoAnnotationHelper.appendHighlight(pageIndex,seleText,rg);
            diigoAnnotationHelper.emptySelection();
        }else{
            if(page.children('div.highlight_icon').length){
                page.children('div.highlight_icon').css({
                    left:left-8+'px',
                    top:top-10+'px'
                }).addClass(color).show();
            }else{

                $('<div class="highlight_icon"></div>').appendTo(page).css({
                    left:left-8+'px',
                    top:top-10+'px'
                }).addClass(color).show();
            }
        }
    });

    $('#viewer').on('mousedown','div.highlight_icon',function(){
        var selection = window.getSelection();
        var seleText='';
        if(selection.toString && typeof selection.toString == "function"){// safari
            seleText=selection.toString();
        }else if(selection.getRangeAt && typeof selection.getRangeAt == "function"){ //firefox, chrome
            seleText=selection.getRangeAt(0).toString();
        }else{
            seleText=selection.toString();
        }

        if(!seleText || seleText.length==0) {
            return false;
        }

        var rg=selection.getRangeAt(0);
        var pageIndex=parseInt($(this).parent().attr('id').match(/pageContainer(\d+)/)[1]) - 1;

        diigoAnnotationHelper.appendHighlight(pageIndex,seleText,rg);
        diigoAnnotationHelper.emptySelection();
        $(this).hide();
    });

    $('.diigo-note').hover(function(){
        $(this).addClass('hovered');
    },function(e){
        $(this).removeClass('hovered');
        if($(e.relatedTarget).hasClass('div_floatnote')){
            return false;
        }
        if($(this).attr('data-origin') && $(this).attr('data-origin') != $(this).find('.diigo-note-input').val()){
            //do nothing
        }else{
            var self = this;
            window.setTimeout(function(){
                var textarea = $(self).find(".diigo-note-input");
                if(textarea.is(":focus")){
                    // do nothing
                }else{
                    if(!$(self).hasClass('hovered')){
                        $(self).find('.diigo-note-colorPicker').addClass('hidden');
                        $(self).hide();
                    }
                }
            },300)
        }
    });

    $('.diigo-note-save').bind('click',function(e){
        e.preventDefault();
        var note = $(this).parents('.diigo-note');
        var type = note.attr('diigo-note-type');
        var id = note.attr('data-diigo-id');
        var content = note.find('.diigo-note-input').first().val();
        if(type=='stickynote'){
            diigoAnnotationHelper.addInlineComment(id,content);
        }
        else{
            if(id){
                diigoAnnotationHelper.updateFloatnoteContent(id,content);
            }else{
                var top = note.css('top');
                var left = note.css('left');
                var pageIndex = note.attr('data-page-index');
                diigoAnnotationHelper.addFloatnote(pageIndex,{left:parseInt(left),top:parseInt(top)},content);
            }
        }
    });

    $('.diigo-note-delete').bind('click',function(e){
        e.preventDefault();
        var note = $(this).parents('.diigo-note');
        var type = note.attr('diigo-note-type');
        var id = note.attr('data-diigo-id');
        if(type=='stickynote'){
            diigoAnnotationHelper.deleteInlineComment(id);
        }else{
            diigoAnnotationHelper.removeFloatnote(id);
            note.fadeOut('fast');
        }
    });

    $('.diigo-note-currentColor').bind('click',function(e){
        e.stopPropagation();
        $(this).siblings('.diigo-note-colorPicker').toggleClass('hidden');
    });

    $('.dlg-colorItem').bind('click',function(e){
        e.stopPropagation();
        var note = $(this).parents('.diigo-note');
        var id = note.attr('data-diigo-id');
        var type = note.attr('diigo-note-type');
        var color = $(this).attr('color');
        if(id){
            if(type=='stickynote'){
               diigoAnnotationHelper.updateHighlightColor(id,color);
            }else{
                diigoAnnotationHelper.updateFloatnoteColor(id,color);
            }
        }else{

        }
    });

    $('#annotationView').on('click','a',function(e){
        e.preventDefault();
        var dest = $(this).attr('data-dest');
        dest = dest.split('#');
        dest = [
            parseInt(dest[0])-1,
            {name:'XYZ'},
            null,
            parseInt(dest[2])+5,
            null
        ];
        PDFView.navigateTo(dest);
    })

    $('#edit_window').draggable({handle:'.edit_header', containment: "parent", opacity:0.95});
    $('#share-window').draggable({handle:'.edit_header', opacity:0.95});
    $('#save').click(function(e){
        $("#edit_window").toggleClass('hidden');
    });

    $('#wCloseLink,#cancel_save').click(function(e){
        e.preventDefault();
        $('#edit_window').addClass('hidden');
    });
    $('#shareCloseLink').click(function(e){
        e.preventDefault();
        $('#share-window').addClass('hidden');
    });

    $('#save_pdf').click(function(){
        var title = $('#bTxtTitle').val();
        var description = $('#bTxtDesc').val();
        var tags = $.trim($('#bTxtTags').val());
        var link_id = DiigoData.bookmark.link_id;

        var list = $('#addToListSelector-pdf').find(":selected").val();
        var params={link_id:link_id,title:title,description:description,tags:tags,lists:list};

        if(!DiigoData.bookmark.saved){
            $('#save_pdf').html('Saving..');
            $('#save_pdf').attr('disabled',true);
            diigoNetwork.pdfCreateItem(params,DiigoData,function(){
                console.log('Create pdf item successfully'); 
                $('#save').addClass('saved');
                $('#save_pdf').html('Saved');
                $('#save_pdf').attr('disabled',false);
                window.setTimeout(function(){
                    $('#edit_window').addClass('hidden');
                    $('#save_pdf').html('Save');
                },1000);
            });
            return false;
        }
        
        $.ajax({
            type: "post",
            url: window.DIIGO_REQUEST_SERVER+"/item/save/pdf",
            data: $.param(params),
            beforeSend: function(XMLHttpRequest){
                $('#save_pdf').html('Saving..');
                $('#save_pdf').attr('disabled',true);
            },
            success: function(data, textStatus){
                $('#save_pdf').html('Saved');
                $('#save_pdf').attr('disabled',false);
                window.setTimeout(function(){
                    $('#edit_window').addClass('hidden');
                    $('#save_pdf').html('Save');
                },1000);
            },
            complete: function(XMLHttpRequest, textStatus){
                //HideLoading();
            },
            error: function(){
                //请求出错处理
            }
        });

    });

    $('#open-with-default').bind('click',function(){
        window.open(window.DIIGO_PDF_URL,'_blank');
    });

    $('#logo').bind('click',function(){

        window.open(window.DIIGO_REQUEST_SERVER,'_blank');
    });

    var tt;
	$('#screenshot').bind('click',function(e){
        /*if(tt){
            clearTimeout(tt);
        }
        e.stopPropagation();
        if($('div#diigo-chrome-installed').length>0){
            //do nothing
        }else{
            if(window.navigator.userAgent.match(/firefox/i)){
                $('#popup-message').html('Get <a href="https://www.diigo.com/tools/toolbar?client=ff">diigo firefox toolbar</a> to take capture.').removeClass('hidden'); 
            }else{
                $("#popup-message").html('Get <a onclick="installExt(event);" href="https://chrome.google.com/webstore/detail/diigo-web-collector-captu/oojbgadfejifecebmdnhhkbhdjaphole">diigo chrome extension</a> to take capture.').removeClass('hidden');
            }
            tt = window.setTimeout(function(){
                $("#popup-message").addClass('hidden');
            },5000);
        }*/
    });

    $('#share').bind('click',function(){
       if(DiigoData.bookmark.saved){
           $('#share-window').removeClass('hidden');
           if(DiigoData.bookmark.shared_url){
               $('#share-link').val(DiigoData.bookmark.shared_url);
               $('#share-link').focus();
               $('#share-link').select();
               return false;
           }
           $.ajax({
               type: "get",
               url: window.DIIGO_REQUEST_SERVER+"/item/get_share_url",
               data: $.param({
                   link_id:DiigoData.bookmark.link_id
               }),
               dataType:'json',
               beforeSend: function(XMLHttpRequest){
                   $('#share-link').val('loading..');
               },
               success: function(data, textStatus){
                   DiigoData.bookmark.shared_url = data.shared_url;
                   $('#share-link').val(data.shared_url);
                   $('#share-link').focus();
                   $('#share-link').select();
               },
               complete: function(XMLHttpRequest, textStatus){
                   //HideLoading();
               },
               error: function(){
                   //请求出错处理
               }
           });
       } else{

       }
    });

    $('#share-link').bind('click',function(){
        $(this).select();
    });
    
    $('#share-chooser a').bind('click',function(e){
        e.preventDefault();
        var share_type = $(this).attr('data-share-type');
        share(share_type);
    });
});

function share(share_way){
    var share_link = DiigoData.bookmark.shared_url;
    var share_text = DiigoData.bookmark.title;
    var to_url = '';
    if (share_way == 'twitter') {
        var twitter_share = 'https://twitter.com/share'
            to_url = twitter_share + "?url=" + encodeURIComponent(share_link) + '&text=' + encodeURIComponent(share_text)
    } else if (share_way == 'facebook') {
        var facebook_share = 'http://www.facebook.com/sharer.php'
            to_url = facebook_share + "?src=bm&u=" + encodeURIComponent(share_link) + '&t=' + encodeURIComponent(share_text)
    }else{
        to_url = "mailto:?subject=Check this pdf&body="+ encodeURIComponent(share_text) +"%0A"+encodeURIComponent(share_link)  ;
    }


    window.open(to_url,'','left=300,top=100,width=500,height=500,toolbar=0,resizable=0,menubar=0,location=0,status=0,scrollbars=yes')       

}

