/*-------------------------------------------------
 * Auto Complete Contacts, alias piku
 * Copyright (c) 2007 A.D. & Diigo System.
 *------------------------------------------------*/
var ACContact = diigoUtil.Class.create({
    initialize: function(options) {
        if(options.maxRec){
            this.maxRec = options.maxRec;
            this.maxRecTipTemp = "MAX Recipients "+this.maxRec;
        }
        this.scanType = options.scanType || 'all';
        this.maxHeight = options.maxHeight || 200;
        this.width = options.width || 414;
        this.recItemsId = [];
        this.tipTemp = "Start typing a friend's name or email address.";
        this.recBox = J(options.rec);
        this.recBox.css({font:"12px verdana", padding:"0 0 2px 2px", width:this.width+"px"});
        if(!this.recInput) {
            this.recInput = J("<input class='recInput' maxlength=255/>");//new Element("input", {className:"recInput", maxlength:255});
            this.recBox.append(this.recInput);
            this.recInputSizer = J("<div class='recInputSizer'/>");//new Element("div", {className:"recInputSizer"});
            this.recBox.append(this.recInputSizer);
            var cl = J("<div />");
            cl.css({clear:"both"});
            this.recBox.append(cl);
        }
        
        if(!ACContact.contacts){ACContact.contacts = options.contacts;}
        if(!ACContact.contactLists) {
            ACContact.contactListsID = [];
            for(var i=0; i<ACContact.contacts.length; i++) {
                if(ACContact.contacts[i].type=="list"){ACContact.contactListsID.push(i)}
            }
        }
        if(!this.tip) {
            this.tip = J("<div />");
            this.tip.css({width:this.recBox.width()-2+"px"});
            this.recBox.parent().append(this.tip);
            this.tip.hide();
        }
        
        if(!this.contactList) {
            this.contactList = J("<div class='accList'/>");//new Element("div", {className:"accList"}).hide();
            this.contactList.css({width:this.recBox.width()-2+"px"});
            this.contactListInner = J("<div />");//new Element("div").setStyle({position:"relative", overflow:"auto", padding:"2px"});
            this.contactListInner.css({position:"relative", overflow:"auto", padding:"2px"});
            this.contactList.append(this.contactListInner);
            this.recBox.parent().append(this.contactList);        
            this.contactList.hide();
        }
        var z=this;
        
        this.recBox.click(function() {
            z.recInput.css({visibility:"visible"});
            z.recInput.trigger("focus");
        });
        
        this.recBox.reset = function() {
            z.recInput.trigger("blur");
            z.recBox.find(".recItem").each(function(t){t.remove();});
            z.recItemsId.clear();
        };
        
        this.recInput.focus(function() {
            z.showTip();
            z.recInput.reset();
            z.currentItem = -1;
        });
        
        this.recInput.reset = function() {
            z.recInput.val("");
            var width = ACContact.getTextSize(z.recInput.val(), z.recInputSizer);
            z.recInput.css({width: width + 30 + "px", visibility:"visible"});    
        };
        
        this.recInput.blur(function() {
            z.wrapItem();
            z.hideTip();
            z.recInput.css({visibility:"hidden"});
            setTimeout(function(){z.hideContacts();}, 300);
        });
        
        this.recInput.keydown(function(e) {
            var keycode;
            if(window.event) {keycode = window.event.keyCode;}
            else if(e){keycode = e.which;}
            switch(keycode) {
                case 9:
                case 40:{z.hoverItem(z.currentItem+1);return false;             
                }break;
                case 38:{z.hoverItem(z.currentItem-1);return false;      
                }break;
                case 8:{
                    if(z.recInput.val()=="" && z.recInput.prev()) {
                        var cIndex = z.recInput.prev().attr("cIndex");
                        J("#recItemRemove_"+cIndex).trigger("click");
                    } 
                }break;
                case 13:{z.wrapItem();z.recInput.reset();z.hideContacts();z.showTip();return false;}break;
				// space
				case 32:{
					//if (this.recInput.value.indexOf("@") != -1) {
						z.wrapItem();
						z.recInput.reset();
						z.hideContacts();
						z.showTip();
						return false;
					//}
					}break;
            }
            var width = ACContact.getTextSize(z.recInput.val(), z.recInputSizer);
            if(width > z.recBox.width()-50){width=z.recBox.width()-50;}
            z.recInput.css({width: width + 30 + "px"});
        });
        
        this.recInput.keyup(function(e) {
            var keycode;
            if(window.event) {keycode = window.event.keyCode;}
            else if(e){keycode = e.which;}
            if((keycode<=105 && keycode>=48) || keycode==8){z.scanContacts();}
        });
    },
    showNotice: function() {        
        this.tip.attr({'class':"accNotice"});
        this.tip.html(this.maxRecTipTemp);
        this.tip.css({width:this.recBox.width()-2+"px"});
        this.tip.show();
    },
    showTip: function() {
        this.tip.attr({'class':"accTip"});// = "accTip";
        this.tip.html(this.tipTemp);
        this.tip.css({width:this.recBox.width()-2+"px"});
        this.tip.show();
    },
    hideTip: function() {
        this.tip.hide();
    },
    scanContacts: function(){
        this.match = [];
        var keyword = this.recInput.val().replace(/\s+/g, "&");
        if(keyword.length<=0){this.hideContacts();return false;}
        var p = new RegExp("&"+keyword,"i");
        for(var i=0; i<ACContact.contacts.length; i++) {
            var summary = ""
            var c = ACContact.contacts[i];
            if(this.scanType!='all' && this.scanType!=c.type){continue;}
            switch(c.type){
                case "list":{
                    summary = "&"+c.extra.title.replace(/\s+/, "&") + "&" + c.extra.note;
                }break;
                case "friend":{
                    summary = "&"+c.extra.real_name.replace(/\s+/, "&") + "&" + c.id;                    
                }break;
                case "user":{
                    summary = "&"+c.id.replace(/\s+/, "&") + "&" + c.extra.email;
                }break;
                case "email":{
                    summary = "&"+c.id;
                }break;
            }
            if(p.test(summary)) {
                this.match.push(i)
            }
        }
        if(this.match.length>0){
            this.showContacts();
        }else {
            this.hideContacts();
        }
    },
    showContacts: function() {
        var keyword = this.recInput.val();
        this.contactListInner.html("");
        this.contactListInner.css({height:"auto", width:this.recBox.width()-6+"px"});
        var z=this;
        for(var i=0; i<this.match.length; i++) {
           var cIndex = this.match[i];
           var c = ACContact.contacts[cIndex];
           var item = J('<div id=cI_'+i+' class="cItem"/>');//new Element("div", {id:"cI_"+i, className:"cItem"});
           switch(c.type){
                case "list":{
                    item.html("<b><i>list</i>"+this.h(c.extra.title)+"</b>"+c.extra.note);
                }break;
                case "friend":{
                    str = "<b>"+this.h(c.extra.real_name)+"</b><span class='extraDesc'>(";
                    if(c.id){
                        str += this.h(c.id)+' on Diigo';
                    }
                    if(c.extra.location){
                        str += ", "+c.extra.location;
                    }
                    if(c.extra.sex){
                        str +=" "+c.extra.sex;
                    }
					str += ")</span>"
                    item.html(str);
                }break;
                case "user":{
                    item.html("<b>"+this.h(c.extra.email)+"</b>");
                }break;
                case "email":{
                    item.html("<b>"+this.h(c.id)+"</b>");
                }break;
           }
           item.attr("cIndex", cIndex);
           item.bind("mouseover",{index:i},function(e) {
                z.hoverItem(e.data.index);
           });
           item.bind("mouseout",{index:i},function(e) {
                z.outItem(e.data.index)
           });
           item.click(function() {
                z.wrapItem();
           })
           this.contactListInner.append(item);
        }
        this.contactList.show();
        if(this.contactListInner.height() > this.maxHeight) {
           this.contactListInner.css({height:this.maxHeight+"px"});
        }
        this.hoverItem(0);
    },
    hideContacts: function() {
        this.contactList.hide();
        this.currentItem = -1;
    },
    h: function(text) {
        if(text.length<=0){return "";}
        var keyword = this.recInput.val();
        //return text.replace(eval("/"+keyword+"/i"), "<span class='keywordStrong'>"+keyword+"</span>");
        return text.replace(keyword, "<span class='keywordStrong'>"+keyword+"</span>");
    },
    hoverItem: function(i) {
        if(this.currentItem>=0){this.outItem(this.currentItem)}
        if(i>this.match.length-1){
            this.currentItem = this.match.length-1;
        }else if(i<-1){
            this.currentItem = -1
        }else {
            this.currentItem = i; 
        }
        var item = J("#cI_"+this.currentItem);
        if(item[0]){
            item[0].className += " hover";
            if(this.currentItem==0){this.contactListInner[0].scrollTop=0;return false;}
            if(this.currentItem==this.match.length-1){this.contactListInner[0].scrollTop=2000;return false;}
            var viewTop = this.contactListInner[0].scrollTop;
            var viewBottom = viewTop+this.contactListInner.height();
            var top = item.offset().top;
            var bottom = top+item.height();
            if(top < viewTop){
                  this.contactListInner[0].scrollTop -=  (viewTop-top);
            }else if(bottom>viewBottom){
                  this.contactListInner[0].scrollTop +=  (bottom-viewBottom);
            }else {}
        }
    },
    outItem: function(i) {
        if(this.currentItem>=0){
           var cItem = J("#cI_"+this.currentItem);
           if(cItem[0]){cItem[0].className = cItem[0].className.replace(/\s?hover/gi, "");}           
        }
        this.currentItem = -1;
        var item = J("#cI_"+i);
        if(item[0]){item[0].className = item[0].className.replace(/\s?hover/gi, "");}
    },
    wrapItem: function(cIndex) {
        if(typeof(cIndex)=="undefined") {
            var keyword = this.recInput.val();
           if(keyword.length<=0){this.currentItem=-1;return false;}    
           if(this.currentItem==-1) {
                emailR =  /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
                if(emailR.test(keyword)) {
                    ACContact.contacts.push({'type':'email', 'id':keyword});
                    cIndex = ACContact.contacts.length-1;
                }else {
                    ACContact.contacts.push({'type':'friend', 'id':keyword, 'extra':{'real_name':keyword}});
                    cIndex = ACContact.contacts.length-1;
                }
            }else {
                cIndex = J("#cI_"+this.currentItem).attr("cIndex");
            }
        }

        var c = ACContact.contacts[cIndex];
        if(this.recItemsId.indexOf(cIndex)!=-1){
            this.hideContacts();
            this.recBox.trigger("click");
            return false;
        }
        if(this.maxRec && this.recItemsId.length>this.maxRec){
            this.hideContacts();
            this.showNotice();
            return false;            
        }
        //alert(cIndex+" : "+c);        
        var itemContent = "";
        if(c){
	        switch(c.type){
	            case "list":{
	                itemContent = "<i>list</i>"+c.extra.title;
	            }break;
	            case "friend":{
	                itemContent = c.extra.real_name;
	            }break;
	            case "user":{
	                itemContent = c.extra.email;
	            }break;
	            case "email":{
	                itemContent = c.id;
	            }break;
	        }
        }
        var recItem = J('<span class="recItem" id="recItem_'+cIndex+'"></span>').html(itemContent);//new Element("span", {className: "recItem", id:"recItem_"+cIndex}).html(itemContent);
        var recItemRemove = J('<a class="recItemRemove" href="javascript:void(0);" id="recItemRemove_'+cIndex+'"></a>').html('x');// new Element("a", {className:"recItemRemove", id:"recItemRemove_"+cIndex, href:"javascript:void(0);"}).html("x");
        recItem.append(recItemRemove);
        recItem.attr("cIndex", cIndex);
        //var temp = J('<div />');//new Element("div");
        //temp.append(recItem);
        recItem.insertBefore(this.recInput);
        //new Insertion.Before(this.recInput, temp.innerHTML);
        var z=this;
        J("#recItemRemove_"+cIndex).bind('click',{index:cIndex},function(e) {
        	var idex=e.data.index;
            z.removeRecItem(idex);
        });
        this.recBox.trigger("click");
        this.recItemsId.push(cIndex);
    },
    removeRecItem: function(cIndex) {
        var recItem = J("#recItem_"+cIndex);
        recItem.remove();
        this.recItemsId = this.recItemsId.slice(cIndex,1);
        this.recBox.trigger("click");
    },
    getRecItems: function() {
        if(!this.recItemsId || this.recItemsId.length==0){
            return null;
        }else {
            var recFriends = [];
            var recEmails = [];
            var recLists = [];
            for(var i=0; i<this.recItemsId.length; i++) {
                var c = ACContact.contacts[this.recItemsId[i]];
                switch(c.type){
                case "friend":{recFriends.push(c.id)}break;
                case "list":{recLists.push(c.id)}break;
                case "user":{recEmails.push(c.extra.email)}break;
                case "email":{recEmails.push(c.id)}break;
                }
            }
            return {'friends':recFriends, 'emails':recEmails, 'lists':recLists};
        }
    },
    setDefault: function(cIndex) {
        this.wrapItem(cIndex);
    },
    getRecOriItems: function() {
        if(!this.recItemsId || this.recItemsId.length==0){
            return null;
        }else {
            var recItems = [];
            for(var i=0; i<this.recItemsId.length; i++) {
                recItems.push(ACContact.contacts[this.recItemsId[i]]);
            }
            return recItems;
        }
    }
});
ACContact.getTextSize = function(text, el){
    el.innerHTML = text.replace(/ /g, '&nbsp;');//escapeHTML
    return (el.offsetWidth > 500 ? 500 : el.offsetWidth);
}