
var J = jQuery.noConflict();
var mainWindow = window.opener || diigoUtil.firefox.getMainWindow();
var D = mainWindow.diigo;
var context = D.getCurrentContext();
var AnnotationFormatter = D.AnnotationFormatter;

var gAnnotatedUrl = '';
var iAddtoEasyBlog = false;


function toggleEasyBlog(v) {
	iAddtoEasyBlog = v == undefined ? !iAddtoEasyBlog : v;
	J('#check-EasyBlog')[0].checked = iAddtoEasyBlog;
}

function openSendHelp() {
	try{
    var w = mainWindow.open(D.urls.getEasyBlogHelpURL(), null, "width=600,height=400, left=100, top=100, status=1,scrollbars=1,resizable=0");
	}catch(e){}
}

//open the web page with rich text editing
function openForwardWindow() {
	var url = D.urls.getForwardURL();
	
	var paramUrl;
	if(context){
		var bm = context.bookmark;
		paramUrl = bm.url;
	}else{
		paramUrl="";
	}
	var sendType = J('#select-recipient-type').val(), sendTo = null;
	if (sendType == 'some') {
		sendTo = window.piku.getRecItems() || {};
	} 
	
	// see dmail_controller#draft_link_forward
	var json = {
		send_type: sendType,
		send_to: sendTo,
		privacy: window.iAddtoEasyBlog ? 'public' : 'private',
		subject: diigoUtil.string.strip(J("#inputSubject").val()),
		body: diigoUtil.string.stripTags(J('#txt-msgBody').val()),
		include_quotes: J('#check-includeAnnotations').is(':checked') ? 'yes' : 'no'
	};
	
	//server side now uses url instead of url_id
	var params = {
		url: paramUrl,
		json: diigoUtil.json.toJSON(json)
	};
	
	D.utils.firefox.post(url, null, diigoUtil.string.toQueryString(params), false, false);
	this.close();
}

//annotations preview
function preview() {
	var includeAnnotations = J('#check-includeAnnotations').is(':checked');
	
	document.getElementById('iframe-preview').contentDocument.body.innerHTML = includeAnnotations ? composeMessage() : '';
	
	if (includeAnnotations&&context) {
		//use annotated link only if there are annotations
		if (context.pageComments.length > 0 || context.annotations.length > 0) {
			D.AnnotatedLink.get(context.bookmark.url, 3, function(annotatedUrl) {
				gAnnotatedUrl = annotatedUrl;
				updateURL(gAnnotatedUrl);
			}, context);
		} else {
			updateURL(context.bookmark.url);
		}
		
	}
	
}

function trySend() {
	function notifyError(msg) {
		J('#noticer').text(msg).show();
	}
	
	var subject = diigoUtil.string.strip(J("#inputSubject").val());
	
	if (!subject) {
		notifyError(D.strings.getString('message.input.subject'));
		return false;	
	}
	
	var data = {
		toAllFriends: false,
		
		toUsers: [],
		toEmails: [],
		toLists: [],
		mode: window.iAddtoEasyBlog ? 0 : 2,
		subject: subject,
		body: composeMessage(diigoUtil.string.stripTags(J('#txt-msgBody').val()))
	};
	
	//append bookmarkUrl only when we are sharing a bookmark
	if (J('#check-includeAnnotations').is(':checked')&&context)
		data.bookmarkUrl = context.bookmark.url;
	
	var val = J('#select-recipient-type').val();
	if (val == 'all') {
		data.toAllFriends = true;
	} else if (val == 'some') {
		var items = window.piku.getRecItems();
		if (!items) {
			notifyError(D.strings.getString('message.input.recipient'));
			return false;	
		}
		
		data.toUsers = items.friends;
		data.toEmails = items.emails;
		data.toLists = items.lists;
	} else if (val == 'noone') {
		
	} else{
		data.toLists = [Number(val)];
	}
	
	D.WebAPI.shareBookmark(data);
	D.prefs.val('send.private', !iAddtoEasyBlog);
	return true;
}
//
function getMessageBody() {
//	return tinyMCE.getContent('txt-msgBody');
	return J('#txt-msgBody').val();
}

function composeMessage(inputMsg) {
	var body = '';
	if (inputMsg) {
		body += '<p>' + inputMsg + '</p>';
	}
	if (!J('#check-includeAnnotations').is(':checked')||!context) return body;
	
	var url = (context.pageComments.length > 0 || context.annotations.length > 0) ? (gAnnotatedUrl || 'DIIGO_PERMALINK') : context.bookmark.url;
	
	var titleLink = diigoUtil.string.showTpl('<p><a id="link-annotatedLink" href="#{1}" title="#{0}">#{0}</a></p>', [context.bookmark.getTitle(), url]);
	
	body += '<p><strong>Quotes:</strong></p><blockquote style="border-left: 2px solid #eee; padding-left: 1em; margin-left: 1em;">' + 
	titleLink + //'<p>' + context.bookmark.description + '</p>' + 
	AnnotationFormatter.format(context, {mode: 1, includePageComments: true}) + 
	'</blockquote>';
	
	//footer will be appended by server
//	var footer = '<p>- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</p>' + 
//		diigoUtil.string.showTpl('<p>See my bookmarks at <a href="#{0}">#{0}</a></p>', [D.urls.getUserBookmarksPageURL()]) +
//		diigoUtil.string.showTpl('<p>See my profile at <a href="#{0}">#{0}</a></p>', [D.urls.getUserProfileURL()]) +
//		'<p style="padding: 2em 0pt 1em;">' + (D.env.myProfile.signature || '') + '</p>'
//
//	body += footer;
	return body;
}

//handles the "Send to" selection change
function recipientTypeOnChange() {
	var j = J('#select-recipient-type');
	var val = j.val();
	if (val == 'some') {
		J('#forwardTo').show();
		window.piku.recInput.trigger("focus");
	} else {
		J('#forwardTo').hide();
	}
	
	WindowResizer.sizeWindowToContent();
}

//fill piku with data
function initAutocompleteContacts() {
	var contacts = D.env.myContacts;
	//piku
    window.piku = new ACContact({
    	rec:"#forwardTo", 
    	contacts:contacts, 
    	maxRec:20, 
    	width: 503,
    	maxHeight: 180
    });
    
    //if a friend has been chosen as default recipient
    //sidebar friends tab > send message
    var defaultRecipient = window.arguments[0];
	//now lets find the index of the damned item
	var i = diigoUtil.array.findIndex(contacts, function(v) {
		return v.type == 'friend' && v.id == defaultRecipient;
	});
	
	if (i > -1) {
		window.piku.setDefault(i);
	}
	
  //add lists to recipient type select
  var j = J('#select-recipient-type optgroup');
  j.append(
  	contacts
  	.filter(function(v) {return v.type == 'list';})
  	.map(function(v) {return diigoUtil.dom.buildOne('option', {value: v.id}, [v.extra.title]);})
  );
}

//update url in message body
function updateURL(url) {
	D.utils.dump('[Share] updating annotated link', url);
	var doc = document.getElementById("iframe-preview").contentDocument;
	var p = doc.getElementById('link-annotatedLink');
	p.setAttribute('href', url);
}

J(window).load(function() {
//	J(window).bind('resize', function() {
//		WindowResizer.sizeContentToWindow();
//	});
	
	WindowResizer.start();
	
	if(context&&context.bookmark){
		J("#inputSubject").val(/*'Bookmark from ' + D.env.myProfile.realName + ': ' + */context.bookmark.getTitle());
	}
	
	J('#check-includeAnnotations')
//	.attr('checked', !!D.prefs.val('share.includeAnnotations'))
	.change(function() {
		var checked = J(this).is(':checked');
		D.utils.dump(checked, J(this)[0].checked);

		//2007-12-02 06:07:01 UTC we don't need remember this, do we?
		//just check it by default
		//D.prefs.val('share.includeAnnotations', checked);
		if (checked){
			preview();
			J('#txt-msgBody').css({height: "115px"});
			J('#iframe-preview').show();
		} else {
			J('#txt-msgBody').css({height: "285px"});
			J('#iframe-preview').hide();
		}
	}).change();
	if(!context){
		J('#check-includeAnnotations').removeAttr('checked').change();
	}
		
	//privacy mode and star
	iAddtoEasyBlog = !D.prefs.val('send.private');
	toggleEasyBlog(iAddtoEasyBlog);
	initAutocompleteContacts();
	
	//Post a Note...
	if (window.arguments[1]) {
		J('#select-recipient-type').val('noone');
		//leave subject and message body blank
		J("#inputSubject").val('');
		var j = J('#check-includeAnnotations');
		j[0].checked = false;
		j.trigger('change');
	}
	if(window.arguments[2]){
		J('#txt-msgBody').val(window.arguments[2]);
	}
	
	recipientTypeOnChange();
	
	ChromeTooltip.run();
});

/**
 * Size window to content
 */
var WindowResizer = {
	timerId: null,
	bodyHeight: 0,
	windowHeight: 0,
	
	start: function() {
		var z = this;
		clearInterval(z.timerId);
		
		z.timerId = setInterval(function() {z.sizeWindowToContent();}, 100);
	},
	
	sizeWindowToContent: function() {
		var z = this;
		
		var newHeight = document.body.clientHeight;
		if (z.bodyHeight != newHeight) {
			window.innerHeight = (z.bodyHeight = newHeight) + 1;
		}
	},
	
//	sizeContentToWindow: function () {
//		var z = this;
//		
//		var newWinHeight = window.innerHeight;
//		if (WindowResizer.windowHeight != newWinHeight) {
//			WindowResizer.windowHeight = newWinHeight;
//			
//			WindowResizer.stop(function() {
//				var delta = window.innerHeight - document.body.clientHeight;
//				var ele = document.getElementById('heightPillar');
//				var style = window.getComputedStyle(ele, null);
//				ele.style.height = parseInt(style.height) + delta + 'px';
//				
//				editor = document.getElementById("txt-msgBody");
//				
//				editor.style.width = parseInt(style.width) + 'px';
//				editor.style.height = parseInt(style.height) + 'px';
//			});
//		}
//	},
	
	stop: function(func) {
		clearInterval(this.timerId);
		
		if (func) {
			func();
			this.start();
		}
	}
};
