/**
 * Less generic, more contrived utils
 */
 
var diigoUtil;


(function() {
	
var Utils = diigoUtil;

Utils.extend(Utils, {
	/**
	 * Returns html code for displaying e.g. page comment, bookmark description
	 * 1. new lines -> <br/>
	 * 2. auto link urls
	 * 
	 */
	content2Html: function(content) {
		return Utils.autoLink.link(Utils.string.stripScripts(content)).replace(/[\r\n]+/g, '<br/>');
	}
});

//https://www.squarefree.com/userscripts/autolink.user.js
//Helper functions for filters
function digits(s)
{
  return s.replace(/[^0-9]/g, "");
}

function alphanumerics(s)
{
  return s.replace(/[^0-9a-z]/ig, "");
}
Utils.autoLink = {
	filters: [
//	{
//    name: "Plain text link1",
//    regexp: /(\s|^)(www\.[^"\s\<\>]*[^.,;'">\:\s\<\>\)\]\!])/gi,
//    href: function(match) { 
//    	return 'http://' + match[2]; 
//    }
//  },
  {
    name: "Plain text link",
    regexp: /https?\:\/\/[^"\s\<\>]*[^.,;'">\:\s\<\>\)\]\!]/gi,
    href: function(match) { return match[0]; }
  },
  {
    name: "Email address",
    regexp: /[a-z0-9_\-+=.]+@[a-z0-9\-]+(\.[a-z0-9-]+)+/ig,
    href: function(match) { return "mailto:" + match[0]; }
  }
//	,
//  {
//    name: "Bug number with comment number",
//    regexp: /bug \#?(\d+) comment \#?(\d+)/ig,
//    href: function(match) { return "https://bugzilla.mozilla.org/show_bug.cgi?id=" + match[1] + "#c" + match[2]; }
//  },
//  {
//    name: "Bug number",
//    regexp: /bug \#?(\d+)/ig,
//    href: function(match) { return "https://bugzilla.mozilla.org/show_bug.cgi?id=" + match[1]; }
//  },
//  {
//    name: "ISBN --> Amazon",
//    regexp: /ISBN( number)?:? \#?((\d(-)?){9}[\dx])/ig,
//    href: function(match) { return "http://www.amazon.com/exec/obidos/ASIN/" + alphanumerics(match[2]); }
//  },
//  {
//    name: "US phone number --> Skype",
//    regexp: /((\(\d{3}\)[\s-]?)|(\d{3}(\s|-)))\d{3}[\s-]\d{4}/g,
//    href: function(match) { return "callto:+1 " + digits(match[0]); }
//  }
	],
	
	link: function(t) {
		var filter, i, r, m, replacement;
		
		for (i = 0; i < this.filters.length; i++) {
			filter = this.filters[i]
			r = filter.regexp;
			r.lastIndex = 0;
			
			while (m = r.exec(t)) {
				replacement = '<a class="link" href="' + filter.href(m) + '">' + m[0] + '</a>';
				t = t.replace(m[0], replacement);
				r.lastIndex += replacement.length - m[0].length;
			}
		}
		return t;
	}
};

})();
